<h2><i class='fa fa-book'></i> Variations dans les Produits</h2>

<p>Les produits sur amazon peuvent comporter différentes variantes, telles que différentes tailles, couleurs, etc. Imaginez pour un instant que vous devez visiter le site web Amazon.fr et acheter un t-shirt pour votre meilleur ami. Si la fiche (ou l'annonce du vendeur) n'est pas pour un item unique comme une machine à gomme-balounne datée de 1964 qu'il vend un peu comme plusieurs items sur Ebay, il a probablement accès à un inventaire qui est automatisé sur Amazon. Il peut donc ajouter à sa fiche ou annonce de vente des options comme les couleurs et la taille depuis une sélection rapide ou depuis un menu déroullant. <br />
  <br />
  Exemple: <br />
  Couleur &gt; rouge, blanc, bleur ou noir. <br />
  Taille &gt; petit, medium, large, xlarge...<br />
  <br />
	La zoaBoutique est la meilleure selon nous et nous sommes fiers des fonctionnalitées uniques qu'elle offre aux visiteurs de votre boutique et entreprise en ligne. Un visiteur peut litéralement ajouter au panier un item, cliquer sur acheter et sans le savoir acheter un item qui est en vente sur Amazon directement sur votre boutique et vous touchez une commission sur chaque vente SANS avoir à rediriger cette personne sur le site d'Amazon. Le seul moment est lors du traitement de son paiement. Bref, ils vont revenir acheter le produit sur votre zoaBoutique et non sur Amazon directement. Qui voudrait passer par l'intermédiaire? Mais bon, tout ça pour dire que...<br />
	<br />
	Les différentes variantes ont des ASIN parents stockés, mais parfois, l'élément parent n'est pas accessible via l'API de Amazon.<br /><br />
	Avec la version 1.01, les informations sur les variantes d'éléments sont stockées par défaut (<i>Même si configuré <code class="text-nowrap">$_config->handle_variations</code> dans les paramètres</i>), s’ils sont un élément parent (uniquement les informations sur les variations) et non les variations en tant qu’éléments de la base de données de produits.<br />
	Quand <code>$_config->handle_variations</code> est activé
<ul class='mt-0'><li>les variantes des articles parents seront stockées en tant qu'articles dans le catalogue de produits, lorsque l'article est un article parent</li>
		<li>les variantes disponibles seront affichées sur les pages produits des modèles (deux styles différents - un style pour chaque modèle, consultez les démos)</li>
		<li>si l'article est un enfant, l'article parent sera ajouté au catalogue de produits et les règles décrites ci-dessus s'appliquent à l'importation</li>
	</ul>
	Pour activer/désactiver les variantes pour votre <i class='fa fa-fw fa-z'></i>oaBoutique, veuillez ouvrir <em class='bg-light text-secondary'>z-conf.php</em><br />
	<strong>vrai</strong> ... activé<br />
	<strong>faux</strong> ... désativé
<pre class='syntax-highlight mb-0'><?php
			echo $zstore->highlightText('	//enable/disable possbile variations for single items
// * show existing variations on item pages
// * add variations for parent items each as new item into products database
// * add parent to child to products database
$_config->handle_variations = true;
');
		?></pre>
	</p>
	
	<h4>Variables dans les Modèles</h4>

	<p>Comme mentionné ci-dessus, il existe deux approches différentes pour afficher les éléments sur votre zoaBoutique. Les variations ne seront affichées que lorsque <code class="text-nowrap">$_config->handle_variations</code> est activé et les variations se trouvent dans la table des variations de la base de données.<br />
		Les Variations ne sont affichées que dans la mise en page du fichier <em class='bg-light text-secondary'>product.php</em>. Faites une recherche pour
		<pre class='syntax-highlight mb-0'><?php
			echo $zstore->highlightText('if ($zstore->handle_variations) {');
		?></pre><br />
		Le modèle <strong><em>default</em></strong> a la liste déroulante avec les sélections et<br />
		Le modèle <strong><em>bikes'n scooters</em></strong> ouvre les variations dans une fenêtre de style popup.