<?php
include("classes/zstore.class.php");

$zstore = new zstore();

//session was set in class file

$action = isset($_POST["action"]) ? $_POST["action"] : false;


/***
  * Frontend Functions [+]
  ***/

  /****
  * add item to cart - create cart if needed ...
  ****/
  if ($action == "add2cart") {
    $zstore->add2cart($_REQUEST["asin"]);
    if ($zstore->json) {
      echo $zstore->json;
    }
    $zstore->sendLastPHPError();
    exit;
  }

  /****
  * remove item from cart 
  ****/
  if ($action == "removeFromCart") {
    $zstore->removeFromCart($_REQUEST["cartItemId"]);
    if ($zstore->json) {
      echo $zstore->json;
    }
    $zstore->sendLastPHPError();
    exit;
  }

  /****
  * empty whole cart 
  ****/
  if ($action == "emptyCart") {
    $zstore->emptyCart();
    if ($zstore->json) {
      echo $zstore->json;
    }
    $zstore->sendLastPHPError();
    exit;
  }

  /****
  * update numbers of items 
  ****/
  if ($action == "modifyCartItem") {
    $zstore->modifyCartItem($_REQUEST["cartItemId"],$_REQUEST["quantity"]);
    if ($zstore->json) {
      echo $zstore->json;
    }
    $zstore->sendLastPHPError();
    exit;
  }

  /****
  * add item to favorites ...
  ****/
  if ($action == "add2favs") {
    $zstore->add2favs($_REQUEST["asin"]);
    if ($zstore->json) {
      echo $zstore->json;
    }
    $zstore->sendLastPHPError();
    exit;
  }

  /****
  * remove item from favorites ...
  ****/
  if ($action == "removeFromFavs") {
    $zstore->removeFromFavs($_REQUEST["asin"]);
    if ($zstore->json) {
      echo $zstore->json;
    }
    $zstore->sendLastPHPError();
    exit;
  }

  /****
  * get variations urls (select fields)
  ****/
  if ($action == "getVariationsUrl") {
    $zstore->getVariationsUrl($_REQUEST["parent_asin"],$_REQUEST["variations"],$_REQUEST["attrName"]);
    if ($zstore->json) {
      echo $zstore->json;
    }
    $zstore->sendLastPHPError();
    exit;
  }



/***
* Frontend Functions [-]
***/





/***
  * Admin Functions [+]
  ***/
if ($zstore->auth) {

  /****
  * update Amazon Settings
  ****/
  if ($action == "updateAmzConfig") {
    $zstore->updateAmzConfig($_REQUEST);
    if ($zstore->json) {
      echo $zstore->json;
    }
    $zstore->sendLastPHPError();
    exit;
  }

  /****
  * check Amazon API DATA
  ****/
  if ($action == "checkApiData") {
    $zstore->checkApiData($_REQUEST);
    if ($zstore->json) {
      echo $zstore->json;
    }
    $zstore->sendLastPHPError();
    exit;
  }

  /****
  * update Site Settings
  ****/
  if ($action == "updateSiteConfig") {
    $zstore->updateSiteConfig($_REQUEST);
    if ($zstore->json) {
      echo $zstore->json;
    }
    $zstore->sendLastPHPError();
    exit;
  }

  /****
  * update Amazon Search Results Settings
  ****/
  if ($action == "updateSrchConfig") {
    $zstore->updateSrchConfig($_REQUEST);
    if ($zstore->json) {
      echo $zstore->json;
    }
    $zstore->sendLastPHPError();
    exit;
  }


  /****
  * update Amazon Suggestions Default Flags
  ****/
  if ($action == "updateSuggestionConfig") {
    $zstore->updateSuggestionConfig($_REQUEST);
    if ($zstore->json) {
      echo $zstore->json;
    }
    $zstore->sendLastPHPError();
    exit;
  }

  /****
  * update Amazon Suggestionssetting for specified products
  ****/
  if ($action == "updateShowAmazonSuggestions") {
    $zstore->updateShowAmazonSuggestions($_REQUEST);
    if ($zstore->json) {
      echo $zstore->json;
    }
    $zstore->sendLastPHPError();
    exit;
  }

  /****
  * update Amazon Suggestion linkings for specified products
  ****/
  if ($action == "updateLinkAmazonSuggestions") {
    $zstore->updateLinkAmazonSuggestions($_REQUEST);
    if ($zstore->json) {
      echo $zstore->json;
    }
    $zstore->sendLastPHPError();
    exit;
  }

  /****
  * remove items coming from multi-ops
  ****/
  if ($action == "removeMultiSelectedItems") {
    $zstore->removeMultiSelectedItems($_REQUEST);
    if ($zstore->json) {
      echo $zstore->json;
    }
    $zstore->sendLastPHPError();
    exit;
  }




  /****
  * update/create product category
  ****/
  if ($action == "editCategory") {
    $zstore->editCategory($_REQUEST);
    if ($zstore->json) {
      echo $zstore->json;
    }
    $zstore->sendLastPHPError();
    exit;
  }

  /****
  * get product category data
  ****/
  if ($action == "getCategoryData") {
    $zstore->getCategoryData($_REQUEST["catId"]);
    if ($zstore->json) {
      echo $zstore->json;
    }
    $zstore->sendLastPHPError();
    exit;
  }

  /****
  * get parent categories (parent=0) 
  ****/
  if ($action == "getCategoryParents") {
    $zstore->getCategoryParents();
    if ($zstore->json) {
      echo $zstore->json;
    }
    $zstore->sendLastPHPError();
    exit;
  }

  /****
  * remove product category
  ****/
  if ($action == "removeCategory") {
    $zstore->removeCategory($_REQUEST["catId"]);
    if ($zstore->json) {
      echo $zstore->json;
    }
    $zstore->sendLastPHPError();
    exit;
  }

  /****
  * new positions for product categories
  ****/
  if ($action == "positionCategory") {
    $zstore->positionCategory($_REQUEST["catId"],$_REQUEST["dir"],$_REQUEST["parent"]);
    if ($zstore->json) {
      echo $zstore->json;
    }
    $zstore->sendLastPHPError();
    exit;
  }


  /****
  * change status of product categories
  ****/
  if ($action == "changeCategoryStatus") {
    $zstore->changeCategoryStatus($_REQUEST["catId"],$_REQUEST["status"]);
    if ($zstore->json) {
      echo $zstore->json;
    }
    $zstore->sendLastPHPError();
    exit;
  }


  /****
  * set/unset top category
  ****/
  if ($action == "changeTopCatState") {
    $zstore->changeTopCatState($_REQUEST["catId"],$_REQUEST["top_cat"]);
    if ($zstore->json) {
      echo $zstore->json;
    }
    $zstore->sendLastPHPError();
    exit;
  }

  /****
  * add single ASIN by (Keywordsearch)
  ****/
  if ($action == "importSingleAsin") {
    $zstore->importSingleAsin($_REQUEST["asin"],$_REQUEST["cat_ids"]);
    if ($zstore->json) {
      echo $zstore->json;
    }
    $zstore->sendLastPHPError();
    exit;
  }


  /****
  * remove single item
  ****/
  if ($action == "removeItem") {
    $zstore->removeItem($_REQUEST["itemId"]);
    if ($zstore->json) {
      echo $zstore->json;
    }
    $zstore->sendLastPHPError();
    exit;
  }

  /****
  * show xml file content
  ****/
  if ($action == "readXMLfiles") {
    $zstore->readXMLfiles($_REQUEST["asin"]);
    if ($zstore->json) {
      echo $zstore->json;
    }
    $zstore->sendLastPHPError();
    exit;
  }


  /****
  * import data for SPECIFIC single item
  ****/
  if ($action == "fetchItemData") {
    $zstore->amzFirstItemUpdate($_REQUEST["asin"],false,true);
    if ($zstore->json) {
      echo $zstore->json;
    }
    $zstore->sendLastPHPError();
    exit;
  }


  /****
  * import data for ANY single item - for GGrab Data Now Function
  ****/
  if ($action == "fetchAnyItemData") {
    $asin = $zstore->getAnyASINReadyToImport();
    if ($asin) {
      $zstore->amzFirstItemUpdate($asin,false,true);
    }
    if ($zstore->json) {
      echo $zstore->json;
    }
    $zstore->sendLastPHPError();
    exit;
  }


  /*********
   * personalize amazon links
   *********/
  if ($action == "placeholdersToAmzKeys") {
    $url = $zstore->placeholdersToAmzKeys($_REQUEST["url"]);
    echo json_encode(array("url" => $url));
    $zstore->sendLastPHPError();
    exit;
  }


  /****
  * remove multiple items
  ****/
  if ($action == "removeItems") {
    $zstore->removeItems($_REQUEST["itemIds"]);
    if ($zstore->json) {
      echo $zstore->json;
    }
    $zstore->sendLastPHPError();
    exit;
  }


  /****
  * set/unset category for single item
  ****/
  if ($action == "setItemCat") {
    $zstore->setItemCat($_REQUEST["itemId"],$_REQUEST["category_id"],$_REQUEST["todo"]);
    if ($zstore->json) {
      echo $zstore->json;
    }
    $zstore->sendLastPHPError();
    exit; 
  }


  /****
  * uncategorize multiple items
  ****/
  if ($action == "uncatItems") {
    $zstore->uncatItems($_REQUEST["itemIds"]);
    if ($zstore->json) {
      echo $zstore->json;
    }
    $zstore->sendLastPHPError();
    exit;
  }


  /****
  * set category for multiple item
  ****/
  if ($action == "setItemsCat") {
    $zstore->setItemsCat($_REQUEST["itemIds"],$_REQUEST["category_id"]);
    if ($zstore->json) {
      echo $zstore->json;
    }
    $zstore->sendLastPHPError();
    exit;
  }

  
  /****
  * sorting product review/detail
  ****/
  if ($action == "positionEditorialReview") {
    $zstore->positionEditorialReview($_REQUEST["reviewId"],$_REQUEST["dir"]);
    if ($zstore->json) {
      echo $zstore->json;
    }
    $zstore->sendLastPHPError();
    exit;
  }
  

  /****
  * update/create product review/detail
  ****/
  if ($action == "saveProductReview") {
    $zstore->saveProductReview($_REQUEST);
    if ($zstore->json) {
      echo $zstore->json;
    }
    $zstore->sendLastPHPError();
    exit;
  }


  /****
  * update custom title
  ****/
  if ($action == "updateCustomTitle") {
    $zstore->updateCustomTitle($_REQUEST);
    if ($zstore->json) {
      echo $zstore->json;
    }
    $zstore->sendLastPHPError();
    exit;
  }

  
  /****
  * remove review/detail
  ****/
  if ($action == "removeEditorialReview") {
    $zstore->removeEditorialReview($_REQUEST["reviewId"],$_REQUEST["asin"]);
    if ($zstore->json) {
      echo $zstore->json;
    }
    $zstore->sendLastPHPError();
    exit;
  }


  /*********
   * remove Log Entries
   *********/
  if ($action == "removeLogEntries") {
    $zstore->removeLogEntries($_REQUEST["logGroup"]);
    if ($zstore->json) {
      echo $zstore->json;
    }
    $zstore->sendLastPHPError();
    exit;
  }

  /*********
   * empty error log
   *********/
  if ($action == "emptyErrorLog") {
    $zstore->emptyErrorLog();
    if ($zstore->json) {
      echo $zstore->json;
    }
    $zstore->sendLastPHPError();
    exit;
  }

  /*********
   * enable disable error logging
   *********/
  if ($action == "updateErrorLogConfig") {
    $zstore->updateErrorLogConfig($_REQUEST["log_errors"]);
    if ($zstore->json) {
      echo $zstore->json;
    }
    $zstore->sendLastPHPError();
    exit;
  }

  


  /*********
   * update language entry
   *********/
  if ($action == "editLanguageEntry") {
    $zstore->editLanguageEntry($_REQUEST);
    if ($zstore->json) {
      echo $zstore->json;
    }
    $zstore->sendLastPHPError();
    exit;
  }


  /*********
   * remove Language Entry
   *********/
  if ($action == "removeLanguageEntry") {
    $zstore->removeLanguageEntry($_REQUEST["langId"]);
    if ($zstore->json) {
      echo $zstore->json;
    }
    $zstore->sendLastPHPError();
    exit;
  }


  /*********
   * remove Language
   *********/
  if ($action == "removeLanguage") {
    $zstore->removeLanguage($_REQUEST["langKey"]);
    if ($zstore->json) {
      echo $zstore->json;
    }
    $zstore->sendLastPHPError();
    exit;
  }


  /*********
   * get languages
   *********/
  if ($action == "getLanguages") {
    $zstore->getLanguages("json");
    if ($zstore->json) {
      echo $zstore->json;
    }
    $zstore->sendLastPHPError();
    exit;
  }


  /*********
   * add/copy languages
   *********/
  if ($action == "addNewLanguage") {
    $zstore->addNewLanguage($_REQUEST["langKey"],$_REQUEST["langCopyBaseKey"]);
    if ($zstore->json) {
      echo $zstore->json;
    }
    $zstore->sendLastPHPError();
    exit;
  }


  /****
  * get single language short_key data (en)
  ****/
  if ($action == "getSingleLangShortKeyData") {
    $zstore->getSingleLangShortKeyData($_REQUEST["langId"]);
    if ($zstore->json) {
      echo $zstore->json;
    }
    $zstore->sendLastPHPError();
    exit;
  }


}
/***
  * Admin Functions [-]
  ***/
?>