/***************
 * zStore 1.20 Admin JS
 *  April 11th 2019
 *  https://codecanyon.net/item/zstore-an-amazon-affiliate-store/22713029
 ***************
 *
 *  1. Misc
 *  1.1 open links in new window without using deprecated/unsupported attribute target=...
 *  1.2 tooltips class
 *  1.3 object dumper for dev purposes
 *  1.4 in_array function definition (not needed now)
 *  1.5 get variables from GET-URL (not needed now)
 *  2. Update Amazon Config
 *  2.1 update api key data
 *  2.2 check api key data
 *  3. Update Site Config
 *  3.A Update Amazon Search Config
 *  3.B Amazon Suggestions Default Values
 *  4. Item/Product Categories Management
 *  4.1 Add/Edit Category
 *  4.2 Remove Category
 *  4.3 Positioning of Categories
 *  4.4 Set Categories online/offline
 *  4.5 Promote Category - Top Categories
 *  5. Add Product Items
 *  5.1 Add ASINs
 *  5.2 Search Amazon for items to add ASINs - categories not implemented yet
 *  5.3 Add Keyword Search Results ASINs
 *  5.4 Multi-Product Operations
 *  5.4.1 category selector
 *  5.4.2 source selector
 *  5.4.3 show/hide suggestions
 *  5.4.4 link suggested items to amazon or stay within shop
 *  6. Product Management
 *	6.1 Animate search form
 *	6.2 Arrange big thumbnail view
 *  6.3. show hide big thumbs admin buttons
 *	6.4 remove item from big thumbnail view
 *	6.5 handle checkboxes
 *  6.6 multiselected button row
 *	6.7 remove single item from table view
 *	6.8 update categories for single items
 *	6.9 remove multiple items from table view
 *	6.10 uncategorize multiple items from table view
 *	6.11 update categories for single items
 *	6.12 fetch data from amazon for single item from table view
 *	6.13 fetch data for multiple items from table view
 *  6.13.A handle multiple custom titles at once
 *  6.13.B open xml response viewer
 *	6.14 grab data of multiple items from amazon
 *  7. Single Item administration
 *  7.1. update items's product data
 *  7.2 update produt details/editorial reviews
 *  7.2.1 create wysiwyg editor instances
 *  7.2.2 enable/disable edit function
 *  7.2.3 save form data
 *  7.2.4 remove editorial reviews
 *  7.2.5 Positioning of Reviews
 *  8. Language Administration
 *  8.1 setup datatables
 *  8.2 remove lang item 
 *  8.3 edit lang item 
 *  8.4 save lang item changes 
 *  8.5 add completely new language 
 *  8.6 remove whole Language 
 *  8.7 import new lang keys 
 *  9. Error Log Handling
 *  9.1 show/hide error_log entries 
 *  9.2 remove set of error_log entries 
 *  9.3 empty error log 
 *  9.4 enable/disable error logging 
 * 10. help/manual section
 * 10.1 display inline help


************/


jQuery(document).ready(function() {

/****
 * 1. Misc [+]
 ****/

  /** 1.1 open links in new window without using deprecated/unsupported attribute target=... **/
  $("body").on("click","a.open-external", function() {
    window.open($(this).attr("href"));
    return false;
  });

  /** 1.2 tooltips class **/
  $('.tt').tooltip();

  /** 1.3 object dumper for dev purposes **/
  function dump(obj) {
    var op = '';
    for (var i in obj) {
        op += i + ": " + obj[i] + "\n";
    }
   alert(op);
  }

  /** 1.4 in_array function definition (not needed now) **/
  function in_array(needle,arr) {
    for(i=0;i<arr.length;i++) {
      if (needle == arr[i]) {
        return true;
      }
    }
    return false;
  }

  /** 1.5 get variables from GET-URL (not needed now) **/
  function getGetVars(url,varName){
    var urlA = url.split("?"); 
    var vars = urlA[1].split("&"); 
    for (var i=0;i<vars.length;i++) {   
          var pair = vars[i].split("=");
          //remove anchor
          if(pair[0] == varName) {
            return pair[1].replace(/#.*$/,'');
          }
     }
  }
/****
 * 1. Misc [-]
 ****/


/****
 * 2. Update Amazon Config [+]
 ****/
  if ($("form#FamzConfig").length) {
    $("#FamzConfig input,#FamzConfig select").on("change keyup",function() {
      if ($("#FamzConfig button[type='submit']").prop("disabled")) {
        $("#FamzConfig input[name='amz_secret_key']").val("");
      }
      if ($("#FamzConfig input[name='amz_secret_key']").val().length) {
        $("#FamzConfig button.js-btn-check-api-key").prop("disabled",false);
      }
      $("#FamzConfig button[type='submit']").prop("disabled",false);
    });

    //2.1 update api key data
    $("form#FamzConfig").submit(function() {
      var thisForm = $(this);
      var thisFormBtns = $("button",thisForm);
      var successBox = $(".success-box",thisForm);

      $(".alert",thisForm).empty().removeClass("alert-success alert-danger").slideUp();

      var amz_marketplace = $("select[name='amz_marketplace']",thisForm).val();
      var amz_tag = $("input[name='amz_tag']",thisForm).val();
      var amz_access_key = $("input[name='amz_access_key']",thisForm).val();
      var amz_secret_key = $("input[name='amz_secret_key']",thisForm).val();

      $.ajax({
       type: "POST",
        async: false,
        dataType: "json",
        url: "functions.ajax.php",
        data: {action:"updateAmzConfig", amz_marketplace:amz_marketplace, amz_tag:amz_tag, amz_access_key:amz_access_key, amz_secret_key:amz_secret_key},
        success: function(msgObj) {
          if(msgObj.success) {

            $(thisFormBtns).prop("disabled",true);
            $(successBox).fadeIn(400,function() {
              $("input[name='amz_tag']",thisForm).val(msgObj.amz_tag);
              $("input[name='amz_access_key']",thisForm).val(msgObj.amz_access_key);
              $("input[name='amz_secret_key']",thisForm).val($("<div>").html(msgObj.amz_secret_key).text());
              setTimeout(function(){
                $(successBox).fadeOut();
              }, 1500); // milliseconds
            });
          } else if (msgObj.error) {
            $(".F-alert",thisForm).html(msgObj.error).addClass("alert-danger").slideDown();
          }
        }
      });      
      return false;
    });

    //2.2 check api key data
    $("form#FamzConfig .js-btn-check-api-key").click(function() {
      var thisForm = $("form#FamzConfig");

      $(".F-alert",thisForm).html("").removeClass("alert-danger alert-success").slideUp();
      
      var amz_marketplace = $("select[name='amz_marketplace']",thisForm).val();
      var amz_tag = $("input[name='amz_tag']",thisForm).val();
      var amz_access_key = $("input[name='amz_access_key']",thisForm).val();
      var amz_secret_key = $("input[name='amz_secret_key']",thisForm).val();

      $.ajax({
       type: "POST",
        async: false,
        dataType: "json",
        url: "functions.ajax.php",
        data: {action:"checkApiData", amz_marketplace:amz_marketplace, amz_tag:amz_tag, amz_access_key:amz_access_key, amz_secret_key:amz_secret_key},
        success: function(msgObj) {
          if(msgObj.success) {
            $(".F-alert",thisForm).html(msgObj.success).addClass("alert-success").slideDown();
          } else if (msgObj.error) {
            $(".F-alert",thisForm).html(msgObj.error).addClass("alert-danger").slideDown();
          } else if (msgObj.xmlError) {
            $(".F-alert",thisForm).html("<strong>" + msgObj.response.Code + "</strong><p>" + msgObj.response.Message + "</p>").addClass("alert-danger").slideDown();
          }
        }
      });      


      return false;
    });

  }
/****
 * 2. Update Amazon Config [-]
 ****/


/****
 * 3. Update Site Config [+]
 ****/
  if ($("form#FsiteConfig").length) {
    $("#FsiteConfig input,#FsiteConfig select,#FsiteConfig textarea").on("change keydown",function() {
      $("#FsiteConfig button").prop("disabled",false);
    });
    $("form#FsiteConfig").submit(function() {
      var thisForm = $(this);
      var thisBtn = $("button",thisForm);
      var successBox = $(".success-box",thisForm);

      $(".alert",thisForm).empty().removeClass("alert-success alert-danger").slideUp();

      var lang = $("select[name='lang']",thisForm).val();
      var categories_in_navbar = $("select[name='categories_in_navbar']",thisForm).val();
      var site_title = $("input[name='site_title']",thisForm).val();
      var site_author = $("input[name='site_author']",thisForm).val();
      var contact_mail = $("input[name='contact_mail']",thisForm).val();
      var meta_description = $("textarea[name='meta_description']",thisForm).val();
      var meta_keywords = $("textarea[name='meta_keywords']",thisForm).val();

      $.ajax({
       type: "POST",
        async: false,
        dataType: "json",
        url: "functions.ajax.php",
        data: {action:"updateSiteConfig", lang:lang, site_title:site_title, site_author:site_author, contact_mail:contact_mail, meta_description:meta_description, meta_keywords:meta_keywords, categories_in_navbar:categories_in_navbar},
        success: function(msgObj) {
          if(msgObj.success) {

            $(thisBtn).prop("disabled",true);
            $(successBox).fadeIn(400,function() {
              $("input[name='site_title']",thisForm).val(msgObj.site_title);
              $("input[name='site_author']",thisForm).val(msgObj.site_author);
              $("input[name='contact_mail']",thisForm).val(msgObj.contact_mail);
              $("textarea[name='meta_description']",thisForm).val(msgObj.meta_description);
              $("textarea[name='meta_keywords']",thisForm).val(msgObj.meta_keywords);
              setTimeout(function(){
                $(successBox).fadeOut();
              }, 1500); // milliseconds
            });
          } else if (msgObj.error) {
            $(".F-alert",thisForm).html(msgObj.error).addClass("alert-danger").slideDown();
          }
        }
      });      
      return false;
    });
  }
/****
 * 3. Update Site Config [-]
 ****/


/****
 * 3.A Update Amazon Search Config [+]
 ****/
  var srchConfigF = $("form#FsrchConfig");
  if (srchConfigF.length) {

    //show hide radios/checkboxes and change/show/hide info [+]
    $("input[type='checkbox']#cb_show_amz_search_results").change(function() {
      var thisState = $(this).is(":checked");
      if (thisState) {
        $(".form-group-amazon-search-results").slideDown();
        $(".js-amz-link-state").fadeIn();
      } else {
        $(".form-group-amazon-search-results").slideUp();
        $(".js-amz-link-state").fadeOut();      
      }
    });
    var updateAmzSrchLinkState = function() {
      if ($("input[name='link_amz_search_results_to_amz']:checked",srchConfigF).val() == 1) {
        $(".js-amz-link-state",srchConfigF).text($(".js-amz-link-state",srchConfigF).data("descr-on"));
      } else {
        $(".js-amz-link-state",srchConfigF).text($(".js-amz-link-state",srchConfigF).data("descr-off"));
      }
    }
    updateAmzSrchLinkState();
    $("input[name='link_amz_search_results_to_amz']",srchConfigF).change(function() {
      updateAmzSrchLinkState();
    });
    //show hide radios/checkboxes and change/show/hide info [-]

    $("input",srchConfigF).on("change",function() {
      $("button",srchConfigF).prop("disabled",false);
    });
    $(srchConfigF).submit(function() {
      var thisForm = $(this);
      var thisBtn = $("button",thisForm);
      var successBox = $(".success-box",thisForm);

      $(".F-alert",thisForm).empty().removeClass("alert-success alert-danger").slideUp();

      var show_amz_search_results = $("input[name='show_amz_search_results']:checked",thisForm).val();
      var link_amz_search_results_to_amz = $("input[name='link_amz_search_results_to_amz']:checked",thisForm).val();
      var link_to_more_results_on_amz = $("input[name='link_to_more_results_on_amz']:checked",thisForm).val();

      $.ajax({
       type: "POST",
        async: false,
        dataType: "json",
        url: "functions.ajax.php",
        data: {action:"updateSrchConfig", show_amz_search_results:show_amz_search_results, link_amz_search_results_to_amz:link_amz_search_results_to_amz, link_to_more_results_on_amz:link_to_more_results_on_amz},
        success: function(msgObj) {
          if(msgObj.success) {

            $(thisBtn).prop("disabled",true);
            $(successBox).fadeIn(400,function() {
              setTimeout(function(){
                $(successBox).fadeOut();
              }, 1500); // milliseconds
            });
          } else if (msgObj.error) {
            $(".F-alert",thisForm).html(msgObj.error).addClass("alert-danger").slideDown();
          }
        }
      });      
      return false;
    });
  }
/****
 * 3.A Update Amazon Search Config [-]
 ****/


/****
 * 3.B Amazon Suggestions Default Values [+]
 ****/
  var suggestionsF = $("form#FamzSuggestions");
  if (suggestionsF.length) {
    var updateAmzSuggestionStates = function() {
      if ($("input[name='default_products_show_amz_suggestions']:checked",suggestionsF).val() == 1) {
        $(".js-amz-show-suggestions-state",suggestionsF).text($(".js-amz-show-suggestions-state",suggestionsF).data("descr-on"));
      } else {
        $(".js-amz-show-suggestions-state",suggestionsF).text($(".js-amz-show-suggestions-state",suggestionsF).data("descr-off"));
      }
      if ($("input[name='default_products_link_amz_suggestions_to_amz']:checked",suggestionsF).val() == 1) {
        $(".js-amz-link-suggestions-state",suggestionsF).text($(".js-amz-link-suggestions-state",suggestionsF).data("descr-on"));
      } else {
        $(".js-amz-link-suggestions-state",suggestionsF).text($(".js-amz-link-suggestions-state",suggestionsF).data("descr-off"));
      }
    }
    updateAmzSuggestionStates();
    $("input[name='default_products_show_amz_suggestions'],input[name='default_products_link_amz_suggestions_to_amz']",suggestionsF).change(function() {
      updateAmzSuggestionStates();
    });

    $("input",suggestionsF).on("change",function() {
      $("button",suggestionsF).prop("disabled",false);
    });
    $(suggestionsF).submit(function() {
      var thisForm = $(this);
      var thisBtn = $("button",thisForm);
      var successBox = $(".success-box",thisForm);

      $(".F-alert",thisForm).empty().removeClass("alert-success alert-danger").slideUp();

      var default_products_show_amz_suggestions = $("input[name='default_products_show_amz_suggestions']:checked",thisForm).val();
      var default_products_link_amz_suggestions_to_amz = $("input[name='default_products_link_amz_suggestions_to_amz']:checked",thisForm).val();

      $.ajax({
       type: "POST",
        async: false,
        dataType: "json",
        url: "functions.ajax.php",
        data: {action:"updateSuggestionConfig", default_products_show_amz_suggestions:default_products_show_amz_suggestions, default_products_link_amz_suggestions_to_amz:default_products_link_amz_suggestions_to_amz},
        success: function(msgObj) {
          if(msgObj.success) {

            $(thisBtn).prop("disabled",true);
            $(successBox).fadeIn(400,function() {
              setTimeout(function(){
                $(successBox).fadeOut();
              }, 1500); // milliseconds
            });
          } else if (msgObj.error) {
            $(".F-alert",thisForm).html(msgObj.error).addClass("alert-danger").slideDown();
          }
        }
      });      
      return false;
    });
  }
/****
 * 3.B Amazon Suggestions Default Values [-]
 ****/



/****
 * 4. Item/Product Categories Management [+]
 ****/
  if ($(".table-product-categories").length) {
    /** 4.1 Add/Edit Category **/
    $("body").on("click",".js-btn-add-category,.js-btn-edit-cat", function() {
      var thisRow = $(this).closest("tr");
      var catId = 0;
      var parent = 0;
      var thisRow;
      var catData;
      var parents = new Array();
      var addForParent = $(this).data("add-for-parent");
      if (!addForParent) {
        addForParent = 0;
      }

      if ($(thisRow).data("id") && !addForParent) {
        catId = $(thisRow).data("id");

        $.ajax({
          type: "POST",
          url: "functions.ajax.php",
          dataType: 'json',
          data: {action:"getCategoryData", catId: catId},
          async: false,
          success: function(msgObj) {
            if (msgObj.error) {
              catId = 0;            
            } else if (msgObj.catData) {
              catData = msgObj.catData;
            }
          }
        });
      }

      $.ajax({
        type: "POST",
        url: "functions.ajax.php",
        dataType: 'json',
        data: {action:"getCategoryParents"},
        async: false,
        success: function(msgObj) {
          if (msgObj.parents) {
            parents = msgObj.parents;
          }
        }
      });

      var bbMessage = '<div class="alert alert-danger js-hide"></div>'+
        '<div class="form-horizontal mb0 pb0 mt10">';

      if (parents.length) {
        bbMessage += '<div class="form-group row">' +
            '<label class="control-label col-sm-3">Parent</label>' +
            '<div class="col-sm-5">' +
              '<select name="parent" class="form-control">' +
                '<option value="0">-- none/is Parent --</option>';
        $.each(parents,function(key,parentData) {
          if (catId && parentData.id == catId) {
            return;
          }
          bbMessage += '<option value="' + parentData.id + '">' + parentData.descr + '</option>';
        });
        bbMessage += '</select>' +
            '</div>' +
          '</div>';  
      }

      bbMessage += '<div class="form-group row">' +
            '<label class="control-label col-sm-3">Name for Category</label>' +
            '<div class="col-sm-5">' +
              '<input type="text" name="descr" value="" class="form-control" placeholder="Name for the product category" required="required" />' +
            '</div>' +
          '</div>' +

          '<hr /><div class="form-group row">' +
            '<label class="control-label col-sm-3">Short Introtext</label>' +
            '<div class="col-sm-9">' +
              '<em class="text-secondary small">optional, mainly used in category listings</em><br />' +
              '<textarea name="short_intro" class="form-control" rows="2" placeholder="optional, mainly used on category listing pages" /></textarea>' +
            '</div>' +
          '</div>' +

          '<hr /><div class="form-group row">' +
            '<label class="control-label col-sm-3">HTML Page Title</label>' +
            '<div class="col-sm-9">' +
              '<em class="text-secondary small">optional, if nothing is set, the Category Name will be used</em><br />' +
              '<input type="text" name="page_title" value="" class="form-control" placeholder="optional, category name by default" />' +
            '</div>' +
          '</div>' +

          '<hr /><div class="form-group row">' +
            '<label class="control-label col-sm-3">HTML Page Description</label>' +
            '<div class="col-sm-9">' +
              '<em class="text-secondary small">optional, 1-2 sentences - META description for SEO issues</em><br />' +
              '<textarea name="page_descr" class="form-control" rows="3" placeholder="optional, 1-2 sentences about the category - META description for SEO issues" /></textarea>' +
            '</div>' +
          '</div>' +

          '<hr /><div class="form-group row">' +
            '<label class="control-label col-sm-3">Headline</label>' +
            '<div class="col-sm-9">' +
              '<em class="text-secondary small">optional, will be used on product list when category is selected</em><br />' +
              '<input type="text" name="headline" value="" class="form-control" placeholder="optional, category name by default" />' +
            '</div>' +
          '</div>' +

          '<hr /><div class="form-group row">' +
            '<label class="control-label col-sm-3">Category Text</label>' +
            '<div class="col-sm-9">' +
              '<em class="text-secondary small">optional, will be used on product list when category is selected</em><br />' +
              '<textarea name="long_intro" class="form-control" rows="4" placeholder="optional, HTML allowed - lines will be breaked with &lt;br /&gt;" /></textarea>' +
            '</div>' +
          '</div>' +

          '<hr /><div class="form-group row">' +
            '<label class="control-label col-sm-3">Status</label>' +
            '<div class="col-sm-9">' +

              '<div class="custom-control custom-radio">' +
                '<input name="status" id="statusOnline" type="radio" class="custom-control-input" value="1" checked="checked">' +
                '<label class="custom-control-label" for="statusOnline">Online</label>' +
              '</div>' +
              '<label class="custom-control custom-radio">' +
                '<input name="status" id="statusOffline" type="radio" class="custom-control-input" value="0">' +
                '<label class="custom-control-label" for="statusOffline">Offline</label>' +
              '</label>' +

            '</div>' +
          '</div>' +
        '</div>';

      var bbEditCat = bootbox.dialog({title: catId ? "Edit Category" : "Create Category",
        onEscape: true,
        message: bbMessage,
        className: "bb-w800",
        buttons: {
          "save" : { label: catId ? "Update Category" : "Create Category", className : "btn-primary btn-submit dont-focus", 
            callback: 
              function() { 
                $(".alert",bbEditCat).fadeOut();      
                var descr = $("input[name='descr']",bbEditCat).val();
                var short_intro = $("textarea[name='short_intro']",bbEditCat).val();
                var page_title = $("input[name='page_title']",bbEditCat).val();
                var page_descr = $("textarea[name='page_descr']",bbEditCat).val();
                var headline = $("input[name='headline']",bbEditCat).val();
                var long_intro = $("textarea[name='long_intro']",bbEditCat).val();
                var status = $("input[name='status']:checked",bbEditCat).val();
                var parent = parseInt($("select[name='parent']",bbEditCat).val());
                $.ajax({
                  type: "POST",
                  url: "functions.ajax.php",
                  dataType: 'json',
                  data: {action:"editCategory", catId: catId, descr:descr, short_intro:short_intro, page_title:page_title, page_descr:page_descr, headline:headline, long_intro:long_intro, status:status, parent:parent},
                  async: false,
                  success: function(msgObj) {
                    if (msgObj.error) {
                      $(".alert.alert-danger",bbEditCat).html(msgObj.error).fadeIn();      
                      return false;
                    } else if (msgObj.success) {
                      if (!catId) {
                        var catRowBase = $(".hidden-content .catRowBase tbody").html();
                        catRowBase = catRowBase.replace(/\[DESCR\]/g,msgObj.descr);
                        catRowBase = catRowBase.replace(/\[ITEMCOUNT\]/g,'');
                        catRowBase = catRowBase.replace(/\[id\]/g,msgObj.newCatId);
                        catRowBase = catRowBase.replace(/\[parent\]/g,parent);
                        if (status == 1) {
                          catRowBase = catRowBase.replace("fa-playpause","fa-pause");
                          catRowBase = catRowBase.replace(/\[statusClass\]/g,"");
                          catRowBase = catRowBase.replace(/\[status\]/g,"0");
                        } else {
                          catRowBase = catRowBase.replace("fa-playpause","fa-play");
                          catRowBase = catRowBase.replace(/\[statusClass\]/g,"offline");
                          catRowBase = catRowBase.replace(/\[status\]/g,"1");
                        }
                        catRowBase = catRowBase.replace(/\[CATLINK\]/g,msgObj.url);
                        if (parent) {
                          catRowBase = catRowBase.replace(/\[FAMID\]/g,parent);
                          catRowBase = catRowBase.replace(/\[CATICON\]/g,"fa-angle-double-right");
                          catRowBase = catRowBase.replace(/\[ADDSUBCATBTN\]/g,"js-hide");
                          catRowBase = catRowBase.replace(/\[CATCELLCLASS\]/g,"pl-25");
                          catRowBase = catRowBase.replace(/\[CATTYPE\]/g,"child");

                          if ($('.table-product-categories tbody tr[data-parent=' + parent + ']').length) {
                            $('.table-product-categories tbody tr[data-parent=' + parent + ']:last').after(catRowBase);
                          } else {
                            $('.table-product-categories tbody tr[data-id=' + parent + ']').after(catRowBase);
                          }
                        } else {
                          catRowBase = catRowBase.replace(/\[FAMID\]/g,msgObj.newCatId);
                          catRowBase = catRowBase.replace(/\[CATICON\]/g,"fa-angle-right");
                          catRowBase = catRowBase.replace(/\[ADDSUBCATBTN\]/g,null);
                          catRowBase = catRowBase.replace(/\[CATCELLCLASS\]/g,null);
                          catRowBase = catRowBase.replace(/\[CATTYPE\]/g,"parent");

                          $(".table-product-categories tbody").append(catRowBase);
                        }
                        disCatPosButtons();
                        $.notify({
                          message: "The category has been created successfully.",icon:'fa fa-check'
                        },{type: "success",placement:{align:"center"}});
                      } else {
                        $(".cell-descr span",thisRow).text(msgObj.descr);
                        if (status == 1) {
                          $(".js-btn-chgstat-cat i",thisRow).addClass("fa-pause").removeClass("fa-play");
                          $(".js-btn-chgstat-cat",thisRow).data("status",0);
                          $(".cell-descr",thisRow).removeClass("offline");
                        } else {
                          $(".js-btn-chgstat-cat i",thisRow).addClass("fa-play").removeClass("fa-pause");
                          $(".js-btn-chgstat-cat",thisRow).data("status",1);
                          $(".cell-descr",thisRow).addClass("offline");
                        }
                        //parent changed??????
                        if (parent != $(thisRow).data("parent")) {
                          if (parent == 0) {
                            $(thisRow).data({"parent":0,"type":"parent","family-id":catId});
                            $("td",thisRow).first().removeClass("pl-25");
                            $("i.fa-angle-double-right",thisRow).removeClass("fa-angle-double-right").addClass("fa-angle-right");
                            $(".js-btn-add-category",thisRow).removeClass("js-hide");
                            $("tr",".table-product-categories").last().after($(thisRow));
                          } else {
                            $(thisRow).data({"parent":parent,"type":"child","family-id":parent});
                            $("td",thisRow).first().addClass("pl-25");
                            $("i.fa-angle-right",thisRow).removeClass("fa-angle-right").addClass("fa-angle-double-right");
                            $(".js-btn-add-category",thisRow).addClass("js-hide");
                            $("tr[data-family-id='" + parent + "']",".table-product-categories").last().after($(thisRow));                            
                          }
                          disCatPosButtons();
                        }

                        $(".js-btn-cat-link",thisRow).attr("href",msgObj.url);
                        $.notify({
                          message: "The category has been updated successfully.",icon:'fa fa-check'
                        },{type: "success",placement:{align:"center"}});
                      }
                    }
                  }
                });
              } 
          },
          "cancel" : { label: "Cancel", className : "btn-default btn-close", callback: function() { bootbox.hideAll(); } },
        }
      }).bind('shown.bs.modal', function(){
        if (catData) {
          $("input[name='descr']",bbEditCat).val(catData.descr);
          $("textarea[name='short_intro']",bbEditCat).val(catData.short_intro);
          $("input[name='page_title']",bbEditCat).val(catData.page_title);
          $("textarea[name='page_descr']",bbEditCat).val(catData.page_descr);
          $("input[name='headline']",bbEditCat).val(catData.headline);
          $("textarea[name='long_intro']",bbEditCat).val(catData.long_intro);
          $("input[name='status'][value='" + catData.status + "']",bbEditCat).attr("checked","checked");
          $("select[name='parent']",bbEditCat).val(catData.parent);
        } else {
          $("select[name='parent']",bbEditCat).val(addForParent);
        }
        //autosubmit
        $("input[name='descr']",bbEditCat).on("keydown",function(e) {
          if (e.keyCode == 13) { //Enter Key
            $(".btn-submit",bbEditCat).trigger("click");
            return false;
          }
        });
        $("input[name='descr']",bbEditCat).focus();
      });
      return false;
    });

    /** 4.2 Remove Category **/
    $("body").on("click",".js-btn-remove-cat",function() {
      var thisRow = $(this).closest("tr");
      var catId = $(thisRow).data("id");
      var thisItemCount = parseInt($(".badge",thisRow).text());

      $(thisRow).addClass("table-danger");

      var bbRemoveCat = bootbox.confirm({
          message: "<h4>Are you sure to delete this category?</h4>This cannot be undone.<br />If category is a parent the assigned items will be uncategorized.<br />If category is a child the items will be assigned to its parent.",
          closeButton: false,
          buttons: {
              confirm: {
                  label: 'Remove Category',
                  className: 'btn-danger bb-btn-remove-cat'
              },
              cancel: {
                  label: 'Cancel',
                  className: 'btn-secondary'
              }
          },
          callback: function (confirmed) {
            if (confirmed) {
              $.ajax({
                type: "POST",
                url: "functions.ajax.php",
                dataType: 'json',
                data: {action:"removeCategory",catId:catId},
                async: false,
                success: function(msgObj) {
                  if (msgObj.error) {
                    $.notify({
                      message: msgObj.error,icon:'fa fa-exclamation-triangle'
                    },{type: "danger",placement:{align:"center"}});
                  } else if (msgObj.success) {
                    $.notify({
                      message: msgObj.success ,icon:'fa fa-check'
                    },{type: "success",placement:{align:"center"}});
                    $(thisRow).fadeOut(400,function(){
                      if ($(thisRow).data("type") == "child" && thisItemCount) {
                        var parentItemCount = parseInt($(".badge","tr[data-type='parent'][data-family-id='" + $(thisRow).data("family-id") + "']").text());
                        if (parentItemCount) {
                          $("tr[data-type='parent'][data-family-id='" + $(thisRow).data("family-id") + "'] .badge").text(parentItemCount + thisItemCount);
                        } else {
                          $("tr[data-type='parent'][data-family-id='" + $(thisRow).data("family-id") + "'] td:first").append("<sup class='badge badge-info badge-pill'>" + thisItemCount + "</sup>");
                        }
                      } else {
                        $("tr[data-type='child'][data-family-id='" + catId + "'] td").removeClass("pl-25");
                        $("tr[data-type='child'][data-family-id='" + catId + "'] td i.child-indicator").removeClass("fa-angle-double-right").addClass("fa-angle-right");
                        $("tr[data-type='child'][data-family-id='" + catId + "'] .js-btn-add-category").fadeIn();
                      }
                      $(this).remove();
                      disCatPosButtons();
                    });
                  }
                }
              });
            } else {
              $(thisRow).removeClass("table-danger");
            }
          }
      }).bind('shown.bs.modal', function(){
        $(".bb-btn-remove-cat",bbRemoveCat).focus();
      });
    });

    /** 4.3 Positioning of Categories **/
    function disCatPosButtons() {
      $(".js-btn-pos-cat",".table-product-categories").prop("disabled",false);
      $("tr[data-type='parent'] .js-btn-pos-cat:first,tr[data-type='parent'] .js-btn-pos-cat:last",".table-product-categories").prop("disabled",true);
      $("tr[data-type='child']").each(function() {
        $("tr[data-parent=" + $(this).data("parent") + "] .js-btn-pos-cat:first,tr[data-parent=" + $(this).data("parent") + "] .js-btn-pos-cat:last",".table-product-categories").prop("disabled",true);
      });
    }
    disCatPosButtons();

    $("body").on("click",".js-btn-pos-cat",function() {
      var thisRow = $(this).closest("tr");
      var catId = $(thisRow).data("id");
      var dir = $(this).data("dir");
      var parent = $(thisRow).data("parent");
      var familyId = $(thisRow).data("family-id");

      $.ajax({
          type: "POST",
          url: "functions.ajax.php",
          dataType: 'json',
          data: {action:"positionCategory",catId:catId, dir:dir, parent:parent},
          async: false,
          success: function(msgObj) {
            //sort sub categories is much easier :)
            if (parent) {
              if (dir == "up") {
                $(thisRow).prev().before($(thisRow));
              } else if (dir == "down") {
                $(thisRow).next().after($(thisRow));
              }
            } else {
              if (dir == "up") {
                $(thisRow).prevAll("tr[data-type='parent']").first().before($("tr[data-family-id='" + familyId + "']"));
              } else if (dir == "down") {
                var nextFamilyId = $(thisRow).nextAll("tr[data-type='parent']").first().data("family-id");
                $(thisRow).nextAll("tr[data-family-id='" + nextFamilyId + "']").last().after($("tr[data-family-id='" + familyId + "']"));
              }
            }
            disCatPosButtons();
          }
      });
    });


    /** 4.4 Set Categories online/offline **/
    $("body").on("click",".js-btn-chgstat-cat",function() {
      var thisRow = $(this).closest("tr");
      var catId = $(thisRow).data("id");
      var status = $(this).data("status");
      var thisBtn = $(this);
      $.ajax({
          type: "POST",
          url: "functions.ajax.php",
          dataType: 'json',
          data: {action:"changeCategoryStatus",catId:catId, status:status},
          async: false,
          success: function(msgObj) {
            if (msgObj.status == "1") {
              $("i",thisBtn).addClass("fa-pause").removeClass("fa-play");
              $(".cell-descr",thisRow).removeClass("offline");
              $(thisBtn).data("status",0);
            } else {
              $("i",thisBtn).addClass("fa-play").removeClass("fa-pause");
              $(".cell-descr",thisRow).addClass("offline");
              $(thisBtn).data("status",1);
            }
          }
      });
    });

    /** 4.5 Promote Category - Top Categories **/
    $("body").on("click",".js-btn-promote-cat",function() {
      var thisRow = $(this).closest("tr");
      var catId = $(thisRow).data("id");
      var top_cat = $(this).data("top-cat");
      var thisBtn = $(this);
      $.ajax({
          type: "POST",
          url: "functions.ajax.php",
          dataType: 'json',
          data: {action:"changeTopCatState",catId:catId, top_cat:top_cat},
          async: false,
          success: function(msgObj) {
            if (msgObj.top_cat == "1") {
              $("i",thisBtn).addClass("fa-star text-warning").removeClass("fa-star-o");
              $(thisBtn).data("top-cat",0);
              $.notify({
                message: 'The category was tagged as top-category successfully.',icon:'fa fa-check'
              },{type: "success",placement:{align:"center"}});
            } else {
              $("i",thisBtn).addClass("fa-star-o").removeClass("fa-star text-warning");
              $(thisBtn).data("top-cat",1);
              $.notify({
                message: 'The top-category status of the category was revoked successfully.',icon:'fa fa-check'
              },{type: "success",placement:{align:"center"}});
            }
          }
      });
    });

  }
/****
 * 4. Item/Product Categories Management [-]
 ****/


/****
 * 5. Add Product Items [+]
 ****/
  if ($("textarea#importList").length) {
    $("textarea#importList").on("keydown keyup",function(e) {
      $(".importlines span").text($(this).val().split(/\r\n|\r|\n/).length);
    });
  }
  /** 5.1 Add Item by ASINs/ASIN or Keyword **/
  if ($("form#asinListImportF,form#amzKeywordsImportF,form#asinImportF").length) {
    //multi-select
    $(".form-control-multiselect-category").multiselect({
      buttonClass: 'btn btn-outline-secondary',
      templates: {
        li: '<li><a class="dropdown-item" tabindex="0" style=""><label style="display: block;padding-left:10px"></label></a></li>'
      },
      nonSelectedText: 'without any Category'
    });
  }

  /** 5.2 Search Amazon for items to add ASINs **/
  // if ($("form#amzKeywordsImportF").length) {
  //   //multi-select
  //   $(".form-control-multiselect-category").multiselect({
  //     buttonClass: 'btn btn-outline-secondary',
  //     templates: {
  //       li: '<li><a class="dropdown-item" tabindex="0" style=""><label style="display: block;padding-left:10px"></label></a></li>'
  //     },
  //     nonSelectedText: 'without any Category'
  //   });
  // }

  /** 5.3 Add Keyword Search Results ASINs **/
  if ($(".amzKeywords-grid").length) {


    var grid = $(".amzKeywords-grid");

    grid.imagesLoaded( function() {
      grid.masonry({
        itemSelector: '.amzKeywords-item',
        columnWidth: '.amzKeywords-item'
      });
    });


    $(".js-btn-import-asin").click(function() {
      var asin = $(this).closest(".amzKeywords-item").data("asin");
      var thisBtn = $(this);
      var thisTitle = $("h6",$(this).closest(".card-body")).html();
      var cat_ids = $("select[name='cat_ids[]']").val();
      $.ajax({
        type: "POST",
        url: "functions.ajax.php",
        dataType: 'json',
        data: {action:"importSingleAsin", asin:asin, cat_ids:cat_ids},
        async: false,
        success: function(msgObj) {
          if (msgObj.error) {
            $.notify({
              message: msgObj.error,icon:'fa fa-exclamation-triangle'
            },{type: "danger",placement:{align:"center"}});
          } else if (msgObj.success) {
            $.notify({
              title: "<strong>" + thisTitle + "</strong><br />", message: 'ASIN ' + asin + ' has been added to database successfully.',icon:'fa fa-check'
            },{type: "success",placement:{align:"center"}});
            $(thisBtn).removeClass("btn-zstore btn-success js-btn-import-asin").addClass("btn-outline-success btn-outline-zstore disabled").html("<i class='fa fa-check'></i> imported").blur();
          }
        }
      });
    });
  }

  /** 5.4 Multi-Product Operations **/
  var multiOpsForm = $("form#multiOpsF");
  if (multiOpsForm.length) {

    // 5.4.1 category selector
    var catItemCountValuesWrapper = $(".hidden-content .catItemCounts");

    $(".form-control-multiselect-category").multiselect({
      buttonClass: 'btn btn-outline-secondary',
      templates: {
        li: '<li><a class="dropdown-item" tabindex="0" style=""><label style="display: block;padding-left:10px"></label></a></li>'
      },
      nonSelectedText: 'please select ... ',
      onChange: function(element, checked) {
        if (element.val() == "all") {
          $(".form-control-multiselect-category").multiselect('deselectAll', true);
          $(".form-control-multiselect-category").multiselect('select', "all");
        } else {
          $(".form-control-multiselect-category").multiselect('deselect', "all");
        }
      },
      buttonTitle: function(options, select) { //used as callback method
        if (options.length === 0) {
          var itemsSelected = 0;
        } else {
          var itemsSelected = 0;
          options.each(function() {
            if ($(this).val() == "all") {
              itemsSelected = parseInt($("input[name='cat-all']",catItemCountValuesWrapper).val());
              $('.form-control-multiselect-category option[value!="all"]').prop('selected', false);
              return;
            }
            itemsSelected += parseInt($("input[name='cat-" + $(this).val() + "']",catItemCountValuesWrapper).val());
          });
        }
        $(".js-items-selected").data("cat",itemsSelected);
        itemsSelected = itemsSelected + parseInt($(".js-items-selected").data("src"));
        $(".js-items-selected").text(itemsSelected);
      }
    });

    // 5.4.2 source selector
    var sourceItemCountValuesWrapper = $(".hidden-content .sourceItemCounts");

    $(".form-control-multiselect-source").multiselect({
      buttonClass: 'btn btn-outline-secondary',
      templates: {
        li: '<li><a class="dropdown-item" tabindex="0" style=""><label style="display: block;padding-left:10px"></label></a></li>'
      },
      nonSelectedText: 'please select ... ',
      buttonTitle: function(options, select) { //used as callback method
        if (options.length === 0) {
          var itemsSelected = 0;
        } else {
          var itemsSelected = 0;
          options.each(function() {
            itemsSelected += parseInt($("input[name='source-" + $(this).val() + "']",sourceItemCountValuesWrapper).val());
          });
        }
        $(".js-items-selected").data("src",itemsSelected);
        itemsSelected = itemsSelected +  parseInt($(".js-items-selected").data("cat"));
        $(".js-items-selected").text(itemsSelected);
      }
    });


    //5.4.3 show/hide suggestions
    $(".btn-set-show_amz_suggestions").click(function() {
      var thisBtn = $(this);
      var thisBtnText = $(thisBtn).html();
      var show_amz_suggestions = $(thisBtn).data("value");
      var catIds = $(".form-control-multiselect-category").val();
      var sources = $(".form-control-multiselect-source").val();
      $.ajax({
        type: "POST",
        url: "functions.ajax.php",
        dataType: 'json',
        data: {action:"updateShowAmazonSuggestions", catIds:catIds, show_amz_suggestions:show_amz_suggestions, sources:sources},
        async: false,
        success: function(msgObj) {
          if (msgObj.error) {
            $.notify({
              message: msgObj.error,icon:'fa fa-exclamation-triangle'
            },{type: "danger",placement:{align:"center"}});
          } else if (msgObj.success) {
            $(thisBtn).removeClass("btn-outline-primary").addClass("btn-success").attr("disabled",true).html("<i class='fa fa-check fa-2x pull-left'></i> Suggestions " + (show_amz_suggestions == 1 ? "enabled" : "disabled") + "<br /><small>for selected items</small>");
            setTimeout(function(){
              $(thisBtn).addClass("btn-outline-primary").removeClass("btn-success").attr("disabled",false).html(thisBtnText);
            }, 1500);
          }
        }
      });
    });

    //5.4.4 link suggested items to amazon or stay within shop
    $(".btn-set-link_amz_suggestions_to_amz").click(function() {
      var thisBtn = $(this);
      var thisBtnText = $(thisBtn).html();
      var link_amz_suggestions_to_amz = $(thisBtn).data("value");
      var catIds = $(".form-control-multiselect-category").val();
      var sources = $(".form-control-multiselect-source").val();
      $.ajax({
        type: "POST",
        url: "functions.ajax.php",
        dataType: 'json',
        data: {action:"updateLinkAmazonSuggestions", catIds:catIds, link_amz_suggestions_to_amz:link_amz_suggestions_to_amz, sources:sources},
        async: false,
        success: function(msgObj) {
          if (msgObj.error) {
            $.notify({
              message: msgObj.error,icon:'fa fa-exclamation-triangle'
            },{type: "danger",placement:{align:"center"}});
          } else if (msgObj.success) {
            $(thisBtn).removeClass("btn-outline-primary").addClass("btn-success").attr("disabled",true).html("<i class='fa fa-check fa-2x pull-left'></i> Links to suggested items will<br />"
             + (link_amz_suggestions_to_amz == 1 ? "lead to amazon" : "stay inside shop")
            );
            setTimeout(function(){
              $(thisBtn).addClass("btn-outline-primary").removeClass("btn-success").attr("disabled",false).html(thisBtnText);
            }, 1500);
          }
        }
      });
    });

    //5.4.5 remove items completely
    $(".btn-remove-selected-items").click(function() {
      var thisBtn = $(this);
      var link_amz_suggestions_to_amz = $(thisBtn).data("value");
      var catIds = $(".form-control-multiselect-category").val();
      var sources = $(".form-control-multiselect-source").val();



      var bbRemoveItems = bootbox.confirm({
        message: "<h4>Are you sure to delete the selected items?</h4>This action cannot be revoked. But you could add the items again at any time.",
        closeButton: false,
        buttons: {
            confirm: {
                label: 'OK, remove items',
                className: 'btn-danger bb-btn-remove-items'
            },
            cancel: {
                label: 'No, Cancel',
                className: 'btn-secondary btn-cancel'
            }
        },
        callback: function (confirmed) {
          if (confirmed) {
            $(".bb-btn-remove-items",bbRemoveItems).prepend("<i class='fa fa-spinner fa-pulse fa-fw'></i> ").prop("disabled",true);
            $(".bb-btn-cancel",bbRemoveItems).prop("disabled",true);
            var proceed = false;
            setTimeout(function() {
              proceed = true;
              $.ajax({
                type: "POST",
                url: "functions.ajax.php",
                dataType: 'json',
                data: {action:"removeMultiSelectedItems", catIds:catIds, sources:sources},
                async: false,
                success: function(msgObj) {
                  if (msgObj.error) {
                    $.notify({
                      message: msgObj.error,icon:'fa fa-exclamation-triangle'
                    },{type: "danger",placement:{align:"center"}});
                  } else if (msgObj.success) {
                    bootbox.hideAll();
                    $(thisBtn).removeClass("btn-outline-danger").addClass("btn-success").attr("disabled",true).html("<i class='fa fa-check fa-3x pull-left'></i><big>items successfully<br />removed</big>");
                    setTimeout(function(){
                      $(thisBtn).html("<i class='fa fa-refresh fa-spin fa-3x pull-left'></i><big>reloading<br />page ...</big>");
                      setTimeout(function(){
                        location.reload();
                      },1500);
                    }, 1500);
                  }
                }
              });
            },500);
            return proceed;
          } else {
            //nothing todo :)
          }
        } //callback
      }).bind('shown.bs.modal', function(){
        $(".bb-btn-remove-items",bbRemoveItems).focus();
      });
    });



  }
/****
 * 5. Add Product Items [-]
 ****/


/****
 * 6. Product Management [+]
 ****/
if ($("form#FsrchAdmItems").length) { //this should be found on the admin page :)
  /** 6.1 Animate search form **/
  $(".btn-srch-items").click(function() {
    if ($("input[name='srch']").hasClass("w0")) {
      $("input[name='srch']").removeClass("w0").css("width",0);
      $("input[name='srch']").animate({
        width: "150px"},
        333, 
        function () {
          $(".btn-srch-items").blur();
          $("input[name='srch']").focus();
        }
      );
      return false;
    }
  });

  //big item views
  if ($(".amz-adm-item-grid").length) {
  
    /** 6.2 Arrange big thumbnail view **/
    var grid = $(".amz-adm-item-grid");

    grid.imagesLoaded( function() {
      grid.masonry({
        itemSelector: '.amz-adm-item-item',
        columnWidth: '.amz-adm-item-item'
      });
    });

    /** 6.3. show hide big thumbs admin buttons **/
    $(".btn-group-adm-items").hide();
    $(".amz-adm-item-grid .amz-adm-item-item").hover(
      function() {
        $(".btn-group-adm-items",this).fadeIn(200);
      },
      function() {
        $(".btn-group-adm-items",this).fadeOut(200);
      }
    );

    /** 6.4 remove item from big thumbnail view **/
    $(".js-btn-remove").click(function() {
      var thisGridCell = $(this).closest(".amz-adm-item-item");
      var itemId = $(thisGridCell).data("item-id");
      var asin = $(thisGridCell).data("asin");
      
      $(".card", thisGridCell).addClass("bg-danger text-white");

      var bbRemoveItem = bootbox.confirm({
        message: "<h4>Are you sure to delete this item?</h4>This action cannot be revoked. But you could add the item again at any time.",
        closeButton: false,
        buttons: {
            confirm: {
                label: 'OK, remove item',
                className: 'btn-danger bb-btn-remove-item'
            },
            cancel: {
                label: 'No, Cancel',
                className: 'btn-secondary'
            }
        },
        callback: function (confirmed) {
          if (confirmed) {
            $.ajax({
              type: "POST",
              url: "functions.ajax.php",
              dataType: 'json',
              data: {action:"removeItem", itemId:itemId},
              async: false,
              success: function(msgObj) {
                if (msgObj.error) {
                  $.notify({
                    message: msgObj.error,icon:'fa fa-exclamation-triangle'
                  },{type: "danger",placement:{align:"center"}});
                } else if (msgObj.success) {
                  $.notify({
                    message: 'ASIN ' + asin + ' has been removed successfully.',icon:'fa fa-check'
                  },{type: "success",placement:{align:"center"}});
                  $(thisGridCell).fadeOut(400,function() {
                    $(this).remove();
                    $(".amz-adm-item-grid").masonry('destroy');
                    $(".amz-adm-item-grid").masonry();
                  });
                }
              }
            });
          } else {
            $(".card", thisGridCell).removeClass("bg-danger text-white");
          }
        } //callback
      }).bind('shown.bs.modal', function(){
        $(".bb-btn-remove-item",bbRemoveItem).focus();
      });
    });
  }
  
  // products table/list view
  if ($(".table-adm-items").length) {

    /** 6.5 handle checkboxes **/

    function enDisMultipleItemActionButtons() {
      if ($(".table-adm-items [type='checkbox']:checked").length > 0) {
        $(".row-multiple-items-actions button").prop("disabled",false);
      } else {
        $(".row-multiple-items-actions button").prop("disabled",true);
      }
    }

    var itemIds = new Array();
    //row clicks
    $(".table-adm-items tbody tr").click(function(e) {
      if ($(e.target).closest('.dont-trigger').length || $(e.target).hasClass("dont-trigger")) {
        return;
      }

      var thisRow = $(this).closest("tr");
      var itemId = $(thisRow).data("item-id");
      var thisCheckbox = $("input[type='checkbox']",this);


      if ($(thisCheckbox).is(":checked")) {
        $(thisRow).removeClass("table-info");  
        $(thisCheckbox).prop("checked",false);

      } else {
        $(thisRow).addClass("table-info");
        $(thisCheckbox).prop("checked",true);
      }
      enDisMultipleItemActionButtons(); 
    });
    //on/off all checkboxes
    $(".js-chgstat-item-checkbox").click(function() {
      if ($(this).hasClass("fa-square-o")) {
        $(".table-adm-items input[type='checkbox']").prop("checked",true);
        $(".table-adm-items tbody tr").addClass("table-info");
        $(this).removeClass("fa-square-o").addClass("fa-check-square-o");
      } else {
        $(".table-adm-items input[type='checkbox']").prop("checked",false);
        $(".table-adm-items tbody tr").removeClass("table-info");
        $(this).addClass("fa-square-o").removeClass("fa-check-square-o");
      }
      enDisMultipleItemActionButtons();
    });

    /** 6.6 multiselected button row **/
    $(".table-adm-items input[type='checkbox']").change(function() {
      var thisRow = $(this).closest("tr");
      if ($(this).is(":checked")) {
        $(thisRow).addClass("table-info");
      } else {
        $(thisRow).removeClass("table-info");
      }
      enDisMultipleItemActionButtons(); 
    });

    /** 6.7 remove single item from table view **/
    $(".table-adm-items tbody .js-btn-remove").click(function() {
      var thisRow = $(this).closest("tr");
      var itemId = $(thisRow).data("item-id");
      var asin = $(thisRow).data("asin");

      $(thisRow).addClass("table-danger");

        var bbRemoveItem = bootbox.confirm({
          message: "<h4>Are you sure to delete this item?</h4>This action cannot be revoked. But you could add the item again at any time.",
          closeButton: false,
          buttons: {
              confirm: {
                  label: 'OK, remove item',
                  className: 'btn-danger bb-btn-remove-item'
              },
              cancel: {
                  label: 'No, Cancel',
                  className: 'btn-secondary'
              }
          },
          callback: function (confirmed) {
            if (confirmed) {
              $.ajax({
                type: "POST",
                url: "functions.ajax.php",
                dataType: 'json',
                data: {action:"removeItem", itemId:itemId},
                async: false,
                success: function(msgObj) {
                  if (msgObj.error) {
                    $.notify({
                      message: msgObj.error,icon:'fa fa-exclamation-triangle'
                    },{type: "danger",placement:{align:"center"}});
                  } else if (msgObj.success) {
                    $(thisRow).fadeOut(400,function() {
                      $(this).remove();
                    })
                    $.notify({
                      message: 'ASIN ' + asin + ' has been removed successfully.',icon:'fa fa-check'
                    },{type: "success",placement:{align:"center"}});
                  }
                }
              });
            } else {
              $(thisRow).removeClass("table-danger");
            }
          } //callback
        }).bind('shown.bs.modal', function(){
          $(".bb-btn-remove-item",bbRemoveItem).focus();
        });

    });
  

    /** 6.8 update categories for single items **/
    $(".btn-group-categories a.set-cat-id").click(function() {
      var thisGroup = $(this).closest(".btn-group-categories");
      var thisRow = $(this).closest("tr");
      var itemId = $(thisRow).data("item-id");
      var thisBtn = $(this);
      var category_id = $(this).data("cat-id");

      var todo = $("i",thisBtn).hasClass("fa-check-square-o") ? "remove" : "add";

      $.ajax({
        type: "POST",
        url: "functions.ajax.php",
        dataType: 'json',
        data: {action:"setItemCat", itemId:itemId, category_id:category_id, todo:todo },
        async: false,
        success: function(msgObj) {
          if (msgObj.error) {
            $.notify({
              message: msgObj.error,icon:'fa fa-exclamation-triangle'
            },{type: "danger",placement:{align:"center"}});
          } else if (msgObj.success) {
            $.notify({
              message: msgObj.success ,icon:'fa fa-check'
            },{type: "success",placement:{align:"center"}});
            if (todo == "add") {
              $("i",thisBtn).removeClass("fa-square-o").addClass("fa-check-square-o");
            } else if (todo == "remove") {
              $("i",thisBtn).addClass("fa-square-o").removeClass("fa-check-square-o");
            }
            if (msgObj.catDescr) {
              $(".cat-descriptions",thisRow).text(" | " + msgObj.catDescr);
            } else {
              $(".cat-descriptions",thisRow).text("");
            }
          }
        }
      });
      return false;

    });


    /** 6.9 remove multiple items from table view **/
    $(".row-multiple-items-actions .js-btn-remove-items").click(function() {

      var itemIds = $("input[name^='itemId']:checked").map(function(){
        return this.value;
      }).get();

      var bbRemoveItem = bootbox.confirm({
        message: "<h4>Are you sure to delete the selected items?</h4>This action cannot be revoked. But you could add the items again at any time.",
        closeButton: false,
        buttons: {
            confirm: {
                label: 'OK, remove items',
                className: 'btn-danger bb-btn-remove-items'
            },
            cancel: {
                label: 'No, Cancel',
                className: 'btn-secondary'
            }
        },
        callback: function (confirmed) {
          if (confirmed) {
            $.ajax({
              type: "POST",
              url: "functions.ajax.php",
              dataType: 'json',
              data: {action:"removeItems", itemIds:itemIds},
              async: false,
              success: function(msgObj) {
                if (msgObj.error) {
                  $.notify({
                    message: msgObj.error,icon:'fa fa-exclamation-triangle'
                  },{type: "danger",placement:{align:"center"}});
                } else if (msgObj.success) {

                  $.each(itemIds, function(key,itemId) {
                    $("tr[data-item-id='" + itemId + "']").fadeOut(400,function() {
                      $(this).remove();
                    });
                  });
                  $.notify({
                    message: 'The selected items have been removed successfully.',icon:'fa fa-check'
                  },{type: "success",placement:{align:"center"}});
                  $(".row-multiple-items-actions button").prop("disabled",true);
                }
              }
            });
          } else {
            //nothing todo :)
          }
        } //callback
      }).bind('shown.bs.modal', function(){
        $(".bb-btn-remove-items",bbRemoveItem).focus();
      });

    });


    /** 6.10 uncategorize multiple items from table view **/
    $(".row-multiple-items-actions .js-btn-uncat-items").click(function() {

      var itemIds = $("input[name^='itemId']:checked").map(function(){
        return this.value;
      }).get();

      var bbUncatItem = bootbox.confirm({
        message: "<h4>Are you sure to uncategorize the selected items?</h4>This action cannot be revoked. But you could re-assign the items again at any time.",
        closeButton: false,
        buttons: {
            confirm: {
                label: 'OK, uncategorize items',
                className: 'btn-primary bb-btn-uncat-items'
            },
            cancel: {
                label: 'No, Cancel',
                className: 'btn-secondary'
            }
        },
        callback: function (confirmed) {
          if (confirmed) {
            $.ajax({
              type: "POST",
              url: "functions.ajax.php",
              dataType: 'json',
              data: {action:"uncatItems", itemIds:itemIds},
              async: false,
              success: function(msgObj) {
                if (msgObj.error) {
                  $.notify({
                    message: msgObj.error,icon:'fa fa-exclamation-triangle'
                  },{type: "danger",placement:{align:"center"}});
                } else if (msgObj.success) {

                 $.each(itemIds, function(key,itemId) {
                    $("tr[data-item-id='" + itemId + "'] .cat-descriptions").text("");
                    $("tr[data-item-id='" + itemId + "'] .btn-group-categories a.set-cat-id i").addClass("fa-square-o").removeClass("fa-check-square-o");
                  });

                  $.notify({
                    message: 'The selected items have been uncategorized successfully.',icon:'fa fa-check'
                  },{type: "success",placement:{align:"center"}});
                }
              }
            });
          } else {
            //nothing todo :)
          }
        } //callback
      }).bind('shown.bs.modal', function(){
        $(".bb-btn-uncats-items",bbUncatItem).focus();
      });
    });

    /** 6.11 update categories for single items **/
    $(".btn-group-categories-for-selected-items a.set-cat-id").click(function() {

      var itemIds = $("input[name^='itemId']:checked").map(function(){
        return this.value;
      }).get();

      var category_id = $(this).data("cat-id");

      $.ajax({
        type: "POST",
        url: "functions.ajax.php",
        dataType: 'json',
        data: {action:"setItemsCat", itemIds:itemIds, category_id:category_id},
        async: false,
        success: function(msgObj) {
          if (msgObj.error) {
            $.notify({
              message: msgObj.error,icon:'fa fa-exclamation-triangle'
            },{type: "danger",placement:{align:"center"}});
          } else if (msgObj.success) {
            $.notify({
              message: msgObj.success ,icon:'fa fa-check'
            },{type: "success",placement:{align:"center"}});
            
            $.each(itemIds, function(key,itemId) {
              if (msgObj.catDescrs[itemId]) {
                $("tr[data-item-id='" + itemId + "'] .cat-descriptions").text(" | " + msgObj.catDescrs[itemId]);
              }
              $("tr[data-item-id='" + itemId + "'] .btn-group-categories a.set-cat-id[data-cat-id='" + category_id + "'] i").removeClass("fa-square-o").addClass("fa-check-square-o");
            });
  

          }
        }
      });
      $(this).closest('.dropdown-menu').dropdown("toggle");

      return false;

    });

    /** 6.12 fetch data from amazon for single item from table view **/
    $(".table-adm-items tbody .js-btn-fetch-data-now").click(function() {
      var thisRow = $(this).closest("tr");
      var itemId = $(thisRow).data("item-id");
      var asin = $(thisRow).data("asin");
      var thisBtn = $(this);

      $(thisRow).addClass("table-info");

      var bbFetchAmazonItemData = bootbox.dialog({title: "Fetching data from Amazon",
        onEscape: false,
        message: '<div class="text-center"><i class="fa fa-circle-o-notch fa-spin fa-3x"></i><br />please wait ...</div>',
      }).bind('shown.bs.modal', function(){
        $.ajax({
          type: "POST",
          url: "functions.ajax.php",
          dataType: 'json',
          data: {action:"fetchItemData", asin:asin},
          async: false,
          success: function(msgObj) {
            if (msgObj.error) {
              $.notify({
                message: msgObj.error,icon:'fa fa-exclamation-triangle'
              },{type: "danger",placement:{align:"center"}});
            } else if (msgObj.success) {
              $(".js-not-imported",thisRow).fadeOut(400,function() {
                if (msgObj.itemImgSrc) {
                  $(".js-just-imported img",thisRow).attr("src",msgObj.itemImgSrc);
                  $(".js-just-imported i.no-img",thisRow).fadeOut();
                } else {
                  $(".js-just-imported img",thisRow).fadeOut();
                }
                $(".js-just-imported",thisRow).fadeIn();

                if (msgObj.itemTitle) {
                  $(".item-cell-short-details h6",thisRow).html(msgObj.itemTitle);
                }

                $(".item-cell-short-details",thisRow).append(", imported: <i>just this minute</i>");

                $(".js-item-amazon-link",thisRow).attr("href",msgObj.itemAmzLink);
                $(".js-item-store-link",thisRow).attr("href",msgObj.itemStoreUrl);

                $(".js-btn-edit-item, .js-btn-item-links a",thisRow).removeClass("disabled");


                $(thisBtn).fadeOut();
              });
              $.notify({
                message: 'Data for ASIN ' + asin + ' has been imported successfully.',icon:'fa fa-check'
              },{type: "success",placement:{align:"center"}});
            }
            bootbox.hideAll();
            $(thisRow).removeClass("table-info");
          }
        });
      });
      return false;
    });


    /** 6.13 fetch data for multiple items from table view **/
    $(".row-multiple-items-actions .js-btn-import-items-data").click(function() {

      var itemIds = $("input[name^='itemId']:checked").map(function(){
        return this.value;
      }).get();

      var bbFetchAmazonMultipleItemData = bootbox.dialog({title: "Fetching data from Amazon",
        onEscape: false,
        message: '<div class="text-center"><i class="fa fa-circle-o-notch fa-spin fa-3x"></i><br />please wait ...</div><br /><ul></ul>',
      }).bind('shown.bs.modal', function(){

        var currentItemIndex = -1;

        var fetchItemDataLooper = setInterval(function() {
            ++currentItemIndex;
            var thisRow = $("tr[data-item-id='" + itemIds[currentItemIndex] + "']");
            var asin = $(thisRow).data("asin"); 


            $.ajax({
              type: "POST",
              url: "functions.ajax.php",
              dataType: 'json',
              data: {action:"fetchItemData", asin:asin},
              async: false,
              success: function(msgObj) {
                if (msgObj.error) {
                  $("ul",bbFetchAmazonMultipleItemData).append("<li class='text-danger'><i class='fa fa-times fa-fw'></i> " + asin + "-troubles: " + msgObj.error + "</li>");
                } else if (msgObj.success) {
                  $(".js-not-imported",thisRow).fadeOut(400,function() {
                    if (msgObj.itemImgSrc) {
                      $(".js-just-imported img",thisRow).attr("src",msgObj.itemImgSrc);
                      $(".js-just-imported i.no-img",thisRow).fadeOut();
                    } else {
                      $(".js-just-imported img",thisRow).fadeOut();
                    }
                    $(".js-just-imported",thisRow).fadeIn();

                    if (msgObj.itemTitle) {
                      $(".item-cell-short-details h6",thisRow).html(msgObj.itemTitle);
                    }

                    $(".item-cell-short-details",thisRow).append(", imported: <i>just this minute</i>");

                    $(".js-item-amazon-link",thisRow).attr("href",msgObj.itemAmzLink);
                    $(".js-item-store-link",thisRow).attr("href",msgObj.itemStoreUrl);

                    $(".js-btn-edit-item, .js-btn-item-links a",thisRow).removeClass("disabled");

                    $(".js-btn-fetch-data-now",thisRow).fadeOut();
                  });
                  $("ul",bbFetchAmazonMultipleItemData).append("<li class='text-success'><i class='fa fa-check fa-fw'></i> " + asin + " data imported</li>");
                  
                  $("input[name^='itemId']",thisRow).prop("checked",false);

                  $(thisRow).removeClass("table-info");
                }
              }
            });
            if (currentItemIndex >= itemIds.length) {
              clearInterval(fetchItemDataLooper)
              bootbox.hideAll();
            }
        }, 1000);
      });
      return false;

    });



    /** 6.13.A handle multiple custom titles at once **/

    //show hide curstom title input fields

    $(".js-btn-show-hide-custom-fields").click(function() {
      var thisBtn = $(this);
      if ($(".custom-input-field-wrapper:first").is(":visible")) {
        $(".custom-input-field-wrapper").slideUp();
        $("span",thisBtn).text($(thisBtn).data("text-show"));
      } else {
        $(".custom-input-field-wrapper").slideDown();
        $("span",thisBtn).text($(thisBtn).data("text-hide"));
      }
      $(thisBtn).blur();
    });

    //the update function
    var updateCustomTitle = function(data) {
      var response = null;
      $.ajax({
        type: "POST",
        url: "functions.ajax.php",
        dataType: 'json',
        data: {action:"updateCustomTitle", itemId:data.itemId, customTitle:data.customTitle},
        async: false,
        success: function(msgObj) {
          response = msgObj;
        }
      });
      return response;
    }

    //field inspector
    $(".js-input-custom-title").on("keydown", function(e) {
      var thisField = $(this);
      var thisRow = $(this).closest("tr");
      var itemId = $(thisRow).data("item-id");
      var thisFieldWrapper = $(this).closest(".custom-input-field-wrapper");

      var origVal = $(thisField).attr("value");

        var customTitle = $(thisField).val();
        var modified = false;
        var updated = false;

        if (customTitle !== origVal) {
          $("button",thisFieldWrapper).prop("disabled",false).addClass("btn-primary").removeClass("btn-outline-secondary");
          modified = true;
        }

        if (e.keyCode == 13) { //Enter Key

          if (modified) {
            var operationResponse = updateCustomTitle({itemId:itemId,customTitle:customTitle});

            if (operationResponse) {
              if (operationResponse.error) {
                $.notify({
                  message: operationResponse.error,icon:'fa fa-exclamation-triangle'
                },{type: "danger",placement:{align:"center"}});
              } else if (operationResponse.success) {
                $.notify({
                  message: operationResponse.success,icon:'fa fa-check'
                },{type: "success",placement:{align:"center"}});
                $(thisField).val(operationResponse.customTitle);
                $(thisField).attr("value",operationResponse.customTitle);
              }
              e.preventDefault();
            } else {
                $.notify({
                  message: "something went wrong!?!",icon:'fa fa-exclamation-triangle'
                },{type: "danger",placement:{align:"center"}});
            }
            $("button",thisFieldWrapper).prop("disabled",true).addClass("btn-outline-secondary").removeClass("btn-primary");
          }
          $(thisRow).nextAll("tr").first().find("input.js-input-custom-title").focus();
        }
    });

    //save button watcher
    $(".js-btn-save-custom-title").click(function() {
      var thisBtn = $(this);
      var thisRow = $(this).closest("tr");
      var thisField = $(".js-input-custom-title",thisRow);
      var itemId = $(thisRow).data("item-id");
      var customTitle = $(thisField).val();

      var operationResponse = updateCustomTitle({itemId:itemId,customTitle:customTitle});

      if (operationResponse) {
        if (operationResponse.error) {
          $.notify({
            message: operationResponse.error,icon:'fa fa-exclamation-triangle'
          },{type: "danger",placement:{align:"center"}});
        } else if (operationResponse.success) {
          $.notify({
            message: operationResponse.success,icon:'fa fa-check'
          },{type: "success",placement:{align:"center"}});
          $(thisField).val(operationResponse.customTitle);
          $(thisField).attr("value",operationResponse.customTitle);
        }
      } else {
          $.notify({
            message: "something went wrong!?!",icon:'fa fa-exclamation-triangle'
          },{type: "danger",placement:{align:"center"}});
      }      
      $(thisBtn).prop("disabled",true).addClass("btn-outline-secondary").removeClass("btn-primary");
    });



    /** 6.13.B open xml response viewer **/
    $(".js-btn-xml").click(function() {
      var asin = $(this).closest("tr").data("asin");
      var bbMessage;
      $.ajax({
        type: "POST",
        url: "functions.ajax.php",
        dataType: 'json',
        data: {action:"readXMLfiles",asin:asin},
        async: false,
        success: function(msgObj) {
          if (msgObj.error) {
            $.notify({
              message: msgObj.error,icon:'fa fa-exclamation-triangle'
            },{type: "danger",placement:{align:"center"}});
          } else {
            bbMessage = msgObj.bbMessage;
          }
        }
      });

      if (bbMessage) {
        var bbXMLfile = bootbox.dialog({title: "XML Response Files for <i>" + asin + "</i>",
          onEscape: true,
          message: bbMessage,
          className: "bb-w800",
          buttons: {
            "close" : { label: "Close", className : "btn-primary btn-close", callback: function() { bootbox.hideAll(); } },
          }
        }).bind('shown.bs.modal', function(){
          // $(".bb-btn-remove-review",bbRemoveReview).focus();
          // alert($(window).height());
          var preHeight = $(window).height() - 300;
          $("pre",this).attr("style","max-height:" + preHeight + "px;");

        }).init(function() {
          // $(".modal-dialog",this).addClass("modal-dialog-scrollable");
        });
      } else {
        return false;
      }

    });

  
  } //$(".table-adm-items").length)
}

  /** 6.14 grab data of multiple items from amazon **/
  var grabNowForm = $("form#grabAmazonItemDataNow");
  if (grabNowForm.length) {
    grabNowForm.submit(function() {
      var itemsImportNumber = $("select[name='itemsImportNumber']",grabNowForm).val();
      var intervalMS = $("select[name='intervalSeconds']",grabNowForm).val() * 1000;
      var itemsReadyToImport = parseInt($(".js-itemsReadyToImport").text());

      $(".alert").slideDown();
      currentItemNumber = 0;
      noAsin = 0;

      // itemsImportNumber = 5;

      $(".js-btn-submit",grabNowForm).prop("disabled",true);
      $(".js-btn-submit i",grabNowForm).addClass("fa-spinner fa-spin").removeClass("fa-bolt");

      var fetchItemDataLooper = setInterval(function() {
          currentItemNumber++;
          itemsReadyToImport--;


          $.ajax({
            type: "POST",
            url: "functions.ajax.php",
            dataType: 'json',
            data: {action:"fetchAnyItemData"},
            async: false,
            success: function(msgObj) {
              if (msgObj.error) {
                $.notify({
                  message: msgObj.error,icon:'fa fa-exclamation-triangle'
                },{type: "danger",placement:{align:"center"}});
                if (msgObj.noAsin) {
                  noAsin = 1;
                }
              } else if (msgObj.success) {
                var itemImage;

                if (msgObj.itemImgSrc) {
                  itemImage = "<img src='" + msgObj.itemImgSrc + "' class='img-fluid' alt='' />";
                } else {
                  itemImage = "<i class='fa fa-cube fa-border text-secondary bg-light fa-3x'></i>";
                }

                $(".js-grabbed-now-items").prepend("<div class='col-sm-2 align-self-end text-center p-2'>" +
                  "<a href='" + msgObj.itemStoreUrl + "' class='open-external'>" + 
                  itemImage + '<br />' + 
                  msgObj.asin + '</a></div>');

              }
              $(".js-itemsReadyToImport").text(itemsReadyToImport);
            }
          });

          
          if (currentItemNumber >= itemsImportNumber || noAsin) {
            clearInterval(fetchItemDataLooper)
            $(".js-btn-submit",grabNowForm).prop("disabled",false);
            $(".js-btn-submit i",grabNowForm).removeClass("fa-spinner fa-spin").addClass("fa-bolt");
            $(".alert").slideUp();
          }

      }, intervalMS);




      return false;
    });
  }
/****
 * 6. Product Management [-]
 ****/


/****
 * 7. Single Item administration [+]
 ****/
  /** 7.1. update items's product data **/
  var FadmItemProductData = $("form#FadmItemProductData");
  if (FadmItemProductData.length) {

    var multiSelectField = $(".form-control-multiselect-category");
    if (multiSelectField.length) {
      $(multiSelectField).multiselect({
        buttonClass: 'btn btn-outline-secondary text-left',
        templates: {
          li: '<li><a class="dropdown-item" tabindex="0" style=""><label style="display: block;padding-left:10px"></label></a></li>'
        },
        buttonWidth: '100%',
        numberDisplayed: 4,
        nonSelectedText: 'without any Category'
      });
    }

    //open personlized links
    $(".js-btn-open-amazon-personalized-link").click(function() {
      var url = $(this).data("url");
      $.ajax({
        type: "POST",
        url: "functions.ajax.php",
        dataType: 'json',
        data: {action:"placeholdersToAmzKeys", url:url},
        async: false,
        success: function(msgObj) {
          if (msgObj.url) {
            window.open(msgObj.url);
          } else {
            $.notify({
                message: "Something went wrong, no URL?",icon:'fa fa-exclamation-triangle'
              },{type: "danger",placement:{align:"center"}});
          }
        }
      });
      return false;
    });

    //load wysiwyg editor  
    var wysihtmlEditor = new wysihtml.Editor('wysihtml-features-div', {
      toolbar: 'wysihtml-features-toolbar',
      parserRules:  wysihtmlParserRules
    });

    wysihtmlEditor.on("change:composer", function() {
      $("#wysihtml-features-textarea").val(wysihtmlEditor.getValue());
    });
    FadmItemProductData.on("change keyup","textarea.wysihtml-source-view", function() {
      $("#wysihtml-features-textarea").val($(this).val());
    });
    wysihtmlEditor.on("change_view", function() {
      if (wysihtmlEditor.currentView.name === "composer") { //pre-state
        $(".btn-wysihtml-change-view").addClass("btn-dark").removeClass("btn-outline-dark");
        $("#wysihtml-features-toolbar .btn").not(".btn-wysihtml-change-view").prop("disabled",true);
      } else {
        $(".btn-wysihtml-change-view").removeClass("btn-dark").addClass("btn-outline-dark");
        $("#wysihtml-features-toolbar .btn").not(".btn-wysihtml-change-view").prop("disabled",false);
      }
    });
    //enable save buttom - removed because of the editors behaviour
    // $("input,checkbox,textarea",FadmItemProductData).on("change keydown",function() {
    //   $("button[type='submit']",FadmItemProductData).prop("disabled",false);
    // });
    //show hide movie form data
    $(".js-show-hide-movie-form-data").click(function() {
      var movieDataWrapper = $(".movie-data-wrapper");
      var thisBtn = $(this);
      if ($(movieDataWrapper).is(":visible")) {
        $(movieDataWrapper).slideUp(400,function() {
          $(thisBtn).addClass("fa-angle-down").removeClass("fa-angle-up");
        });
        $(".hr-movie-line").fadeIn();
      } else {
        $(movieDataWrapper).slideDown(400,function() {
          $(thisBtn).addClass("fa-angle-up").removeClass("fa-angle-down");
        });      
        $(".hr-movie-line").fadeOut();
      }
    });

    //show hide amazon suggestion boxes
    $("input[type='checkbox']#cb_show_amz_suggestions").change(function() {
      var thisState = $(this).is(":checked");
      if (thisState) {
        $(".form-group-amazon-suggestions").slideDown();
        $(".js-amz-link-state").fadeIn();
      } else {
        $(".form-group-amazon-suggestions").slideUp();
        $(".js-amz-link-state").fadeOut();      
      }
    });
    var updateAmzLinkState = function() {
      if ($("input[name='link_amz_suggestions_to_amz']:checked").val() == 1) {
        $(".js-amz-link-state").text($(".js-amz-link-state").data("descr-on"));
      } else {
        $(".js-amz-link-state").text($(".js-amz-link-state").data("descr-off"));
      }
    }
    updateAmzLinkState();
    $("input[name='link_amz_suggestions_to_amz']").change(function() {
      updateAmzLinkState();
    });

    //handle video trailers
    $("input[name='video_url']").on("change keyup", function() {
      var videoUrl = $(this).val();
      var thisBtn = $(".js-btn-open-trailer-link",$(this).closest(".input-group"));
      if (videoUrl.match(/^https?:\/\/(www\.)?youtu/)) {
        $(thisBtn).prop("disabled",false).addClass("btn-youtube").removeClass("btn-secondary btn-vimeo");
      } else if (videoUrl.match(/^https?:\/\/(www\.)?vimeo/)) {
        $(thisBtn).prop("disabled",false).addClass("btn-vimeo").removeClass("btn-secondary btn-youtube");
      } else {
        $(thisBtn).prop("disabled",true).addClass("btn-secondary").removeClass("btn-youtube btn-vimeo");
      }
    });
    //open personlized links
    $(".js-btn-open-trailer-link").click(function() {
      var url = $("input[name='video_url']").val();
      if (url) {
        window.open(url);
      }
      return false;
    });
  }


  /** 7.2 update produt details/editorial reviews **/
    var FadmItemProductReview = $("form.FadmItemProductReview");
    if (FadmItemProductReview.length) {

      //show success??
      var showSucc = getGetVars(location.href,"showSucc");
      if (showSucc == "addedReview") {
        $.notify({
          message: "The editorial product review has been created successfully.", icon:'fa fa-check'
        },{type: "success",placement:{align:"center"}});
      }

    /** 7.2.1 create wysiwyg editor instances **/
      var wysihtmlEditors = new Array();
      $(FadmItemProductReview).each(function() {
        var thisCard = $(this).closest(".card");
        var newItem = $(thisCard).data("new-item");
        var reviewId = $(thisCard).data("review-id");
        wysihtmlEditors["review" + reviewId] = new wysihtml.Editor('wysihtml-review-div-' + reviewId, {
          toolbar: 'wysihtml-review-toolbar-' + reviewId,
          parserRules:  wysihtmlParserRules
        }).on("load", function() {
          if (newItem) {
            $(".card-header",thisCard).hide();
            $(thisCard).prepend('<h5 class="card-header">Add new Editorial Review/Product Details</h5>');
            $(".form-control-plaintext",thisCard).removeClass("form-control-plaintext").addClass("form-control").prop("readonly",false);
            $('#wysihtml-review-toolbar-' + reviewId).slideDown();
            $('.card-footer',thisCard).slideDown();
          } else {
            wysihtmlEditors["review" + reviewId].disable();
          }
        });
        wysihtmlEditors["review" + reviewId].on("change:composer", function() {
          $("#wysihtml-review-textarea-" + reviewId).val(wysihtmlEditors["review" + reviewId].getValue());
        });
        $("body").on("change keyup",".card[data-review-id='" + reviewId + "'] textarea.wysihtml-source-view", function() {
          $("#wysihtml-review-textarea-" + reviewId).val($(this).val());
        });
        wysihtmlEditors["review" + reviewId].on("change_view", function() {
          // alert(wysihtmlEditors["review" + reviewId].currentView.name);
          if (wysihtmlEditors["review" + reviewId].currentView.name === "composer") { //pre-state
            $(".btn-wysihtml-change-view",thisCard).addClass("btn-dark").removeClass("btn-outline-dark");
            $("#wysihtml-review-toolbar-" + reviewId + " .btn").not(".btn-wysihtml-change-view").prop("disabled",true);
          } else {
            $(".btn-wysihtml-change-view",thisCard).removeClass("btn-dark").addClass("btn-outline-dark");
            $("#wysihtml-review-toolbar-" + reviewId + " .btn").not(".btn-wysihtml-change-view").prop("disabled",false);
          }
        });

      });


    /** 7.2.2 enable/disable edit function **/
      $(".js-btn-edit-review").click(function() {
        var thisCard = $(this).closest(".card");
        var thisBtn = $(this);
        var asin = $(thisCard).data("asin");
        var reviewId = $(thisCard).data("review-id");
   
        if ($(thisBtn).hasClass("active")) {
          $(thisBtn).removeClass("active");
          $(".nav-review-options button",thisCard).not(thisBtn).prop("disabled",false);
          $(".form-control",thisCard).removeClass("form-control").addClass("form-control-plaintext").prop("readonly",true);
          if (wysihtmlEditors["review" + reviewId].currentView == 'source') {
              wysihtmlEditors["review" + reviewId].fire('change_view', 'composer');
          }
          wysihtmlEditors["review" + reviewId].disable();
          $('#wysihtml-review-toolbar-' + reviewId).slideUp();
          $('.card-footer',thisCard).slideUp();
          disReviewPosButtons();
        } else {
          $(thisBtn).addClass("active");
          $(".nav-review-options button",thisCard).not(thisBtn).prop("disabled",true);
          $(".form-control-plaintext",thisCard).removeClass("form-control-plaintext").addClass("form-control").prop("readonly",false);
          wysihtmlEditors["review" + reviewId].enable();
          $('#wysihtml-review-toolbar-' + reviewId).slideDown();
          $('.card-footer',thisCard).slideDown();
        }
        return false;
      });

    /** 7.2.3 save form data **/
      FadmItemProductReview.submit(function() {
        var thisCard = $(this).closest(".card");
        var thisBtn = $(this);
        var asin = $(thisCard).data("asin");
        var reviewId = $(thisCard).data("review-id");
        var thisLocation = $("input[name='location']",thisCard).val();

        var source = $("input[name='source']",thisCard).val();
        var review = $("textarea[name='review']",thisCard).val();

        $.ajax({
          type: "POST",
          url: "functions.ajax.php",
          dataType: 'json',
          data: {action:"saveProductReview", asin:asin, reviewId:reviewId, source:source, review:review},
          async: false,
          success: function(msgObj) {
            if (msgObj.error) {
              $.notify({
                message: msgObj.error,icon:'fa fa-exclamation-triangle'
              },{type: "danger",placement:{align:"center"}});
            } else if (msgObj.success) {
              if (msgObj.newReviewId) {
                location.href = thisLocation + "&showSucc=addedReview";
              } else {
                $.notify({
                  message: msgObj.success ,icon:'fa fa-check'
                },{type: "success",placement:{align:"center"}});

                $(".js-btn-edit-review",thisCard).removeClass("active");
                $(".nav-review-options button",thisCard).prop("disabled",false);
                $(".form-control",thisCard).removeClass("form-control").addClass("form-control-plaintext").prop("readonly",true);
                if (wysihtmlEditors["review" + reviewId].currentView == 'source') {
                    wysihtmlEditors["review" + reviewId].fire('change_view', 'composer');
                }
                wysihtmlEditors["review" + reviewId].disable();
                $('#wysihtml-review-toolbar-' + reviewId).slideUp();
                $('.card-footer',thisCard).slideUp();
                $(".successBox",thisCard).fadeIn(400,function() {
                  setTimeout(function(){
                    $(".successBox",thisCard).fadeOut();
                  }, 1500); // milliseconds
                });
              }
            }
          }
        });
        return false;
      });

    /** 7.2.4 remove editorial reviews **/
      $(".js-btn-remove-review").click(function() {
        var thisCard = $(this).closest(".card");
        var reviewId = $(thisCard).data("review-id");
        var asin = $(thisCard).data("asin");

        $(thisCard).addClass("border-danger");

        var bbRemoveReview = bootbox.confirm({
          message: "<h4>Are you sure to delete this editorial review?</h4>These cannot be undone.",
          closeButton: false,
          buttons: {
              confirm: {
                  label: 'Remove Review',
                  className: 'btn-danger bb-btn-remove-review'
              },
              cancel: {
                  label: 'Cancel',
                  className: 'btn-secondary'
              }
          },
          callback: function (confirmed) {
            if (confirmed) {
              $.ajax({
                type: "POST",
                url: "functions.ajax.php",
                dataType: 'json',
                data: {action:"removeEditorialReview",reviewId:reviewId, asin:asin},
                async: false,
                success: function(msgObj) {
                  if (msgObj.error) {
                    $.notify({
                      message: msgObj.error,icon:'fa fa-exclamation-triangle'
                    },{type: "danger",placement:{align:"center"}});
                  } else if (msgObj.success) {
                    $.notify({
                      message: msgObj.success ,icon:'fa fa-check'
                    },{type: "success",placement:{align:"center"}});
                    $(thisCard).fadeOut(400,function(){
                      $(this).remove();
                      disReviewPosButtons();
                    });
                  }
                }
              });
            } else {
              $(thisCard).removeClass("border-danger");
            }
          }
        }).bind('shown.bs.modal', function(){
          $(".bb-btn-remove-review",bbRemoveReview).focus();
        });
        return false;
      });


    /** 7.2.5 Positioning of Reviews **/
      function disReviewPosButtons() {
        $(".js-btn-pos-review",".review-cards-holder").prop("disabled",false);
        $(".js-btn-pos-review:first,.js-btn-pos-review:last",".review-cards-holder").prop("disabled",true);
      }
      disReviewPosButtons();

      //positioning reviews
      $(".js-btn-pos-review").click(function() {
        var thisCard = $(this).closest(".card");
        var reviewId = $(thisCard).data("review-id");
        var asin = $(thisCard).data("asin");
        var dir = $(this).data("dir");

        $.ajax({
            type: "POST",
            url: "functions.ajax.php",
            dataType: 'json',
            data: {action:"positionEditorialReview",reviewId:reviewId, dir:dir},
            async: false,
            success: function(msgObj) {
              $(thisCard).fadeOut(200,function() {
                if (dir == "up") {
                  $(thisCard).prev().before($(thisCard));
                } else if (dir == "down") {
                  $(thisCard).next().after($(thisCard));
                }
                disReviewPosButtons();
                $(thisCard).fadeIn();
              });
            }
        });
      });

  }
/****
 * 7. Single Item administration [-]
 ****/




/****
 * 8. Language Administration [+]
 ****/
  /** 8.1 setup datatables **/
  var langTable = $("table#langTable");
  if (langTable.length) {
    $(".js-btn-group-form",langTable).hide();

    //add datatables css
    $('<link/>', {
      rel: 'stylesheet',
      type: 'text/css',
      href: 'css/datatables.min.css'
    }).appendTo('head');

    var dataTableLang = langTable.DataTable({
      "processing": true,
      "serverSide": true,
      "ajax": {
        url: "data.table.lang.php",
        data: function ( d ) {
          d.lang_key = $(langTable).data("lang-key");
        }
      },
      createdRow: function(row, data, dataIndex) {
          // var a = $(row).find('td:eq(1)').html();
          $(row).attr("data-lang-id",data.id);

          var cell1 = $(row).find('td:eq(0)');
          cell1.addClass("text-right pt-2");

          var cell4 = $(row).find('td:eq(3)');
          cell4.addClass("text-right align-bottom");

      },

       "columns": [
            { "data": "id" },
            { "data": null,
              render: function(data, row, type) {
                return "<input type='text' class='form-control-sm form-control-plaintext' value='" + data.short_key + "' readonly='readonly' name='short_key' />";
              } 
            },
            { "data": null, 
              render: function(data, type, row) {
                return "<textarea class='form-control-sm form-control-plaintext' readonly='readonly' name='descr'>" + data.descr + "</textarea>";
              }
            },
            { "data": null, 
              render: function() {
                return "<div class='btn-group btn-group-sm js-btn-group-tools'>" +
                  "<button type='button' class='btn btn-outline-primary js-btn-edit-langitem'><i class='fa fa-pencil fa-fw'></i></button>" + 
                  "<button type='button' class='btn btn-danger js-btn-remove-langitem'><i class='fa fa-times fa-fw'></i></button>" +
                "</div>" +
                "<div class='btn-group btn-group-sm js-btn-group-form'>" +
                  "<button type='button' class='btn btn-outline-primary js-btn-save-langitem'><i class='fa fa-save fa-fw'></i></button>" +
                  "<button type='button' class='btn btn-outline-dark js-btn-close-edit-form'><i class='fa fa-times fa-fw'></i></button>" +
                "</div>";
              }
            },
        ],
      "columnDefs": [
        { searchable: false, "targets": [ 0,-1 ] },
        { orderable: false, "targets": [ -1 ] }
      ],
      // initComplete: function() {
      drawCallback: function() {
        $(".js-btn-group-form",langTable).hide();
      }
    });

  /** 8.2 remove lang item **/
    $(langTable).on("click",".js-btn-remove-langitem",function() {
      var thisRow = $(this).closest("tr");
      var langId = $(thisRow).data("lang-id"); 
      
      $(thisRow).addClass("table-danger");

      var bbMessage = "<h4>Are you sure to delete this language item?</h4>" +
        // "<div class='alert alert-sm alert-info mt-3'>All corresponding short_keys from the other languages will be removed too.</div>" +
        "This cannot be undone but the key will be rebuild automatically when used anywhere in code.";
      
      var bbRemoveLangItem = bootbox.confirm({
        message: bbMessage,
        closeButton: false,
        buttons: {
            confirm: {
                label: 'Remove Item',
                className: 'btn-danger bb-btn-remove-langItem'
            },
            cancel: {
                label: 'Cancel',
                className: 'btn-secondary'
            }
        },
        callback: function (confirmed) {
          if (confirmed) {
            $.ajax({
              type: "POST",
              url: "functions.ajax.php",
              dataType: 'json',
              data: {action:"removeLanguageEntry",langId:langId},
              async: false,
              success: function(msgObj) {
                if (msgObj.error) {
                  $.notify({
                    message: msgObj.error,icon:'fa fa-exclamation-triangle'
                  },{type: "danger",placement:{align:"center"}});
                } else if (msgObj.success) {
                  $.notify({
                    message: msgObj.success ,icon:'fa fa-check'
                  },{type: "success",placement:{align:"center"}});
                  
                  setTimeout(function() {
                    $(thisRow).fadeOut(function() {
                      dataTableLang.row(thisRow).remove().draw();
                    });
                  }, 1000);
                }
              }
            });
          } else {
            $(thisRow).removeClass("table-danger");
          }
        }
      }).bind('shown.bs.modal', function(){
        $(".bb-btn-remove-langItem",bbRemoveLangItem).focus();
      });
    });

    $(langTable).on("dblclick","input.form-control-plaintext,textarea.form-control-plaintext",function() {
      var thisRow = $(this).closest("tr");
      $(".js-btn-edit-langitem",thisRow).trigger("click");
      return false;      
    });

  /** 8.3 edit lang item **/
    $(langTable).on("click",".js-btn-edit-langitem",function() {
      var thisRow = $(this).closest("tr");
      $(".js-btn-group-tools",thisRow).fadeOut(400,function() {
        $(".js-btn-group-form",thisRow).fadeIn();
        $("textarea,input",thisRow).removeClass("form-control-plaintext").addClass("form-control").attr("readonly",false);
      });
      $("input[name='short_key']",thisRow).on("keydown",function(e) {
        if (e.keyCode == 13) { //Enter Key
          $(".js-btn-save-langitem",thisRow).trigger("click");
          return false;
        }
      });
      $("input,textarea",thisRow).on("keydown",function(e) {
        if (e.keyCode == 27) { //ESC Key
          $(".js-btn-close-edit-form",thisRow).trigger("click");
          $("input,textarea",thisRow).blur();
          return false;
        }
      });
      return false;
    });

  /** 8.4 save lang item changes **/
    $(langTable).on("click",".js-btn-save-langitem",function() {
      var thisRow = $(this).closest("tr");
      var langId = $(thisRow).data("lang-id"); 
      var langShortKey = $("input[name='short_key']",thisRow).val();
      var langDescr = $("textarea[name='descr']",thisRow).val();
      var langKey = $(langTable).data("lang-key");

      $.ajax({
        type: "POST",
        async: false,
        dataType: "json",
        url: "functions.ajax.php",
        data: {action:"editLanguageEntry", langId:langId, langShortKey:langShortKey, langDescr:langDescr, langKey:langKey},
        success: function(msgObj) {
          if(msgObj.success) {
            $(".js-btn-group-form",thisRow).fadeOut(400,function() {
              $(".js-btn-group-tools",thisRow).fadeIn();
              $("textarea,input",thisRow).addClass("form-control-plaintext").removeClass("form-control").attr("readonly",true);

              $("input[name='short_key']",thisRow).attr("value",msgObj.langShortKey);
              $("textarea[name='descr']",thisRow).text(msgObj.langDescr);

              $("input[name='short_key']",thisRow).closest("td").data("order",msgObj.dataOrderShortKey);
              $("textarea[name='descr']",thisRow).closest("td").data("order",msgObj.dataOrderLangDescr);
              
              $("input[name='short_key']",thisRow).val(msgObj.langShortKey);
              $("textarea[name='descr']",thisRow).val(msgObj.langDescr);

              //doesn't work as expected???
              // dataTableLang.row(thisRow).invalidate('dom').draw();
              dataTableLang.cell($("textarea[name='descr']",thisRow).closest("td")).invalidate('dom').draw();
            });

            $.notify({
                message: msgObj.success ,icon:'fa fa-check'
            },{type: "success",placement:{align:"center"}});

          } else if (msgObj.error) {
            $.notify({
              message: msgObj.error ,icon:'fa fa-exclamation-triangle'
            },{type: "danger",placement:{align:"center"}});
          }
        }
      }); 
      return false;
    });
    //exit lang edit form
    $(langTable).on("click",".js-btn-close-edit-form",function() {
      var thisRow = $(this).closest("tr");
      $(".js-btn-group-form",thisRow).fadeOut(400,function() {
        $(".js-btn-group-tools",thisRow).fadeIn();
        $("textarea,input",thisRow).addClass("form-control-plaintext").removeClass("form-control").attr("readonly",true);
        $("input",thisRow).val($("input",thisRow).attr("value"));
        $("textarea",thisRow).val($("textarea",thisRow).text());
      });
      return false;
    });
  }
  /** 8.5 add completely new language **/
  var btnAddLanguage = $(".js-btn-add-language");
  if (btnAddLanguage.length) {
    $(btnAddLanguage).click(function() {
      //get languages
      var languageOptions;
      $.ajax({
        type: "POST",
        url: "functions.ajax.php",
        dataType: 'json',
        data: {action:"getLanguages"},
        async: false,
        success: function(msgObj) {
          $.each(msgObj.languages, function(key,val) {
            languageOptions += "<option value='" + val + "'>" + val + "</option>";
          });
        }
      });

      var bbMessage = '<div class="alert alert-danger js-hide"></div>'+
        '<div class="form-horizontal mb0 pb0 mt10">' +

          '<div class="form-group row">' +
            '<label class="control-label col-sm-4">new language key</label>' +
            '<div class="col-sm-4">' +
              '<input type="text" name="langKey" value="" maxlength="5" class="form-control" placeholder="five digits min" required="required" />' +
            '</div>' +
          '</div>' +

          '<hr /><div class="form-group row">' +
            '<label class="control-label col-sm-4">copy values from</label>' +
            '<div class="col-sm-4">' +
              '<select name="langCopyBaseKey" class="form-control">' + languageOptions + '</select>' +
            '</div>' +
          '</div>' +

        '</div>';


      var bbAddLanguage = bootbox.dialog({title: "Add new Language",
        onEscape: true,
        message: bbMessage,
        // className: "bb-w800",
        buttons: {
          "save" : { label: "Add Language", className : "btn-primary btn-submit dont-focus", 
            callback: 
              function() {
                var PROCEED = true; 
                $(".alert",bbAddLanguage).fadeOut();      
                var langKey = $("input[name='langKey']",bbAddLanguage).val();
                var langCopyBaseKey = $("select[name='langCopyBaseKey']",bbAddLanguage).val();

               $.ajax({
                  type: "POST",
                  url: "functions.ajax.php",
                  dataType: 'json',
                  data: {action:"addNewLanguage", langKey:langKey, langCopyBaseKey:langCopyBaseKey},
                  async: false,
                  success: function(msgObj) {
                    if (msgObj.error) {
                      $(".alert.alert-danger",bbAddLanguage).html(msgObj.error).fadeIn();      
                      PROCEED = false; 
                      return false;
                    } else if (msgObj.success) {
                      var navItemBase = $(".hidden-content .langNavItem").html();
                      navItemBase = navItemBase.replace(/\[LANGKEY\]/g,langKey);
                      navItemBase = navItemBase.replace(/\[CLASS_ACTIVE\]/,'');

                      $(".language-keys-nav").append(navItemBase);

                      $.notify({
                        message: msgObj.success,icon:'fa fa-check'
                      },{type: "success",placement:{align:"center"}});
                    }
                  }
              });
              return PROCEED;
            } 
          },
          "cancel" : { label: "Cancel", className : "btn-default btn-close", callback: function() { bootbox.hideAll(); } },
        }
      }).bind('shown.bs.modal', function(){
        //autosubmit
        $("input[name='langKey']",bbAddLanguage).on("keydown",function(e) {
          if (e.keyCode == 13) { //Enter Key
            $(".btn-submit",bbAddLanguage).trigger("click");
            return false;
          }
        });
        $("input[name='langKey']",bbAddLanguage).focus();
      });
      return false;
    });

  }

  /** 8.6 remove whole Language **/
  var btnRemoveLanguage = $(".js-btn-remove-language");
  if (btnRemoveLanguage.length) {

    $(btnRemoveLanguage).click(function() {
      var langKey = $(this).data("lang-key");

      var bbRemoveLang = bootbox.confirm({
        message: "<h4>Are you sure to delete this language?</h4><div class='alert alert-sm alert-info mt-3'>All items of this language will be removed.</div>This cannot be undone but feel free to add any language.",
        closeButton: false,
        buttons: {
            confirm: {
                label: 'Remove Language',
                className: 'btn-danger bb-btn-remove-lang'
            },
            cancel: {
                label: 'Cancel',
                className: 'btn-secondary'
            }
        },
        callback: function (confirmed) {
          if (confirmed) {
            $.ajax({
              type: "POST",
              url: "functions.ajax.php",
              dataType: 'json',
              data: {action:"removeLanguage",langKey:langKey},
              async: false,
              success: function(msgObj) {
                if (msgObj.error) {
                  $.notify({
                    message: msgObj.error,icon:'fa fa-exclamation-triangle'
                  },{type: "danger",placement:{align:"center"}});
                } else if (msgObj.success) {
                  $.notify({
                    message: msgObj.success ,icon:'fa fa-check'
                  },{type: "success",placement:{align:"center"}});
                  
                  $(".language-keys-nav a[data-lang-key='" + langKey + "']").fadeOut();
                  $(btnRemoveLanguage).fadeOut();
                  $("p.sectionIntro").addClass("alert alert-success").html("<i class='fa fa-check'></i> Language removed");


                  $("table#langTable").fadeOut(400,function() {
                    dataTableLang.destroy();
                  });
                }
              }
            });
          }
        }
      });
    });
  } //btn-remove-language

  /** 8.7 import new lang keys **/
  $(".js-btn-copy-lang-key,.js-btn-add-lang-key").click(function() {
    var thisBtn = $(this);
    var langId = $(this).data("lang-id");
    var langKey = $("table#langTable").data("lang-key");

    var langData;
    if (langId) {
      $.ajax({
        type: "POST",
        url: "functions.ajax.php",
        dataType: 'json',
        data: {action:"getSingleLangShortKeyData", langId: langId},
        async: false,
        success: function(msgObj) {
          if (msgObj.error) {
            langId = 0;    
          } else if (msgObj.langData) {
            langData = msgObj.langData;
          }
        }
      });
    }
  
    var bbMessage = '<div class="alert alert-danger js-hide"></div>'+
      '<div class="form-horizontal mb0 pb0 mt10">' +
        '<div class="form-group row">' +
          '<label class="control-label col-sm-3">Short Key</label>' +
          '<div class="col-sm-5">' +
            '<input type="text" name="short_key" value="" class="form-control" placeholder="short and unique identifier" required="required" />' +
          '</div>' +
        '</div>' +

        '<div class="form-group row">' +
          '<label class="control-label col-sm-3">Text to display/Translation</label>' +
          '<div class="col-sm-9">' +
            '<em class="text-secondary small">use {a:x} for arguments, where x is the number of the argument, equal behaviour to PHP\'s <code>sprintf</code></em><br />' +
            '<textarea name="descr" class="form-control" rows="4" placeholder="HTML allowed" /></textarea>' +
          '</div>' +
        '</div>' +

      '</div>';

    var bbEditLang = bootbox.dialog({title: langId ? "Import Language Key" : "Add Language Key",
      onEscape: true,
      message: bbMessage,
      className: "bb-w800",
      buttons: {
        "save" : { label: langId ? "Import Language Key" : "Add Language Key", className : "btn-primary btn-submit dont-focus", 
          callback: 
            function() { 
              $(".alert",bbEditLang).fadeOut();
              $(thisBtn).fadeOut(); 
              var langShortKey = $("input[name='short_key']",bbEditLang).val();
              var langDescr = $("textarea[name='descr']",bbEditLang).val();

              $(thisBtn).fadeOut();


              // var newNode = dataTableLang.row.add({id: "12", short_key: "buy", descr: "yeaj", tools: "new"}).node();
              // $(newNode).attr("data-lang-id", "12345");

              $.ajax({
                type: "POST",
                url: "functions.ajax.php",
                dataType: 'json',
                data: {action:"editLanguageEntry", langShortKey:langShortKey, langDescr:langDescr, langKey:langKey},
                async: false,
                success: function(msgObj) {
                  if (msgObj.error) {
                    $(".alert.alert-danger",bbEditLang).html(msgObj.error).fadeIn();      
                    return false;
                  } else if (msgObj.success) {
                    // dataTableLang.draw();
                    dataTableLang.order([0, 'desc']).draw();

                  }
                }
              });


            } 
        },
        "cancel" : { label: "Cancel", className : "btn-default btn-close", callback: function() { bootbox.hideAll(); } },
      }
    }).bind('shown.bs.modal', function(){
      if (langData) {
        $("textarea[name='descr']",bbEditLang).val(langData.descr);
        $("input[name='short_key']",bbEditLang).val(langData.short_key).attr("readonly",true);
      }
      //autosubmit
      $("input[name='descr']",bbEditLang).on("keydown",function(e) {
        if (e.keyCode == 13) { //Enter Key
          $(".btn-submit",bbEditLang).trigger("click");
          return false;
        }
      });
      $("input[name='descr']",bbEditLang).focus();
    });
    return false;
  });


/****
 * 8. Language Administration [-]
 ****/



/****
 * 9. Error Log Handling [+]
 ****/
  if ($(".list-group-error-log").length) {
    /** 9.1 show/hide error_log entries **/
    $("li[data-loggroup]").hide();
    $(".js-btn-toggle-logitems-view").click(function() {
      var logGroup = $(this).data("loggroup-target");
      var thisBtn = $(this);
      $("i",thisBtn).toggleClass("fa-chevron-down fa-chevron-up");
      $("li[data-loggroup='" + logGroup + "']").slideToggle(400,function() {
        if ($(this).is(":visible")) {
          $("span",thisBtn).text($(thisBtn).data("text-less"));
        } else {
          $("span",thisBtn).text($(thisBtn).data("text-more"));
        }
      });
    });

    /** 9.2 remove set of error_log entries **/
    $(".js-btn-remove-logitems").click(function() {
      var logGroup = $(this).data("loggroup-delkey");
      var thisListItem = $(this).closest("li.list-group-item");
      $.ajax({
        type: "POST",
        async: false,
        dataType: "json",
        url: "functions.ajax.php",
        data: {action:"removeLogEntries", logGroup:logGroup},
        success: function(msgObj) {
          if(msgObj.success) {
            $("li[data-loggroup='" + logGroup + "']").fadeOut(400,function() {
              $(this).remove();
            });
            $(thisListItem).fadeOut(400,function() {
              $(this).remove();
              if ($("ul.list-group-error-log li").length === 0) {
                $("ul.list-group-error-log").fadeOut();
                $(".alert-no-log-entries").fadeIn();
              }
            });
            $.notify({
                message: msgObj.success ,icon:'fa fa-check'
            },{type: "success",placement:{align:"center"}});
          } else if (msgObj.error) {
            $.notify({
              message: msgObj.error ,icon:'fa fa-exclamation-triangle'
            },{type: "danger",placement:{align:"center"}});
          }
        }
      }); 
    });

    /** 9.3 empty error log **/
    $(".js-btn-empty-error-log").click(function() {
      var thisBtn = $(this);
      var bbEmptyErrorLog = bootbox.confirm({
        message: "<h4>Are you sure to delete all error log entries?</h4><div class='alert alert-sm alert-info mt-3'>This cannot be undone.",
        closeButton: false,
        buttons: {
            confirm: {
                label: 'Remove all log entries',
                className: 'btn-danger'
            },
            cancel: {
                label: 'Cancel',
                className: 'btn-secondary'
            }
        },
        callback: function (confirmed) {
          if (confirmed) {
            $.ajax({
              type: "POST",
              url: "functions.ajax.php",
              dataType: 'json',
              data: {action:"emptyErrorLog"},
              async: false,
              success: function(msgObj) {
                if (msgObj.error) {
                  $.notify({
                    message: msgObj.error,icon:'fa fa-exclamation-triangle'
                  },{type: "danger",placement:{align:"center"}});
                } else if (msgObj.success) {
                  $.notify({
                    message: msgObj.success ,icon:'fa fa-check'
                  },{type: "success",placement:{align:"center"}});
                  bootbox.hideAll();
                  $(".list-group.list-group-error-log").slideUp(400,function() {
                    $(".alert-no-log-entries").fadeIn();
                    $(thisBtn).fadeOut();
                  });
                }
              }
            });
          }
        }
      });
    });
  } //.list-group-error-log

  // 9.4 enable/disable error logging
  var errLogForm = $("form#FconfigErrorLog");
  if (errLogForm.length) {

    $("input[type='checkbox']#cb_log_errors").change(function() {
      var thisState = $(this).is(":checked") ? 1 : 0;

      $(".F-alert",errLogForm).empty().removeClass("alert-success alert-danger").slideUp();
      var successBox = $(".success-box",errLogForm);

      $.ajax({
       type: "POST",
        async: false,
        dataType: "json",
        url: "functions.ajax.php",
        data: {action:"updateErrorLogConfig", log_errors:thisState},
        success: function(msgObj) {
          if(msgObj.success) {
            $(successBox).fadeIn(400,function() {
              setTimeout(function(){
                $(successBox).fadeOut();
              }, 1500); // milliseconds
            });
          } else if (msgObj.error) {
            $(".F-alert",errLogForm).html(msgObj.error).addClass("alert-danger").slideDown();
          }
        }
      });      
      return false;
    });
  };
/****
 * 9. Error Log Handling [-]
 ****/

/****
 * 10. help/manual section [+]
 ****/
 // 10.1 display inline help

  $("*[data-help-text]").each(function() {
    $(this).popover({
      content: $(this).data("help-text"),
      placement: $(this).data("placement") ?  $(this).data("placement") : "auto",
      html: true,
      trigger: "manual"
    });
  });

 
 $(".js-help").click(function() {
    var helpsection = $(this).data("helpsection");

    var backdrop = $("<div>");
    $(backdrop).appendTo("body").addClass("modal-backdrop fade").fadeTo(400,.75);

    $("*[data-help-text]:visible",".helpsection-" + helpsection).each(function() {
      if ($(this).is(":visible")) {
        $(this).css("z-index",1041).addClass("bg-light border border-secondary");
        $(this).popover('show');
        // alert($(this).prop("tagName") + "." + $(this).attr("class") + ":" + $(this).css("z-index"));
      }
    });

    $(backdrop).click(function(e) {
      if (e.target !== e.currentTarget) {
        return;
      } else {
        $(backdrop).fadeOut(400,function() {
          $("*[data-help-text]:visible").popover('hide').css("z-index","auto").removeClass("bg-light border border-secondary");
          $(this).remove();
        });
      }
    });
 });


/****
 * 10. help/manual section [-]
 ****/





});
