/***************
 * zStore 1.20 root frontend JS
 *  April 11th 2019
 *  https://codecanyon.net/item/zstore-an-amazon-affiliate-store/22713029
 ***************
 *  1. Misc
 *  1.1 open links in new window without using deprecated/unsupported attribute target=...
 *  1.2 tooltips class
 *  1.3 object dumper for dev purposes
 *  1.4 in_array function definition (not needed now)
 *  1.5 get variables from GET-URL (not needed now)
 *  2. add select behaviour to button dropdowns (needed i.e. for the categories in Search Bar)
 *  3. replace url in browser's address bar if needed
 *  4. zStore Cart operations
 *  4.1 add item to cart
 *  4.2 remove item from cart
 *  4.3 empty cart
 *  4.4 change number of items in cart
 *  5. zStore favorites operations
 *  5.1 add to favs
 *  5.2 remove item from favs on item page
 *  5.3 remove item from favorites page
 *  6. variation selector
************/


jQuery(document).ready(function() {

/****
 * 1. Misc [+]
 ****/

  /** 1.1 open links in new window without using deprecated/unsupported attribute target=... **/
  $("body").on("click","a.open-external", function() {
  	window.open($(this).attr("href"));
  	return false;
  });

  /** 1.2 tooltips class **/
  $('.tt').tooltip();

  /** 1.3 object dumper for dev purposes **/
  function dump(obj) {
    var op = '';
    for (var i in obj) {
        op += i + ": " + obj[i] + "\n";
    }
   alert(op);
  }

  /** 1.4 in_array function definition (not needed now) **/
  function in_array(needle,arr) {
    for(i=0;i<arr.length;i++) {
      if (needle == arr[i]) {
        return true;
      }
    }
    return false;
  }

  /** 1.5 get variables from GET-URL (not needed now) **/
  function getGetVars(url,varName){
    var urlA = url.split("?"); 
    var vars = urlA[1].split("&"); 
    for (var i=0;i<vars.length;i++) {   
          var pair = vars[i].split("=");
          //remove anchor
          if(pair[0] == varName) {
            return pair[1].replace(/#.*$/,'');
          }
     }
  }
/****
 * 1. Misc [-]
 ****/


/****
 * 2. add select behaviour to button dropdowns (needed i.e. for the categories in Search Bar) [+]
 ****/
  $(".js-dropdown-set-formval a").click(function() {
    var formval = $(this).data("formval");
    var thisDropdown = $(this).closest(".js-dropdown-set-formval");
    var formvalTarget = $(thisDropdown).data("formval-target");
    $("input[name='" + formvalTarget + "']").val(formval);
    //reset active ones
    // $(".js-dropdown-set-formval a i").not("[data-formval='" + formval + "']").removeClass("fa-check-square-o").addClass("fa-square-o");
    $(".js-dropdown-set-formval a i").removeClass("fa-check-square-o").addClass("fa-square-o");
    $(".js-dropdown-set-formval a").removeClass("active");
    $("i",this).removeClass("fa-square-o").addClass("fa-check-square-o");
    $(this).addClass("active");
    $(".js-dropdown-set-formval").parent("div").find(".js-btn-dropdown-show-formval").text($(this).text());
    $(this).closest('.dropdown-menu').dropdown("toggle");
    return false;
  });
/****
 * 2. add select behaviour to button dropdowns (needed i.e. for the categories in Search Bar) [-]
 ****/


/****
 * 3. replace url ín browser's address bar if needed [+]
 ****/
  var currentPath = $(".hidden-content input[name='currentPath']").val();
  if (currentPath) {
    if (window.location.pathname != currentPath) {
      window.history.replaceState(null, null, currentPath);
    }
  }
/****
 * 3. replace url ín browser's address bar if needed [-]
 ****/


/****
 * 4. zStore Cart operations [+]
 ****/
  /** 4.1 add item to cart **/
  $(".js-btn-add2cart").click(function() {
    var asin = $(this).data("asin");

    var pathPrefix = "../../";
    if ($(this).data("path-prefix")) {
      var pathPrefix = $(this).data("path-prefix");
    }

    $.ajax({
     type: "POST",
      async: false,
      dataType: "json",
      url: pathPrefix + "functions.ajax.php",
      data: {action:"add2cart", asin:asin},
      success: function(msgObj) {
        if(msgObj.success) {
          $(".badge.badge-cart-items-count").each(function() {
            $(this).text(parseInt($(this).text())+1).fadeIn();
          });
          $.notify({
            message: msgObj.success,icon:'fa fa-check'
          },{type: "success",placement:{align:"center"}});
        } else if (msgObj.error) {
          $.notify({
            message: msgObj.error,icon:'fa fa-exclamation-triangle'
          },{type: "danger",placement:{align:"center"}});
        }
      }
    });

    return false;
  });


  if ($(".table-shopping-cart").length) {
  
  /** 4.2 remove item from cart **/
    $(".js-btn-remove-item-from-cart").click(function() {
      var thisRow = $(this).closest("tr");
      var cartItemId = $(thisRow).data("cart-item-id");
      $.ajax({
        type: "POST",
        async: false,
        dataType: "json",
        url: "functions.ajax.php",
        data: {action:"removeFromCart", cartItemId:cartItemId},
        success: function(msgObj) {
          if(msgObj.success) {

            if (msgObj.itemsCount > 0) {
              //update table
              $(thisRow).fadeOut(400,function() {
                $(this).remove();
              });
              $(".table-shopping-cart .sum-subtotal").text(msgObj.subTotal);

              //update shopping cart link
              $(".badge.badge-cart-items-count").text(msgObj.itemsCount);

              $.notify({
                message: msgObj.success,icon:'fa fa-check'
              },{type: "success",placement:{align:"center"}});
            } else {
              $(".shopping-cart-wrapper").fadeOut(400,function() {
                $(".alert.alert-no-items-in-cart").fadeIn();
              });
              $(".badge.badge-cart-items-count").text(0).fadeOut();
            }
            $.notify({
              message: msgObj.success,icon:'fa fa-check'
            },{type: "success",placement:{align:"center"}});
          } else if (msgObj.error) {
            $.notify({
              message: msgObj.error,icon:'fa fa-exclamation-triangle'
            },{type: "danger",placement:{align:"center"}});
          }
        }
      });
      return false;
    });


  /** 4.3 empty cart **/
    $(".js-btn-empty-cart").click(function() {
      $.ajax({
        type: "POST",
        async: false,
        dataType: "json",
        url: "functions.ajax.php",
        data: {action:"emptyCart"},
        success: function(msgObj) {
          if(msgObj.success) {
            $(".shopping-cart-wrapper").fadeOut(400,function() {
              $(".alert.alert-no-items-in-cart").fadeIn();
            });
            $(".badge.badge-cart-items-count").text(0).fadeOut();
            $.notify({
              message: msgObj.success,icon:'fa fa-check'
            },{type: "success",placement:{align:"center"}});
          } else if (msgObj.error) {
            $.notify({
              message: msgObj.error,icon:'fa fa-exclamation-triangle'
            },{type: "danger",placement:{align:"center"}});
          }
        }
      });
      return false;
    });


  /** 4.4 change number of items in cart **/
    $(".js-btn-change-item-number").click(function() {
      $(this).prop("disabled",true);
      var thisBtn = $(this);
      var thisRow = $(this).closest("tr");
      var cartItemId = $(thisRow).data("cart-item-id");
      var quantity = parseInt($("input.item-number", thisRow).val());
      var method = $(this).data("method");

      if (method == "increase") {
        quantity += 1;
      } else {
        quantity -= 1;
      }

      $.ajax({
        type: "POST",
        async: false,
        dataType: "json",
        url: "functions.ajax.php",
        data: {action:"modifyCartItem", cartItemId:cartItemId, quantity:quantity},
        success: function(msgObj) {
          if(msgObj.success) {

            //still items in the cart?????
            if (msgObj.itemsCount > 0) {
              if (quantity > 0) {
                $("input.item-number", thisRow).val(quantity);
                $(".item-subtotal",thisRow).text(msgObj.itemSubTotal);
              } else {
                $(thisRow).fadeOut(400,function() {
                  $(this).remove();
                });
              }
              $(".table-shopping-cart .sum-subtotal").text(msgObj.subTotal);
              $(".badge.badge-cart-items-count").text(msgObj.itemsCount);
            } else {
              $(".shopping-cart-wrapper").fadeOut(400,function() {
                $(".alert.alert-no-items-in-cart").fadeIn();
              });
              $(".badge.badge-cart-items-count").text(0).fadeOut();
              
            }
            $.notify({
              message: msgObj.success,icon:'fa fa-check'
            },{type: "success",placement:{align:"center"}});
          } else if (msgObj.error) {
            $.notify({
              message: msgObj.error,icon:'fa fa-exclamation-triangle'
            },{type: "danger",placement:{align:"center"}});
          }
        }
      });

      setTimeout(function(){
        $(thisBtn).prop("disabled",false);
      }, 700); // milliseconds
      

      return false;
    
    });

  } //$(".table-shopping-cart").length

/****
 * 4. zStore Cart operations [-]
 ****/



/****
 * 5. zStore favorites operations [+]
 ****/
  /** 5.1 add to favs **/
  $("body").on("click",".js-btn-add2favs", function() {
    var thisBtn = $(this);
    var asin = $(this).data("asin");

    var pathPrefix = "../../";
    if ($(this).data("path-prefix")) {
      var pathPrefix = $(this).data("path-prefix");
    }

    $.ajax({
     type: "POST",
      async: false,
      dataType: "json",
      url: pathPrefix + "functions.ajax.php",
      data: {action:"add2favs", asin:asin},
      success: function(msgObj) {
        if(msgObj.success) {
          $(thisBtn).addClass("js-btn-remove-from-favs").removeClass("js-btn-add2favs").blur();


          //tooltip mod
          $(thisBtn).attr({"data-original-title":msgObj.newTitle});
          //button mod
          $("span",thisBtn).html($(thisBtn).data("btn-remove-title"));

          $(".js-btn-nav-favorites i").addClass("fa-heart").removeClass("fa-heart-o");
          $("i",thisBtn).addClass("fa-heart").removeClass("fa-heart-o");
          $.notify({
            message: msgObj.success,icon:'fa fa-check'
          },{type: "success",placement:{align:"center"}});
        } else if (msgObj.error) {
          $.notify({
            message: msgObj.error,icon:'fa fa-exclamation-triangle'
          },{type: "danger",placement:{align:"center"}});
        }
      }
    });

    return false;
  });

  /** 5.2 remove item from favs on item page **/
  $("body").on("click",".js-btn-remove-from-favs", function() {
    var thisBtn = $(this);
    var asin = $(this).data("asin");

    var pathPrefix = "../../";
    if ($(this).data("path-prefix")) {
      var pathPrefix = $(this).data("path-prefix");
    }

    $.ajax({
     type: "POST",
      async: false,
      dataType: "json",
      url: pathPrefix + "functions.ajax.php",
      data: {action:"removeFromFavs", asin:asin},
      success: function(msgObj) {
        if(msgObj.success) {
          $(thisBtn).removeClass("js-btn-remove-from-favs").addClass("js-btn-add2favs").blur();

          //tooltip mod
          $(thisBtn).attr({"data-original-title":msgObj.newTitle});
          //button mod
          $("span",thisBtn).html($(thisBtn).data("btn-add-title"));

          $("i",thisBtn).removeClass("fa-heart").addClass("fa-heart-o");
          if (msgObj.noFavorites) {
            $(".js-btn-nav-favorites i").removeClass("fa-heart").addClass("fa-heart-o");
          }
          $.notify({
            message: msgObj.success,icon:'fa fa-check'
          },{type: "success",placement:{align:"center"}});
        } else if (msgObj.error) {
          $.notify({
            message: msgObj.error,icon:'fa fa-exclamation-triangle'
          },{type: "danger",placement:{align:"center"}});
        }
      }
    });

    return false;
  });


  var grid = $(".row-cards.masonry-these-favorites");
  if (grid.length) {
    grid.imagesLoaded( function() {
      grid.masonry({
        itemSelector: '.card-holder',
        columnWidth: '.card-holder'
      });
    });
  }

  /** 5.3 remove item from favorites page **/
  $(".btn-rm-from-favs").click(function() {
    var thisContainer = $(this).closest(".card-holder");
    var asin = $(this).data("asin");

    $.ajax({
     type: "POST",
      async: false,
      dataType: "json",
      url: "functions.ajax.php",
      data: {action:"removeFromFavs", asin:asin},
      success: function(msgObj) {
        if(msgObj.success) {
          $(thisContainer).fadeOut(400,function() {
            $(this).remove();            
            grid.masonry('layout');
          });
          if (msgObj.noFavorites) {
            $(".js-btn-nav-favorites i").removeClass("fa-heart").addClass("fa-heart-o");
            $(".js-alert-no-favorites").fadeIn();
          } else {
          }
          $.notify({
            message: msgObj.success,icon:'fa fa-check'
          },{type: "success",placement:{align:"center"}});
        } else if (msgObj.error) {
          $.notify({
            message: msgObj.error,icon:'fa fa-exclamation-triangle'
          },{type: "danger",placement:{align:"center"}});
        }
      }
    });

    return false;
  });

/****
 * 5. zStore favorites operations [-]
 ****/


/****
 * 6.item variations selector [+]
 ****/
  var variationSelects = $("#variationSelects");
  if (variationSelects.length) {
    $("select",variationSelects).change(function() {
      var parent_asin = $(variationSelects).data("parent-asin");
      var attrName = $("option:selected",this).data("attr-name");
      var attrVal = $("option:selected",this).data("attr-val");
      var attr = attrName + ":" + attrVal;

      var variations = new Array();
      $("select",variationSelects).each(function() {
        var selOption = $("option:selected",this);
        variations.push(
          {name: selOption.data("attr-name"),val: selOption.data("attr-val")}
          );
      });

    var pathPrefix = "../../";
    if ($(this).data("path-prefix")) {
      var pathPrefix = $(this).data("path-prefix");
    }

      //get variations url
      $.ajax({
        type: "POST",
        async: false,
        dataType: "json",
        url: pathPrefix + "functions.ajax.php",
        data: {action:"getVariationsUrl", parent_asin:parent_asin, variations:variations, attrName:attrName},
        success: function(msgObj) {
          if (msgObj.success) {
            location.href = msgObj.item_url;
          }
        }
      });
    });
  }

  //modal opener
  if ($(".js-btn-variation-modal-selector").length) {

    $(".js-btn-variation-modal-selector").click(function() {

      var bbMessage = "<div class='row row-modal-variations'>" + $(".hidden-content #variationsHiddenModalContent").html() + "</div>";
      var bbVariations = bootbox.dialog({title: $(".hidden-content .lang-bb-headline").text(),
        onEscape: true,
        message: bbMessage,
        className: "bb-w800",
        buttons: {          
          "cancel" : { label: $(".hidden-content .lang-bb-cancel").text(), className : "btn-primary btn-close", callback: function() { bootbox.hideAll(); } },
        }
      }).on('shown.bs.modal', function() {
        $(".modal-body div.active-asin a",bbVariations).focus().blur();
      }).init(function() {
        $(".modal-dialog",this).addClass("modal-dialog-scrollable");
      });
      return false;
    });
  }

/****
 * 6.item variations selector [-]
 ****/


});
