<?php

$action = isset($_REQUEST["action"]) ? $_REQUEST["action"] : null;

$catId = isset($_REQUEST["catId"]) ? intval($_REQUEST["catId"]) : 0;

$catData = $zstore->getCategoryData($catId,false);

$filter = array();

$filter["own_cat"] = $catId;
$filter["imported"] = true;
$filter["hasImages"] = false;

$products = $zstore->getProducts($filter);

//set page data
$zstore->setSite(
	array("title" => $catData->page_title ?: $catData->descr,
			 	"description" => $catData->page_descr,
			 	)
);


include("header.php");

$sideNav = false;

?>

		  	<div class='container'>
			  	<div class='row'>
			  		<div class='col-12'>
						  <ol class="zstore-breadcrumb d-flex flex-nowrap">
						    <li><a href="<?php echo $zstore->instDir; ?>/">Home</a></li>
						    <?php
						    if ($catData->parent) {
					    			$parentCatId = $catData->parent;
					    			echo "<li><a href='" . $allCategoriesData[$parentCatId]->url . "'>" . $allCategoriesData[$parentCatId]->descr . "</a></li>";

					    		}
						    	if ($zstore->p > 1) {
						    		echo '<li><a href="' . $catData->url . '">' . $catData->descr . '</a></li>';
						    	} else {
						    		echo '<li class="active">' . $catData->descr . '</li>';
						    	}
						    ?>
						  </ol>
			  		</div>
			  	</div>
			  </div>


    <div class="jumbotron pt-4">
      <div class="container">
        <h1><?php echo ($catData->headline ?: $catData->descr); ?></h1>
        	<?php
        		if ($catData->long_intro) {
			        echo "<hr />
			        <p>" . nl2br($catData->long_intro) . "</p>";        			
        		}
        	?>
      </div>
    </div>


<section class='section'>
	<div class='container'>



<?php


if ($products) {

	//sidenav???
	if (
		($subCategories[$catId] && $products) || //main category with items and subs
		($catData->parent && (count($subCategories[$catData->parent]) > 1 || $allCategoriesData[$catData->parent]->itemsCount)) 	//sub category with siblings or items in parent
	) {
		echo "<div class='row'>
			<div class='col-lg-3 order-12 order-lg-1'>
				<div class='mt-1'>";
		echo "<div class='list-group list-group-flush border-right'>";
		if ($catData->parent) {
			if ($allCategoriesData[$catData->parent]->itemsCount) {
				echo "<a href='" . $allCategoriesData[$catData->parent]->url . "' class='list-group-item list-group-item-action'><i class='fa fa-angle-right fa-fw'></i>" . $allCategoriesData[$catData->parent]->descr . "</a>";
			} else {
				echo "<div class='list-group-item'><i class='fa fa-angle-right fa-fw'></i>" . $allCategoriesData[$catData->parent]->descr . "</div>";
			}
		} else {
			echo "<a href='" . $catData->url . "' class='list-group-item list-group-item-action list-group-item-light'><i class='fa fa-angle-right fa-fw'></i>" . $catData->descr . "</a>";
		}
		echo "</strong></li>";
		foreach ($subCategories[$catData->parent?:$catId] as $row) {
			echo "<a href='" . $row->url . "' class='list-group-item list-group-item-action " . ($catId == $row->id ? "list-group-item-light" : "") . "'><i class='fa fa-angle-double-right fa-fw'></i>" . $row->descr . "</a>\n";
		}
		echo "</div>
				</div>
			</div>"; //col


		$sideNav = true;
		echo "<div class='col-lg-9 order-1 order-lg-12'>";
	}

	$pager = null;
	$thisUrlPath = $_SERVER["REQUEST_URI"] ? strtok($_SERVER["REQUEST_URI"], '?') : $_SERVER["REDIRECT_URL"];
	if ($zstore->pages > 1) {
    $navPages = $zstore->drawPagination($zstore->pages,$zstore->p); 
    if ($navPages) {
      // $pager .= "<div class='row'>";
      // $pager .= "<div class='col-xs-12 text-right'>";
      $pager .= "<ul class='pagination pagination-sm justify-content-center justify-content-md-end mb-20'>";

       $pager .= "<li class='page-item " . ($zstore->p && $zstore->p > 1 ? "" : "disabled") . "'><a href='$thisUrlPath?p=" . ($zstore->p-1) . "' class='page-link'><i class='fa fa-chevron-left'></i></a></li>";

      foreach ($navPages as $row) {
          if (isset($row["P"]) && $row["P"]) {
            $pager .= "<li class='page-item " . (isset($row["ACTIVE"]) && $row["ACTIVE"] ? "active" : "") . "'><a href='$thisUrlPath?p=" . $row["P"] . "' class='page-link'>" . $row["P"] . "</a></li>";
          }
          if (isset($row["SEP"]) && $row["SEP"]) {
            $pager .= "<li class='page-item disabled'><span class='page-link'>...</span></li>";
          }
      }

      $pager .= "<li class='page-item " . ($zstore->p < $zstore->pages ? "" : "disabled") . "'><a href='$thisUrlPath?p=" . ($zstore->p+1) . "' class='page-link'><i class='fa fa-chevron-right'></i></a></li>";
      
      $pager .= "</ul>";
    }
   }

  echo $pager;
?>

		<div class='row row-cards row-product-cards masonry-this'>
			<?php
				$cardHolderClasses = null;
				if ($sideNav) {
					$cardHolderClasses = "col-sm-6 col-md-4 col-lg-4";
				} else {
					$cardHolderClasses = "col-sm-6 col-md-4 col-lg-3";
				}
				foreach ($products as $row) {
					//asins in favorites - $favAsins set in header.php
					$row->inFavorites = in_array($row->asin,$favAsins);

					echo "<div class='col-12 $cardHolderClasses card-holder'>
						<div class='card'>
						<div class='btn-group-vertical btn-group-sm btn-group-cat-prod-listing'>
							<button type='button' class='btn btn-zstore btn-secondary btn-sm js-btn-add2cart' data-asin='" . $row->asin . "' data-path-prefix='../'><i class='fa fa-cart-plus'></i></button>";
					if ($row->inFavorites) {
						echo "<button type='button' class='btn btn-sm btn-light border js-btn-remove-from-favs tt' data-asin='" . $row->asin . "' data-path-prefix='../' title='" . $zstore->lang("title_remove_from_favorites") . "'><i class='fa fa-heart'></i></button>";
					} else {						
						echo "<button type='button' class='btn btn-sm btn-light border js-btn-add2favs tt' data-asin='" . $row->asin . "' data-path-prefix='../' title='" . $zstore->lang("title_add2favorites") . "'><i class='fa fa-heart-o'></i></button>";
					}
					echo "<a href='" . $zstore->placeholdersToAmzKeys($row->item_url) . "' class='btn btn-sm btn-amazon open-external' data-asin='" . $row->asin . "'><i class='fa fa-amazon'></i></a>
						</div>";
					if ($row->rating) {
						echo "<div class='text-amazon small prodlisting-rating-stars'>" . $zstore->drawRatingStars($row->rating) . "</div>";
					}
					echo "<a href='" . $row->url . "'>";
					if ($row->image_url) {
						echo "<img src='" . $zstore->getImgSizeUrl($row->image_url,"md") . "' class='card-img-top mx-auto p-3' alt='' />";
					} else {
						echo "<i class='fa fa-cube fa-border text-secondary bg-light fa-no-item-pic'></i>";
					}
					echo "</a>
							<div class='card-body'>
								<h6 class='card-title'>" . $row->titleDB . "</h6>
				        <a href='" . $row->url . "' class='btn btn-secondary btn-zstore btn-block btn-sm mt-10'>" . $zstore->lang("more_details") . "</a>";
					echo "</div>
						</div>				
					</div>";				
				}
			?>
		</div>

<?php
	echo $pager;

	if ($sideNav) {
		echo "</div>"; //col
		echo "</div>"; //row

	}


} //products
else {

	if ($subCategories[$catId]) {
		echo "<div class='home-category-listing'>";
		foreach ($subCategories[$catId] as $row) {
			$products = $zstore->getRandomProducts($row->id);
			echo '<section class="section mt-2 border-bottom">
				<div class="container">';
			echo "<div class='row row-single-category'>
				<div class='col-12 col-md-3 col-xl-2'>
					<h4 class='font-bsn'><a href='" . $row->url . "' class='text-dark'>" . $row->descr . "</a></h4>";						
			if ($row->short_intro) {
				echo "<p class='card-text'>" . $row->short_intro . "</p>";
			}
			echo "</div>";
			if ($products) {
				echo "<div class='col-12 col-md-9 col-xl-10'>
					<div class='row row-cards masonry-this'>";
				$i=0;
				foreach ($products as $item) {
					$i++;
					$itemLink = $zstore->generateItemUrl($item->asin,$item->title);

					echo "<div class='card-holder col-6 col-sm-6 col-md-6 col-lg-4 col-xl-3 " . ($i == 4 ? "d-lg-none d-xl-block" : "") . "'>
						<div class='card text-center'>
							<a href='" . $itemLink . "' class='no-text-decoration'>";
					if ($item->image_url) {
						echo "<img src='" . $zstore->getImgSizeUrl($item->image_url,"sm200") . "' class='img-fluid mx-auto mt-2' alt='' />";
					} else {
						echo "<i class='fa fa-cube fa-border text-secondary bg-light fa-no-item-pic-medium'></i>";
					}
					echo "</a>
							<div class='card-body'>
		          	<h6 class='card-title'>" . mb_strimwidth($item->title, 0, 100, "...") . "</h6>
		          	<a href='" . $itemLink . "' class='btn btn-secondary btn-zstore btn-block btn-sm mt-10'>" . $zstore->lang("more_details") . "</a>
		          </div>";
		      
		      echo "</div></div>"; //card & col
				}
			}
			echo "</div></div>";	//row & col 
			echo "<div class='col col-category-link'><a href='" . $row->url . "' class='btn btn-block btn-secondary'>" . $zstore->lang("view_all_products") . "</a></div>";
			echo "</div>"; //row
			echo "</div>"; //container
			echo "</section>\n\n";
		}
		echo "</div>";
	}
}

?>

	</div>
</section>







<?php include("footer.php"); ?>