<?php

if ($zstore->maintenance && !$zstore->auth) {
  include("maintenance.php");
  exit;
}

if (!isset($currentPage)) $currentPage = "home";

if (!isset($srch)) $srch = null;
if (!isset($catId)) $catId = 0;

$activePage[$currentPage] = "active";

$action = isset($_REQUEST["action"]) ? $_REQUEST["action"] : null;

list($mainCategories,$subCategories,$allCategoriesData) = $zstore->getCategoriesWithItems();

//get current cart stats
$cartData = $zstore->getCart();

//just set to avoid unwanted notices
$loadWysiHTML = $useDataTables = false;


//asins in favorites
$favAsins = $zstore->getAsinsFromFavs();

?>

<!DOCTYPE html>
<html lang="<?php echo $zstore->lang; ?>">
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <meta name="description" content="<?php echo $zstore->site->meta_description; ?>">
    <meta name="author" content="<?php echo $zstore->site->author; ?>">
    <meta name="keywords" content="<?php echo $zstore->site->meta_keywords; ?>">
    <!-- <meta name="google-site-verification" content="get it from https://www.google.com/webmasters/tools/" /> -->
    <link rel="icon" href="">
    <title><?php echo $zstore->site->title; ?></title>

    <link href="<?php echo $zstore->instDir; ?>/layouts/<?php echo $zstore->config->layout; ?>/css/bns.min.css?<?php echo date("Ymd"); ?>" rel="stylesheet">
    <script>window._epn = {campaign:5338573184};</script>
<script src="https://epnt.ebay.com/static/epn-smart-tools.js"></script>
  </head>

  <body>

  <?php
    if ($zstore->maintenance) {
      echo "<div class='text-center alert-info fixed-top maintenance-info'>Maintenance Mode <strong>enabled</strong></div>";
    }
  ?>

    <div class='wrapper-top-head d-none d-sm-block'>
      <div class='container-fluid'><div class='row'>
        <div class='col d-none d-md-block'>ZOABOUTIQUE</div>
        <div class='col text-right link-row'>
          <a href='<?php echo $zstore->instUrl; ?>/favorites.php'><?php echo $zstore->lang("hl_favorites"); ?></a>
          <a href='<?php echo $zstore->instUrl; ?>/cart.php'><?php echo $zstore->lang("shopping_cart"); ?></a>
          <a href='<?php echo $zstore->instUrl; ?>/cnt/terms.html'><?php echo $zstore->lang("imprint"); ?></a>
          <a href='<?php echo $zstore->instUrl; ?>/prodmap.php'><?php echo $zstore->lang("hl-products-map"); ?></a>
        </div>
      </div></div>
    </div>

    <!-- mobile navigation [+] -->
    <!-- <div class='overlay'></div> -->
      <div class='zstore-mobilenav fixed-top js-hide bg-dark d-md-none'>
      <button class="btn btn-outline-light zstore-btn-show-hide-mobilenav m-3" type="button"><i class='fa fa-times'></i></button>
      <div class='dropdown-menu bg-dark'>
        <?php
          //favorites link
          echo "<a href='" . $zstore->instDir . "/favorites.php' class='dropdown-item " . ($currentPage == "favorites" ? "active" : "") . " js-btn-nav-favorites'><i class='fa fa-fw " . ($favAsins ? "fa-heart" : "fa-heart-o") . "'></i> " . $zstore->lang("hl_favorites") . "</a>\n";
          //cart link
          echo "<a href='" . $zstore->instDir . "/cart.php' class='dropdown-item " . ($currentPage == "cart" ? "active" : "") . "'><i class='fa fa-shopping-cart'></i> " . $zstore->lang("shopping_cart") . "
            <span class='badge badge-light badge-cart-items-count " . (!$cartData["itemsCount"] ? "js-hide" : "") . "'>" . intval($cartData["itemsCount"]) . "</span></a>";
          //prodmap link
          echo "<a href='" . $zstore->instDir . "/prodmap.php' class='dropdown-item " . ($currentPage == "prodmap" ? "active" : "") . "'><i class='fa fa-fw fa-sitemap'></i> " . $zstore->lang("hl-products-map") . "</a>\n";
          //seperator line
          echo '<div class="dropdown-divider"></div>';
          //additional page(s)
          echo "<a class='dropdown-item " . ($currentPage == "sample" ? "active" : "") . "' href='" . $zstore->instDir . "/cnt/sample.html'><i class='fa fa-file fa-fw'></i> Sample Page</a>";
          //additional page(s)
          echo '<div class="dropdown-divider"></div>';
          //product categories
          if ($mainCategories) {
            echo '<h6 class="dropdown-header">' . $zstore->lang("product_categories") . '</h6>';
            foreach ($mainCategories as $row) {
              echo '<a class="dropdown-item ' . ($row->id == $catId ? "active" : "") . ' ' . (!$row->status ? "offline" : "") . '" href="' . $row->url . '"><i class="fa fa-angle-right fa-fw"></i> ' . $row->descr . ($row->top_cat ? "<sup><i class='fa fa-star text-zstore'></i><sup>" : "") . '</a>';
            }  
          }
          echo '<div class="dropdown-divider"></div>';

     ?>
     <div class='container'>
          <form method='get' action='<?php echo $zstore->instDir; ?>/search.php'>
            <input type='hidden' name='srchCatId' value='0' />
                <div class='form-group row'>
                  <div class='col-9'>
                    <input type='text' name='srch' class='form-control' value='<?php echo $srch; ?>' placeholder='Recherche' />
                  </div>
                  <div class='text-right col-3'>
                    <button class="btn btn-outline-light" type="submit"><i class='fa fa-search'></i></button>
                  </span>
                  </div>
                </div>
        </form>
        </div>
<?php


        ?>
      </div>
    </div>
    <!-- mobile navigation [-] -->


    <nav class="navbar-zstore">
      <div class='container'>
        <div class='row'>
          <div class='col-md-4 col-9 js-col-logo'>
            <a href="<?php echo $zstore->instDir; ?>/" class="zstore-logo">Velos & Trottinettes</a>
          </div>


          <!-- mobile nav init button -->
          <div class="d-md-none mb-2 col-3 text-right">
            <button class="btn btn-outline-dark zstore-btn-show-hide-mobilenav" type="button"><i class='fa fa-bars'></i></button>
          </div>


          <div class='col-md-8 col-search d-none d-sm-block'>
            <form method='get' action='<?php echo $zstore->instDir; ?>/search.php'>
              <input type='hidden' name='srchCatId' value='<?php echo isset($catId) ? $catId : 0; ?>' />
              <div class='form-group row'>
                <div class='col-lg-4 col-md-5 col'>
                <?php
                  $currentSrchFormCatId = 0;
                  if ($currentPage == "search") {
                    if (isset($_REQUEST["srchCatId"]) && isset($allCategoriesData[$_REQUEST["srchCatId"]])) {
                      $currentSrchFormCatId = $_REQUEST["srchCatId"];
                    }
                  } else {
                    if (isset($catId) && isset($allCategoriesData[$catId])) {
                      $currentSrchFormCatId = $catId;
                    }
                  }

                  if ($mainCategories) {
                    echo '<div class="input-group-btn">
                      <button type="button" class="btn btn-outline-secondary dropdown-toggle js-btn-dropdown-show-formval btn-block text-right text-ellipsis text-truncate" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false"><span class="d-none d-sm-inline">';
                    if ($currentSrchFormCatId) {
                      echo $allCategoriesData[$currentSrchFormCatId]->descr;
                    } else {
                      echo $zstore->lang("all_categories");
                    }
                    echo '</span></button>
                      <div class="dropdown-menu dropdown-menu-small js-dropdown-set-formval" data-formval-target="srchCatId">';
                    echo "<a class='dropdown-item' href='#catsel?all' data-formval='0'><i class='fa fa-fw fa-square-o'></i>" . $zstore->lang("all_categories"). "</a>\n";
                    foreach ($mainCategories as $row) {
                      echo "<a class='dropdown-item " . ($currentSrchFormCatId == $row->id ? "active" : "") . ' ' . (!$row->status ? "offline" : "") . "' href='#catsel" . $row->id . "' data-formval='" . $row->id . "'>";
                      if ($currentSrchFormCatId == $row->id) {
                        echo "<i class='fa fa-fw fa-check-square-o'></i> ";
                      } else {
                        echo "<i class='fa fa-fw fa-square-o'></i> ";
                      }
                      echo $row->descr . "</a>\n";
                    }
                    
                    echo "</div>
                      </div>
                    \n";                  
                  }
                ?>
                </div>
                <div class='col-lg-8 col-md-7 col'>
                  <div class='input-group'>
                    <input type='text' name='srch' class='form-control border-secondary border-right-0' value='<?php echo $srch; ?>' placeholder='Recherche' />
                    <span class="input-group-prepend">
                      <button class="btn btn-outline-secondary border-left-0 rounded-right" type="submit"><i class='fa fa-search'></i></button>
                    </span>
                  </div>
                </div>
              </div>
              </form>
            </div>
          </div>


        </div>


       </div> <!-- row -->
    </div> <!-- container -->
    </nav>

    <!-- the main nav -->
    <nav class='zstore-top-nav navbar-dark bg-dark'>
      <div class='container'>
        <div class='row'>
          <div class='col-auto mr-auto btn-group'>
            <?php
              if ($mainCategories && $zstore->config->categories_in_navbar) {
                if ($zstore->config->categories_in_navbar == 1) {
                  foreach ($mainCategories as $row) {
                    $add2DropDownClass = null;
                    if ($subCategories[$row->id]) {
                      echo '<div class="dropdown">';
                      if ($row->itemsCount) {
                        echo '<a href="' . $row->url . '" class="btn btn-link pr-0' . ($row->id == $catId || $allCategoriesData[$catId]->parent == $row->id ? " active" : "") . ' ' . (!$row->status ? "offline" : "") . '">' . $row->descr . ($row->top_cat ? "<sup><i class='fa fa-star text-zstore'></i><sup>" : "") . '</a>';
                        echo '<a href="#" class="btn btn-link dropdown-toggle dropdown-toggle-split pl-1" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false"></a>';
                        $add2DropDownClass = "dropdown-menu-right";
                      } else {
                        echo '<button class="btn btn-link dropdown-toggle' . ($row->id == $catId || $allCategoriesData[$catId]->parent == $row->id ? " active" : "") . ' ' . (!$row->status ? "offline" : "") . '" type="button" id="dropdownMenuButton" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">' . $row->descr . ($row->top_cat ? "<sup><i class='fa fa-star text-zstore'></i><sup>" : "") . '</button>';                        
                      }
                      echo '<div class="dropdown-menu dropdown-menu-small bg-dark ' . $add2DropDownClass . '" aria-labelledby="dropdownMenuButton">';
                      foreach ($subCategories[$row->id] as $subCat) {
                        echo '<a class="dropdown-item ' . ($subCat->id == $catId ? "active" : "") . ' ' . (!$subCat->status ? "offline" : "") . '" href="' . $subCat->url . '">' . $subCat->descr . '</a>' . "\n";
                      }
                      echo '</div>
                      </div>';
                    } else {
                      echo '<a class="btn btn-link ' . ($row->id == $catId ? "active" : "") . ' ' . (!$row->status ? "offline" : "") . '" href="' . $row->url . '">' . $row->descr . ($row->top_cat ? "<sup><i class='fa fa-star text-zstore'></i><sup>" : "") . '</a>' . "\n";
                    }

                    ?>

                      

                    <?php

                  }
                } elseif ($zstore->config->categories_in_navbar == 2) {
                  //categories in dropdown
                  echo '<div class="dropdown float-left mr-1">
                    <button class="btn btn-link ' . ($catId ? "active" : "") . ' dropdown-toggle" type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">' . $zstore->lang("product_categories") . '</button>
                    <div class="dropdown-menu dropdown-menu-small bg-dark">';
                  foreach ($mainCategories as $row) {
                    echo '<a class="dropdown-item ' . ($row->id == $catId ? "active" : "") . ' ' . (!$row->status ? "offline" : "") . '" href="' . $row->url . '"><i class="fa fa-cube fa-fw"></i> ' . $row->descr . ($row->top_cat ? "<sup><i class='fa fa-star text-zstore'></i><sup>" : "") . '</a>';
                  }

                  echo '</div>
                </div>';
              }
            }
           ?>
           <a class="btn btn-link <?php echo ($currentPage == "active" ? "" : ""); ?>" href="<?php echo $zstore->instDir; ?>/cnt/1tpe.html">Produits Numériques</a>
           <a href="https://rover.ebay.com/rover/1/709-53476-19255-0/1?icep_id=114&ipn=icep&toolid=20004&campid=5338573184&mpre=https%3A%2F%2Fwww.ebay.fr%2Fdeals" target="_blank" class="btn btn-link <?php echo ($currentPage == "active" ? "" : ""); ?>">Bon Plans</a>

         </div>

           <div class='col-auto text-right'>
            <?php
              echo "<a href='" . $zstore->instDir ."/favorites.php' class='btn btn-link " . ($currentPage == "favorites" ? "active" : "") . " js-btn-nav-favorites'><i class='fa " . ($favAsins ? "fa-heart" : "fa-heart-o") . "'></i></a>\n";
              echo "<a href='" . $zstore->instDir ."/cart.php' class='btn btn-link " . ($currentPage == "cart" ? "active" : "") . "'><i class='fa fa-shopping-cart'></i><span class='badge badge-zstore badge-tiny badge-cart-items-count " . (!$cartData["itemsCount"] ? "js-hide" : "") . "'>" . intval($cartData["itemsCount"]) . "</span></a>";
              ?>

            </a>
          </div>
        </div>
      </div>
    </nav>
