/***************
 * zStore bikes_n_scooters layout JS 1.16
 * coming with zStore 1.16
 *  January 17th 2019
 *  https://codecanyon.net/item/zstore-an-amazon-affiliate-store/22713029
 ***************
 *  0. Misc
 *  0.1 finding/defining bootstrap breakpoints
 *  0.2 in_array function definition 
 *  1. Masonry
 *  1.1 for product listings (on category pages)
 *      clickable cards
 *  1.2 for category listings (on home page)
 *      clickable cards
 *  1.3 for product site map
 *  2. Footer positioning
 *  4. Sliders
 *  4.1 zStore Slider for product thumbs on product pages
 *  4.2 Slick Sliders for amazon item listings on search results pages or amazon suggestions on product pages
 *  4.3 Slick Sliders for shop group item listings on product pages
 *  4.4 Bootstrap Slider home header slider
 *  5. Mobile Navigation
************/


jQuery(document).ready(function() {


/****
  0. Misc [+]
****/ 

// 0.1 finding/defining bootstrap breakpoints
var currentBreakpoint;
// bootstrap breakpoint check-s
function setCurrentBreakpoint() {
  var breakpoints = { 'xs': 'd-block d-sm-none', 
                      'sm': 'd-none d-sm-block d-md-none',
                      'md': 'd-none d-md-block d-lg-none', 
                      'lg': 'd-none d-lg-block d-xl-none',
                      'xl': 'd-none d-xl-block'};
  var dom = $('<div>');
  $(dom).appendTo($('body'));
  $.each(breakpoints, function(breakpoint,cssClass) {
    var bpdom = $('<div>');
    $(bpdom).appendTo($(dom)).text(breakpoint).addClass(cssClass);
    if ($(bpdom).is(":visible")) {
      // $("bpdom").appendTo($(dom)).text(breakpoint).addClass(cssClass);
      currentBreakpoint = breakpoint;
    }
  });
  $(dom).remove();
}
setCurrentBreakpoint();
// $(window).resize(function(){
//   setCurrentBreakpoint();
// });


// 0.2 in_array function definition (not needed now)
function in_array(needle,arr) {
  for(i=0;i<arr.length;i++) {
    if (needle == arr[i]) {
      return true;
    }
  }
  return false;
}

/****
  0. Misc [-]
****/ 



/****
  1. Masonry [+]
****/ 

  /** 1.1 Masonry for product listings (on category pages) **/
  if ($(".row-product-cards").length) {
    //category cards
    var grid = $(".row-cards.masonry-this");
    if (grid.length) {
      grid.imagesLoaded( function() {
        grid.masonry({
          itemSelector: '.card-holder',
          columnWidth: '.card-holder'
        });
      });
    }
    // make whole cards clickable
    if ($(".row-cards").length) {
      $(".row-cards .card a").not(".btn-amazon").each(function() {
        var thisLink = $(this).attr("href");
        var thisCard = $(this).closest(".card");
        $(thisCard)
          .addClass("pointer").click(function(e) {
            if(e.target !== e.currentTarget && event.target.nodeName != "H6") {
              return;
            } else {
              location.href=thisLink;
            }
            e.preventDefault();
          })
      });

      //mouseover on specific resolutions
      if (currentBreakpoint != "xs") {
        $(".btn-group-cat-prod-listing").hide();
        $(".row-product-cards .card").hover(
          function() {
            $(".btn-group-cat-prod-listing",this).slideDown(200);
          },
          function() {
            $(".btn-group-cat-prod-listing",this).slideUp(200);
          }
        );
      }
    }
  }



  /** 1.2 Masonry for category listings (on home page) **/
  if ($(".home-category-listing").length) {

    //category cards
    var grid = $(".row-cards.masonry-this");
    if (grid.length) {
      grid.imagesLoaded( function() {
        grid.masonry({
          itemSelector: '.card-holder',
          columnWidth: '.card-holder'
        });
      });
    }
     // make whole cards clickable
    if ($(".row-cards").length) {
      $(".row-cards .card a").each(function() {
        var thisLink = $(this).attr("href");
        var thisCard = $(this).closest(".card");
        $(thisCard)
          .addClass("pointer").click(function(e) {
            location.href=thisLink;
            e.preventDefault();
          })
      });
    }

    // alert(breakpoint);

    // $(window).on('load resize', function () {
    //     $('.row-single-category .card-holder .card').css('height',"auto");
    //   $('.row-single-category').each(function() {
    //     setCurrentBreakpoint();
    //     if (in_array(currentBreakpoint,["lg","xl"])) {    
    //       $('.row-single-category').each(function() {
    //         var map_height = $(this).height();
    //         var selection_height = $('.card-holder .card',this).height();
    //         if (selection_height < map_height) {
    //           $('.card-holder .card',this).css('height',map_height);
    //         }
    //       });
    //     }
    //   })
    // });
  }


  /** 1.3 Masonry for category listings (on home page) **/
  if ($(".grid-prodMap").length) {
    var grid = $(".grid-prodMap");
    // grid.imagesLoaded( function() {  //no images in grid
      grid.masonry({
        itemSelector: '.grid-prodMap-item',
        columnWidth: '.grid-prodMap-item'
      });
    // });
  }



/****
  1. Masonry [-]
****/ 



/****
  2. Footer positioning [+]
****/ 
  //move footer to the bottom if needed 
  var reposFooter = function() {
    if($(window).height()-100 > $('body').height()) {
      $("footer").css("margin-top",$(window).height() - $('body').height()-$("footer").height());
    }
  };
  reposFooter();
/****
  2. Footer positioning [-]
****/


/****
  4. Slick Sliders [+]
****/

  /** 4.1 for product thumbs on product pages **/
  var thumbnailDots = $('.item-thumbnail-dots');
  if (thumbnailDots.length) {
    //init arrow keys on load :)
    $(thumbnailDots).focus();
    $("i",thumbnailDots).click(function() {
      var image_url = $(this).data("image-url");
      $(".item-image-big-bgholder").css("background-image","url(" + image_url + ")");
      $("i",thumbnailDots).not(this).removeClass("fa-dot-circle-o text-zstore").addClass("fa-circle-o");
      $(this).removeClass("fa-circle-o").addClass("fa-dot-circle-o text-zstore");
      thumbnailDots.data("current",$(this).data("itemnum"));
      $(thumbnailDots).focus();
      return false;
    });
    // if (clickedInDotsArea)
    $(thumbnailDots).bind('keydown', function(e) {
      var current = parseInt(thumbnailDots.data("current"));
      if(e.keyCode == 37) { // left
        if (current == 1) {
          return false;
        } else {
          $("i[data-itemnum='" + (current - 1) + "']", thumbnailDots).trigger("click");
        }
      } else if(e.keyCode == 39) { // right
        if (current == parseInt(thumbnailDots.data("max"))) {
          return false;
        } else {
          $("i[data-itemnum='" + (current + 1) + "']", thumbnailDots).trigger("click");
        }
      }
    });
  }

  /** 4.2 for amazon item listings on search results pages or amazon suggestions on product pages **/
  var suggestionsRow = $(".row-suggestions-amazon");
  if (suggestionsRow.length) {
    var slickArrowHolder = ".slick-suggestions-arrow-holder";
    var slickSuggestions = $(suggestionsRow).slick({
      dots: false,
      infinite: false,
      speed: 300,
      slidesToShow: 4,
      slidesToScroll: 4,
      nextArrow: '<i class="fa fa-chevron-right slick-next pointer"></i>',
      prevArrow: '<i class="fa fa-chevron-left slick-prev pointer"></i>',
      appendArrows: slickArrowHolder,
      responsive: [
        {
          breakpoint: 1024,
          settings: {
            slidesToShow: 3,
            slidesToScroll: 3
          }
        },
        {
          breakpoint: 600,
          settings: {
            slidesToShow: 2,
            slidesToScroll: 2
          }
        },
        {
          breakpoint: 480,
          settings: {
            slidesToShow: 1,
            slidesToScroll: 1
          }
        }
      ]
    });

    $(slickArrowHolder + " .slick-prev").hide();

    slickSuggestions.on('afterChange', function(event, slick, currentSlide) {    
      var slickToShow = $(suggestionsRow).slick('slickGetOption','slidesToShow');
        if (currentSlide === 0) {
          $(slickArrowHolder + ' .slick-prev').hide();
          $(slickArrowHolder + ' .slick-next').show();
        } else {
          $(slickArrowHolder + ' .slick-prev').show();
        }
        
        if (currentSlide + slickToShow >= slick.slideCount) {
          $(slickArrowHolder + ' .slick-next').hide();
        } else {
          $(slickArrowHolder + ' .slick-next').show();
        }
      });
  }

  /** 4.3 for shop group item listings on product pages **/
  var suggestionsGroupRow = $(".row-suggestions-group");
  if (suggestionsGroupRow.length
    && (
      ($(".suggestion-item",suggestionsGroupRow).length > 4 && in_array(currentBreakpoint,["xl","lg"])) ||
      ($(".suggestion-item",suggestionsGroupRow).length > 3 && in_array(currentBreakpoint,["md","sm"])) ||
      ($(".suggestion-item",suggestionsGroupRow).length > 2 && currentBreakpoint == "xs")
    )
  ) {
    var slickArrowHolderG = ".slick-suggestions-group-arrow-holder";
    var slickGroupSuggestions = $(suggestionsGroupRow).slick({
      dots: false,
      infinite: false,
      speed: 300,
      slidesToShow: 4,
      slidesToScroll: 4,
      nextArrow: '<i class="fa fa-chevron-right slick-next pointer"></i>',
      prevArrow: '<i class="fa fa-chevron-left slick-prev pointer"></i>',
      appendArrows: slickArrowHolderG,
      responsive: [
        {
          breakpoint: 1024,
          settings: {
            slidesToShow: 3,
            slidesToScroll: 3,
          }
        },
        {
          breakpoint: 600,
          settings: {
            slidesToShow: 2,
            slidesToScroll: 2
          }
        },
        {
          breakpoint: 480,
          settings: {
            slidesToShow: 1,
            slidesToScroll: 1
          }
        }
      ]
    });


    $(slickArrowHolderG + " .slick-prev").hide();

      slickGroupSuggestions.on('afterChange', function(event, slick, currentSlide) {    
        var slickToShow = $(suggestionsRow).slick('slickGetOption','slidesToShow');
          if (currentSlide === 0) {
            $(slickArrowHolderG + ' .slick-prev').hide();
            $(slickArrowHolderG + ' .slick-next').show();
          } else {
            $(slickArrowHolderG + ' .slick-prev').show();
          }
          
          if (currentSlide + slickToShow >= slick.slideCount) {
            $(slickArrowHolderG + ' .slick-next').hide();
          } else {
            $(slickArrowHolderG + ' .slick-next').show();
          }
        });

    }

  /** 4.4 home header slider **/
  var homeSlider = $("div#homeSlider");
  // if (homeSlider.length) {
  //   $('p',homeSlider).typewriter({speed:33});
  //   $('h3:first-child',homeSlider).typewriter({speed:75});
  //   homeSlider.on('slide.bs.carousel', function () {
  //     $('h3',$(this)).typewriter({speed:75});
  //     $('p',$(this)).typewriter({speed:33});
  //   });
  // }
  if (homeSlider.length) {
    $('p',homeSlider).typewriter({speed:33,delay:.5,caret:false});
    $('h3:first-child',homeSlider).typewriter({speed:75,delay:.25,caret:false});
    homeSlider.on('slide.bs.carousel', function () {
      $('h3',$(this)).typewriter({speed:75,delay:.5,caret:false});
      $('p',$(this)).typewriter({speed:33,delay:1,caret:false});
    });
  }


/****
  4. Slick Sliders [-]
****/




/****
  5. Mobile Navigation [+]
****/
  $(".zstore-btn-show-hide-mobilenav").click(function() {
    var mobileNav = $(".zstore-mobilenav");
    if (mobileNav.is(":visible")) {
      mobileNav.slideUp();
      $("div.overlay").fadeOut();
    } else {
      mobileNav.slideDown();
      $("div.overlay").fadeIn();
    }
  });

/****
  5. Mobile Navigation [-]
****/


});