<?php

$action = isset($_REQUEST["action"]) ? $_REQUEST["action"] : null;

$catId = isset($_REQUEST["catId"]) ? intval($_REQUEST["catId"]) : 0;

$catData = $zstore->getCategoryData($catId,false);

$filter = array();

$filter["own_cat"] = $catId;
$filter["imported"] = true;
$filter["hasImages"] = false;

$products = $zstore->getProducts($filter);

//set page data
$zstore->setSite(
	array("title" => $catData->page_title ?: $catData->descr,
			 	"description" => $catData->page_descr,
			 	)
);


include("header.php");

$sideNav = false;

?>

  	<div class="card card-top-line">
		  <div class="card-header">
		  	<div class='container'>
			  	<div class='row'>
			  		<div class='col-12'>
						  <ol class="breadcrumb zstore-breadcrumb">
						    <li class="breadcrumb-item"><a href="<?php echo $zstore->instDir; ?>/">Home</a></li>
						    <?php
									if ($catData->parent) {
					    			$parentCatId = $catData->parent;
					    			echo "<li class='breadcrumb-item'><a href='" . $allCategoriesData[$parentCatId]->url . "'>" . $allCategoriesData[$parentCatId]->descr . "</a></li>";
					    		}
						    	if ($zstore->p > 1) {
						    		echo '<li class="breadcrumb-item"><a href="' . $catData->url . '">' . $catData->descr . '</a></li>';
						    	} else {
						    		echo '<li class="breadcrumb-item active">' . $catData->descr . '</li>';
						    	}
						    ?>
						  </ol>
			  		</div>
			  	</div>
			  </div>
		  </div>
		 </div>


    <div class="jumbotron pt-4">
      <div class="container">
        <h1><?php echo ($catData->headline ?: $catData->descr); ?></h1>
        	<?php
        		if ($catData->long_intro) {
			        echo "<hr />
			        <p>" . nl2br($catData->long_intro) . "</p>";        			
        		}
        	?>
      </div>
    </div>


<section class='section'>
	<div class='container'>
<?php

if ($products) {

	//sidenav???
	if (
		($subCategories[$catId] && $products) || //main category with items and subs
		($catData->parent && (count($subCategories[$catData->parent]) > 1 || $allCategoriesData[$catData->parent]->itemsCount)) 	//sub category with siblings or items in parent
	) {
		echo "<div class='row'>
			<div class='col-lg-3 order-12 order-lg-1'>
				<div class='card'>
				<div class='card-header'>";
		if ($catData->parent) {
			if ($allCategoriesData[$catData->parent]->itemsCount) {
				echo "<a href='" . $allCategoriesData[$catData->parent]->url . "'>" . $allCategoriesData[$catData->parent]->descr . "</a>";
			} else {
				echo $allCategoriesData[$catData->parent]->descr;
			}
		} else {
			echo $catData->descr;
		}
		echo "</div>
				<ul class='list-group list-group-flush'>";
		foreach ($subCategories[$catData->parent?:$catId] as $row) {
			if ($catId == $row->id) {
				echo "<li class='list-group-item'><a href='" . $row->url . "' class='text-secondary" . ' ' . (!$row->status ? "offline" : "") . "'><strong>" . $row->descr . "</strong></a></li>\n";
			} else {
				echo "<li class='list-group-item'><a href='" . $row->url . "' " . (!$row->status ? "class='offline'" : "") . ">" . $row->descr . "</a></li>\n";
			}
		}
		echo "</ul>
				</div>
			</div>"; //col


		$sideNav = true;
		echo "<div class='col-lg-9 order-1 order-lg-12'>";
	}

?>

<?php
	$pager = null;
	$thisUrlPath = $_SERVER["REQUEST_URI"] ? strtok($_SERVER["REQUEST_URI"], '?') : $_SERVER["REDIRECT_URL"];
	if ($zstore->pages > 1) {
    $navPages = $zstore->drawPagination($zstore->pages,$zstore->p); 
    if ($navPages) {
      // $pager .= "<div class='row'>";
      // $pager .= "<div class='col-xs-12 text-right'>";
      $pager .= "<ul class='pagination pagination-sm justify-content-center justify-content-md-end mb-20'>";

       $pager .= "<li class='page-item " . ($zstore->p && $zstore->p > 1 ? "" : "disabled") . "'><a href='$thisUrlPath?p=" . ($zstore->p-1) . "' class='page-link'><i class='fa fa-chevron-left'></i></a></li>";

      foreach ($navPages as $row) {
          if (isset($row["P"]) && $row["P"]) {
            $pager .= "<li class='page-item " . (isset($row["ACTIVE"]) && $row["ACTIVE"] ? "active" : "") . "'><a href='$thisUrlPath?p=" . $row["P"] . "' class='page-link'>" . $row["P"] . "</a></li>";
          }
          if (isset($row["SEP"]) && $row["SEP"]) {
            $pager .= "<li class='page-item disabled'><span class='page-link'>...</span></li>";
          }
      }

      $pager .= "<li class='page-item " . ($zstore->p < $zstore->pages ? "" : "disabled") . "'><a href='$thisUrlPath?p=" . ($zstore->p+1) . "' class='page-link'><i class='fa fa-chevron-right'></i></a></li>";
      
      $pager .= "</ul>";
    }
   }

  echo $pager;
?>


		<div class='row row-cards row-product-cards masonry-this'>
			<?php
				$cardHolderClasses = null;
				if ($sideNav) {
					$cardHolderClasses = "col-sm-6 col-md-4 col-lg-4";
				} else {
					$cardHolderClasses = "col-sm-6 col-md-4 col-lg-3";
				}
				foreach ($products as $row) {
					echo "<div class='col-12 $cardHolderClasses card-holder'>
						<div class='card'>
							<a href='" . $row->url . "'>";
					if ($row->image_url) {
						echo "<img src='" . $zstore->getImgSizeUrl($row->image_url,"md") . "' class='card-img-top mx-auto p-3' alt='' />";
					} else {
						echo "<i class='fa fa-cube fa-border text-secondary bg-light fa-no-item-pic'></i>";
					}
					echo "</a>
							<div class='card-body'>
								<h6 class='card-title'>" . $row->titleDB . "</h6>";

					if ($row->rating) {
						echo "<div class='text-amazon small pull-left'>" . $zstore->drawRatingStars($row->rating) . "</div>";
					}
					echo "<div class='pull-right small'><strong class='text-primary'>" . $row->price_str_offer . "</strong></div>";

					if ($row->price_str_lowest && $row->price_str_lowest !=  $row->price_str_offer) {
						echo "<div class='clearfix'></div>
							<div class='text-right small text-muted'><em>" . $row->price_str_lowest . "</em></div>";
					}
					echo "</div>
						</div>				
					</div>";				
				}
			?>
		</div>

<?php
	echo $pager;

	if ($sideNav) {
		echo "</div>"; //col
		echo "</div>"; //row

	}

} //products
else {
	if ($subCategories[$catId]) {

		echo "<div class='row row-cards row-category-cards masonry-this'>";
		foreach ($subCategories[$catId] as $row) {
			$catImg = $zstore->getRandomItemPicsForCategory($row->id,$row->parent);
			echo "<div class='col-lg-3 col-md-4 col-sm-6 col-12 card-holder'>
				<div class='card'>";
			if ($catImg) {
				switch (count($catImg)) {
					case 1:
						echo "<img class='card-img-top' src='" . $zstore->getImgSizeUrl($catImg[0]->image_url,"md") . "' alt='' />";
						break;
					case 2: 
						echo "<div class='row'>
								<div class='col-6'><img class='img-fluid' src='" . $zstore->getImgSizeUrl($catImg[0]->image_url,"md") . "' alt='' /></div>								
								<div class='col-6'><img class='img-fluid' src='" . $zstore->getImgSizeUrl($catImg[1]->image_url,"md") . "' alt='' /></div>
							</div>";
						break;
					case 3:
					default:
						echo "<div class='row'>
							<div class='col-8'><img class='img-fluid mt-2' src='" . $zstore->getImgSizeUrl($catImg[0]->image_url,"md") . "' alt='' /'></div>								
							<div class='col-4'>
								<img class='img-fluid align-top mt-2' src='" . $zstore->getImgSizeUrl($catImg[1]->image_url,"md") . "' alt='' /><br /><br />
								<img class='img-fluid align-bottom' src='" . $zstore->getImgSizeUrl($catImg[2]->image_url,"md") . "' alt='' />
							</div>
						</div>";
				}
			}
					
			echo "<div class='card-body'>
				    <h4 class='card-title'>" . $row->descr . "</h4>";
			if ($row->short_intro) {
				echo "<p class='card-text'>" . $row->short_intro . "</p>";
			}
			echo "<a href='" . $row->url . "' class='btn btn-zstore text-light btn-block'>" . $zstore->lang("view_products") . "</a>
				  </div>
				</div>
			</div>";
		}
		echo "</div>";
	}
}

?>

	</div>
</section>







<?php include("footer.php"); ?>