<?php

if ($zstore->maintenance && !$zstore->auth) {
  include("maintenance.php");
  exit;
}

if (!isset($currentPage)) $currentPage = "home";

if (!isset($srch)) $srch = null;
if (!isset($catId)) $catId = 0;

$activePage[$currentPage] = "active";

$action = isset($_REQUEST["action"]) ? $_REQUEST["action"] : null;

list($mainCategories,$subCategories,$allCategoriesData) = $zstore->getCategoriesWithItems();

//get current cart stats
$cartData = $zstore->getCart();

//just set to avoid unwanted notices
$loadWysiHTML = $useDataTables = false;


//asins in favorites
$favAsins = $zstore->getAsinsFromFavs();

?>

<!DOCTYPE html>
<html lang="<?php echo $zstore->lang; ?>">
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <meta name="description" content="<?php echo $zstore->site->meta_description; ?>">
    <meta name="author" content="<?php echo $zstore->site->author; ?>">
    <meta name="keywords" content="<?php echo $zstore->site->meta_keywords; ?>">
    <!-- <meta name="google-site-verification" content="get it from https://www.google.com/webmasters/tools/" /> -->
    <link rel="icon" href="">
    <title><?php echo $zstore->site->title; ?></title>

    <link href="<?php echo $zstore->instDir; ?>/layouts/<?php echo $zstore->config->layout; ?>/css/default.min.css?<?php echo date("Ymd"); ?>" rel="stylesheet">
    <script>window._epn = {campaign:5338573184};</script>
<script src="https://epnt.ebay.com/static/epn-smart-tools.js"></script>
  </head>

  <body>

  <?php
    if ($zstore->maintenance) {
      echo "<div class='text-center alert-info fixed-top maintenance-info'>Maintenance Mode <strong>enabled</strong></div>";
    }
  ?>

    <div class='wrapper-top-head'>
      <div class='container'><div class='row'>
        <div class='col d-none d-sm-block'>ZOA BOUTIQUE</div>
        <div class='col text-right link-row'><a href='<?php echo $zstore->instUrl; ?>/cnt/terms.html'><?php echo $zstore->lang("imprint"); ?></a></div>
      </div></div>
    </div>
    <nav class="navbar-zstore navbar-dark bg-green">
      <div class='container'>
        <div class='row'>
          <div class='col-md-4 col-lg-3 col-8 js-col-logo'>
            <a href="<?php echo $zstore->instDir; ?>/" class="pull-left zstore-logo"><span class='z'>z</span> <span class='h3 display-4'>oaBoutique</span></a>
          </div>


          <!-- mobile nav -->
          <div class="zstore-xs-top-nav mb-2 col-4 text-right">
            <button class="btn btn-outline-light" type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
              <i class='fa fa-bars'></i>
            </button>
            <div class="dropdown-menu dropdown-menu-right">
              <?php
                //favorites link
                echo "<a href='" . $zstore->instDir . "/favorites.php' class='dropdown-item " . ($currentPage == "favorites" ? "active" : "") . " js-btn-nav-favorites'><i class='fa fa-fw " . ($favAsins ? "fa-heart" : "fa-heart-o") . "'></i> " . $zstore->lang("hl_favorites") . "</a>\n";
                //cart link
                echo "<a href='" . $zstore->instDir . "/cart.php' class='dropdown-item " . ($currentPage == "cart" ? "active" : "") . "'><i class='fa fa-shopping-cart'></i> " . $zstore->lang("shopping_cart") . "
                  <span class='badge badge-light badge-cart-items-count " . (!$cartData["itemsCount"] ? "js-hide" : "") . "'>" . intval($cartData["itemsCount"]) . "</span></a>";
                //products map
                echo "<a href='" . $zstore->instDir . "/prodmap.php' class='dropdown-item " . ($currentPage == "prodmap" ? "active" : "") . "'><i class='fa fa-fw fa-sitemap'></i> " . $zstore->lang("hl-products-map") . "</a>\n";
                //seperator line
                echo '<div class="dropdown-divider"></div>';
                //additional page(s)
                echo "<a class='dropdown-item " . ($currentPage == "sample" ? "active" : "") . "' href='" . $zstore->instDir . "/cnt/sample.html'><i class='fa fa-file fa-fw'></i> Sample Page</a>";
                //additional page(s)
                echo '<div class="dropdown-divider"></div>';
                //product categories
                if ($mainCategories) {
                  echo '<h6 class="dropdown-header">' . $zstore->lang("product_categories") . '</h6>';
                  foreach ($mainCategories as $row) {
                    echo '<a class="dropdown-item ' . ($row->id == $catId ? "active" : "") . ' ' . (!$row->status ? "offline" : "") . '" href="' . $row->url . '"><i class="fa fa-cube fa-fw"></i> ' . $row->descr . ($row->top_cat ? " <sup>&#9679;</sup>" : "") .  '</a>';
                  }  
                }
              ?>
            </div>
          </div>


          <div class='col-md-8 col-lg-9 col-12 col-search'>
            <form method='get' action='<?php echo $zstore->instDir; ?>/search.php' class='form'>
              <input type='hidden' name='srchCatId' value='<?php echo isset($catId) ? $catId : 0; ?>' />
              <div class="input-group">
                <?php
                  $currentSrchFormCatId = 0;
                  if ($currentPage == "search") {
                    if (isset($_REQUEST["srchCatId"]) && isset($allCategoriesData[$_REQUEST["srchCatId"]])) {
                      $currentSrchFormCatId = $_REQUEST["srchCatId"];
                    }
                  } else {
                    if (isset($catId) && isset($allCategoriesData[$catId])) {
                      $currentSrchFormCatId = $catId;
                    }
                  }

                  if ($mainCategories) {
                    echo '<div class="input-group-btn">
                      <button type="button" class="btn btn-secondary dropdown-toggle js-btn-dropdown-show-formval text-ellipsis text-truncate" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false"><span class="d-none d-sm-inline">';
                    if ($currentSrchFormCatId) {
                      echo $allCategoriesData[$currentSrchFormCatId]->descr;
                    } else {
                      echo $zstore->lang("all_categories");
                    }
                    echo '</span></button>
                      <div class="dropdown-menu dropdown-menu-small js-dropdown-set-formval" data-formval-target="srchCatId">';
                    echo "<a class='dropdown-item' href='#catsel?all' data-formval='0'><i class='fa fa-fw fa-square-o'></i>" . $zstore->lang("all_categories"). "</a>\n";
                    foreach ($mainCategories as $row) {
                      echo "<a class='dropdown-item " . ($currentSrchFormCatId == $row->id ? "active" : "") . ' ' . (!$row->status ? "offline" : "") . "' href='#catsel" . $row->id . "' data-formval='" . $row->id . "'>";
                      if ($currentSrchFormCatId == $row->id) {
                        echo "<i class='fa fa-fw fa-check-square-o'></i> ";
                      } else {
                        echo "<i class='fa fa-fw fa-square-o'></i> ";
                      }
                      echo $row->descr . "</a>\n";
                    }
                    
                    echo "</div>
                    </div>";                  
                  }
                ?>
                <input type='text' name='srch' class='form-control' value='<?php echo $srch; ?>' placeholder='Recherche dans la zoaboutique' />
                <span class="input-group-btn">
                  <button class="btn btn-zstore btn-secondary" type="submit"><i class='fa fa-search'></i></button>
                </span>
              </form>
            </div>
          </div>


        </div>


       </div> <!-- row -->
    </div> <!-- container -->
    </nav>

    <nav class='zstore-top-nav navbar-light bg-dark text-light'>
      <div class='container'>
        <div class='row'>
          <div class='col-auto mr-auto'>
            <?php
              if ($mainCategories && $zstore->config->categories_in_navbar) {
                if ($zstore->config->categories_in_navbar == 1) {
                  foreach ($mainCategories as $row) {
                    echo '<a class="btn btn-outline-secondary ' . ($row->id == $catId ? "text-light border border-light" : "") . ($row->top_cat ? " top_cat" : "") . ' ' . (!$row->status ? "offline" : "") . '" href="' . $row->url . '"><i class="fa fa-cube fa-fw"></i> ' . $row->descr . '</a>' . "\n";
                  }
                } elseif ($zstore->config->categories_in_navbar == 2) {
                  //categories in dropdown
                  echo '<div class="dropdown float-left mr-1">
                    <button class="btn ' . ($catId ? "btn-outline-light" : "btn-outline-secondary") . ' dropdown-toggle" type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false"><i class="fa fa-bars"></i> ' . $zstore->lang("product_categories") . '</button>
                    <div class="dropdown-menu dropdown-menu-small bg-dark">';
                  foreach ($mainCategories as $row) {
                    echo '<a class="dropdown-item ' . ($row->id == $catId ? "text-light" : "text-secondary") . ' ' . (!$row->status ? "offline" : "") . '" href="' . $row->url . '"><i class="fa fa-cube fa-fw"></i> ' . $row->descr .  ($row->top_cat ? "<sup><i class='fa fa-dot text-light'></i>" : "") . '</a>';
                  }

                  echo '</div>
                </div>';
              }
            }
           ?>
           <a class="btn btn-outline-secondary border-0 <?php echo ($currentPage == "sample" ? "text-light border border-light" : ""); ?>" href="<?php echo $zstore->instDir; ?>/cnt/1tpe.html"><i class="fa fa-file fa-fw"></i> Produits Numériques</a>
<a href="https://rover.ebay.com/rover/1/709-53476-19255-0/1?icep_id=114&ipn=icep&toolid=20004&campid=5338573184&mpre=https%3A%2F%2Fwww.ebay.fr%2Fdeals" target="_blank" class="btn btn-outline-secondary border-0 <?php echo ($currentPage == "sample" ? "text-light border border-light" : ""); ?>"><i class="fa fa-file fa-fw"></i> Bon Plans</a>
         </div>

           <div class='col-auto text-right'>
            <?php
              echo "<a href='" . $zstore->instDir ."/prodmap.php' class='btn " . ($currentPage == "prodmap" ? "btn-outline-light" : "btn-outline-secondary") . " tt' title='" . $zstore->lang("hl-products-map") . "'><i class='fa fa-sitemap'></i></a>\n";
              echo "<a href='" . $zstore->instDir ."/favorites.php' class='btn " . ($currentPage == "favorites" ? "btn-outline-light" : "btn-outline-secondary") . " js-btn-nav-favorites tt' title='" . $zstore->lang("hl_favorites") . "'><i class='fa " . ($favAsins ? "fa-heart" : "fa-heart-o") . "'></i></a>\n";
              echo "<a href='" . $zstore->instDir ."/cart.php' class='btn " . ($currentPage == "cart" ? "btn-outline-light" : "btn-outline-secondary") . " tt' title='" . $zstore->lang("shopping_cart") . "'><i class='fa fa-shopping-cart'></i> 
                <sup><span class='badge badge-light badge-cart-items-count " . (!$cartData["itemsCount"] ? "js-hide" : "") . "'>" . intval($cartData["itemsCount"]) . "</span></sup></a>";
              ?></a>
          </div>
        </div>
      </div>
    </nav>
