<?php

$action = isset($_REQUEST["action"]) ? $_REQUEST["action"] : null;

$asin = isset($_REQUEST["asin"]) ? trim($_REQUEST["asin"]) : null;

//get updated product data
$productData = $zstore->getProductData($asin);

if (!$productData) {
	header("HTTP/1.0 404 Not Found");
	
	include("header.php");

	echo "<section class='section'><div class='container'>";
	echo "<h1>Page not found!</h1>";
	echo "<p>Content Page not set up correctly</p>";
	echo "</div></section>";

	include("footer.php");

	exit;	
} elseif (is_numeric($productData) && $productData == -1) {
	if ($zstore->amzImportOnCall($asin)) {
		$productData = $zstore->getProductData($asin);
	} else {
		exit ("ERROR 404.1");
	}
}

//update iframe url if needed
$updatedIframeData = $zstore->amzUpdateReviewsIframeUrl($asin);
if ($updatedIframeData) {
	list($productData->has_reviews, $productData->reviews_iframe_url) = $updatedIframeData;
}

//update rating if possible
$updatedRatingData = $zstore->updateItemRating($asin);
if ($updatedRatingData) {
	list($productData->rating, $productData->reviews) = $updatedRatingData;
}

//update prices
$updatedPrices = $zstore->amzUpdatePrices($asin);
if ($updatedPrices) {
	list($productData->price_str_lowest, $productData->price_str_offer, $productData->prime) = $updatedPrices;
}

//set page data
$zstore->setSite(
	array("title" => $productData->titleDB,
			 	"description" => $productData->meta_description,
			 	"keywords" => $productData->meta_keywords,
			 	)
);

//catId to display???
if ($productData->categories) {
	$catId = $productData->categories[0]->id;
}

include("header.php");

//asins in favorites - $favAsins set in header.php
$productData->inFavorites = in_array($asin,$favAsins);

?>

  	<div class="card card-top-line">
		  <div class="card-header">
		  	<div class='container'>
			  	<div class='row'>
			  		<div class='col-12'>
						  <ol class="breadcrumb zstore-breadcrumb">
						    <li class="breadcrumb-item"><a href="<?php echo $zstore->instDir; ?>/">Home</a></li>
						    <?php
						    	if (count($productData->categories) == 1) {
						    		if ($productData->categories[0]->parent) {
						    			$parentCatId = $productData->categories[0]->parent;
						    			echo "<li class='breadcrumb-item'><a href='" . $allCategoriesData[$parentCatId]->url . "'>" . $allCategoriesData[$parentCatId]->descr . "</a></li>";

						    		}
						    		echo "<li class='breadcrumb-item'><a href='" . $productData->categories[0]->url . "'>" . $productData->categories[0]->descr . "</a></li>";
						    	}
						    ?>
						    <li class="breadcrumb-item active"><?php echo mb_strimwidth($productData->titleDB,0,100,"..."); ?></li>
						  </ol>
			  		</div>
			  	</div>
			  </div>
		  </div>
		 </div>


<section class='section'>
	<div class='container'>
		<div class='row'>
				<?php
					$handleMultipleItemImages = $productData->images && count($productData->images) > 1;
					echo "<div class='col-lg-6'>
						<div class='card'>";
					echo "<div class='text-center pt-3 pb-3 pl-15 pr-15'>";
					if ($handleMultipleItemImages) {
						echo "<div class='item-image-big-bgholder' style='background-image:url(" . $productData->image_url . "'></div>";
					} else {
						if ($productData->image_url) {
							echo "<img src='" . $productData->image_url . "' class='img-fluid mx-auto' alt='' />";
						} else {
							echo "<i class='fa fa-cube fa-border text-secondary bg-light fa-no-item-pic-huge'></i><br />
							<small class='text-secondary'>No image available</small>";
						}
					}
					echo "</div>";
					// echo "<div class='text-center pt-3 pb-3' style='max-height:425px;height:425px'><img src='" . $productData->image_url . "' class='img-fluid mx-auto item-image-big' alt='' style='height:100%' /></div>";
					if ($handleMultipleItemImages) {
						echo "<div class='card-footer'>
							<div class='row item-thumbnails-wrapper'>";
						foreach ($productData->images as $image_url) {
							echo "<div class='item-thumbnail my-auto col-lg-3 col-md-3 col-sm-4 col-6 text-center'><div class='img-thumbnail'><img src='" . $zstore->getImgSizeUrl($image_url,"xs") . "' class='img-fluid my-auto pointer' alt='" . $zstore->getImgSizeUrl($image_url,"xs") . "' data-image-url='" . $image_url . "' /></div></div>";
						}
					  echo "<br /><br /><br /></div>
					  	<div class='slick-thumbs-arrow-holder'></div>
					  	</div>";

					}
					echo "</div>"; //card
					echo "</div>"; //col
					echo "<div class='col-lg-6'>
						<h1 class='mb-0'>" . $productData->titleDB . "</h1>
						<div class='text-secondary small'>";
					if ($productData->brand) echo "<strong>" . $productData->brand . "</strong> ";
					$tmpArr = array();
					if ($productData->product_group) $tmpArr[] = $productData->product_group;
					if ($productData->platform) $tmpArr[] = $productData->platform;
					if ($tmpArr) {
						echo implode(" | ",$tmpArr);
					}
					if ($productData->rating) {
						echo "<div class='pull-right text-amazon tt' title='" . sprintf($zstore->lang("rating_x_of_5_with_reviews"),$productData->rating,$productData->reviews) . "'>" . $zstore->drawRatingStars($productData->rating) . "</div>";
					}
					echo "</div><hr class='mt-0' />";
					if ($productData->actors) {
						echo "<strong class='text-secondary'>" . $zstore->lang("actors") . "</strong> " . str_replace("|", ", ", $productData->actors) . "<br />";
					}
					if ($productData->running_time) {
						echo "<strong class='text-secondary'>" . $zstore->lang("running_time") . "</strong> " . sprintf($zstore->lang("x_minutes"),$productData->running_time) . "<br />";
					}
					if ($productData->features) {
						echo "<p>" . $productData->features . "</p>";
					}
					echo "<hr />";

					if ($zstore->handle_variations) {
						//select attributes variations [+]
						list($variations,$currentVariation,$selections) = $zstore->getVariationsAttributesAndValues($productData->parent_asin,$asin);
						if ($variations) {
							echo "<div class='row' id='variationSelects' data-parent-asin='" . $productData->parent_asin . "'>";
							foreach ($variations as $v_attr => $v_values) {
								echo "<div class='col-4 form-group'>
									<label>$v_attr</label>
									<select class='custom-select' name='attr[]'>";
								$tmpCurrentVariation = array();
								foreach ($currentVariation as $currVar) {
									if (!preg_match('/^' . preg_quote($v_attr) . ':/', $currVar)) {
										$tmpCurrentVariation[] = $currVar;
									}
								}

								foreach ($v_values as $v_val) {
									$add2option = null;
									// $optionClass = 'font-weight-bold';
									$optionClass = null;
									$thisVariation = $v_attr . ":" . $v_val;
									if (in_array($thisVariation,$currentVariation)) {
										$add2option = "selected='selected'";
									}
									foreach ($tmpCurrentVariation as $tcv) {
										if (isset($selections[$tcv])) {
											if (!in_array($thisVariation, $selections[$tcv])) {
												$optionClass = "text-light-grey";
											}
										}
									}
									echo "<option value='$thisVariation' class='$optionClass' data-attr-name='$v_attr' data-attr-val='$v_val' $add2option>$v_val</option>\n\n";
								}
								echo "</select></div>";
							}
							echo "</div>";
						}
						//select attributes variations [-]
					}

					if ($productData->price_str_offer) {
						echo "<strong class='text-primary'>" . $productData->price_str_offer . "</strong>";
						if ($productData->prime) echo "<sup class='badge badge-primary' style='font-size:.6em;'><em>Prime</em></sup>";
						if ($row->price_str_lowest && $row->price_str_lowest !=  $row->price_str_offer) {
							echo " <em class='small text-secondary'>" . $zstore->lang("lowest_price") . ": " . $productData->price_str_lowest . "</em>";
						}
					} elseif ($productData->price_str_lowest) {
						echo "<em>" . $zstore->lang("lowest_price") . ": <strong>" . $productData->price_str_lowest . "</strong></em>";
					}

					echo "<div class='dropdown float-right'>
					  <button class='btn btn-secondary dropdown-toggle btn-xs' type='button' id='dropdownMenuButton' data-toggle='dropdown' aria-haspopup='true' aria-expanded='false'><i class='fa fa-share-alt'></i> " . $zstore->lang("share") . "</button>
					  <div class='dropdown-menu dropdown-menu-right' aria-labelledby='dropdownMenuButton'>
					    <a class='dropdown-item bg-facebook btn-facebook small open-external' href='" . $zstore->getSocialSharingURL("facebook") . "'><i class='fa fa-facebook'></i> " . $zstore->lang("share_on_facebook") . "</a>
					    <a class='dropdown-item bg-facebook btn-twitter small open-external' href='" . $zstore->getSocialSharingURL("twitter",$productData->title) . "'><i class='fa fa-twitter'></i> " . $zstore->lang("share_on_twitter") . "</a>
					    <a class='dropdown-item bg-facebook btn-google small open-external' href='" . $zstore->getSocialSharingURL("googlePlus") . "'><i class='fa fa-google-plus'></i> " . $zstore->lang("share_on_google") . "</a>
					  </div>
					</div>
					<div class='clearfix'></div>";
					echo "<div class='mt-20'>";
					if ($productData->inFavorites) {
						echo "<button class='btn btn-outline-secondary btn-circle js-btn-remove-from-favs tt' data-asin='$asin' title='" . $zstore->lang("title_remove_from_favorites") . "'><i class='fa fa-heart'></i></button>\n";	
					} else {
						echo "<button class='btn btn-outline-secondary btn-circle js-btn-add2favs tt' data-asin='$asin' title='" . $zstore->lang("title_add2favorites") . "'><i class='fa fa-heart-o'></i></button>\n";	
					}
					echo "<button type='button' class='btn btn-secondary btn-sm btn-zstore js-btn-add2cart' data-asin='$asin'><i class='fa fa-cart-plus'></i> " . $zstore->lang("add_to_cart") . "</button>
						<a href='" . $productData->item_url . "' class='btn btn-sm btn-amazon open-external float-right'><i class='fa fa-amazon'></i> " . $zstore->lang("amazon_item_page") . "</a></div>";
					echo "<div class='clearfix'></div>";

					echo "</div>";	//col
				
				?>
			</div>
		</div>
	</section>
<div class='clearfix'></div>

<?php
  $showUserReviews = $productData->has_reviews && $productData->show_reviews;

	if ($showUserReviews || $productData->editorial_reviews || $productData->video_url) {
?>
	<section class='section bg-light'>
		<div class='container'>
			<div class='row'>
				<?php
					//editorial and customer reviews
					echo "<div class='col-12'>";

					echo '<ul class="nav nav-tabs" role="tablist">';
					if ($productData->editorial_reviews) {
					  echo '<li class="nav-item">
					    <a class="nav-link active" data-toggle="tab" href="#editorial_reviews" role="tab" aria-controls="editorial_reviews" aria-selected="true">' . $zstore->lang("description") . '</a>
					  </li>';
					}
					if ($productData->video_url) {
						echo '<li class="nav-item">
						    <a class="nav-link ' . (!$productData->editorial_reviews ? "active" : "") . '" data-toggle="tab" href="#product_video" role="tab" aria-controls="product_video" aria-selected="false">' . $zstore->lang("product_video") . '</a>
						</li>';
					}
					if ($showUserReviews) {
						echo '<li class="nav-item">
						    <a class="nav-link ' . (!$productData->editorial_reviews && !$productData->video_url ? "active" : "") . '" data-toggle="tab" href="#customer_reviews" role="tab" aria-controls="customer_reviews" aria-selected="false">' . $zstore->lang("customer_reviews") . '</a>
						</li>';
					} 
					echo '</ul>';

					echo '<div class="tab-content card">';
						if ($productData->editorial_reviews) {
							echo '<div class="tab-pane fade show active card-body" id="editorial_reviews" role="tabpanel" aria-labelledby="editorial_reviews-tab">';
							foreach ($productData->editorial_reviews as $row) {

								$row->review = preg_replace('/third-col/', 'col-4 float-left mb-2', $row->review);


								echo "<h4>" . $row->source . "</h4>";
								echo "<p>" . $row->review . "</p>";
							}
							echo '</div>';
						}

						if ($productData->video_url) {
							echo '<div class="tab-pane fade ' . (!$productData->editorial_reviews ? "active show" : "") . ' card-body" id="product_video" role="tabpanel" aria-labelledby="product_video-tab">';


				      list($vw,$vh,$ratio) = $zstore->getVideoDimensions($productData->video_url,640);
				      // echo "<h4>" . $thisv->descr . "</h4>";
				      echo "<div class='embed-responsive embed-responsive-" . $ratio . "'>
					      	<iframe class='embed-responsive-item' src='" . $zstore->vUrlIFrameEmbedded($productData->video_url,0) . "' allowfullscreen></iframe>
					      </div>\n";

							echo '</div>';
						}

						if ($showUserReviews) {
							echo '<div class="tab-pane fade ' . (!$productData->editorial_reviews && !$productData->video_url ? "active show" : "") . ' card-body" id="customer_reviews" role="tabpanel" aria-labelledby="customer_reviews-tab">';
							echo "<div><iframe src='" . $productData->reviews_iframe_url . "' class='iframe-customer-reviews'></iframe></div>";
							echo '</div>';
						}
					echo "</div>"; //tab-content


					echo "</div>"; //col

					?>
				</div>
			</div>
		</section>
<?php
	}
?>





<?php
	if ($productData->show_other_group_items) {
		$suggestions = $zstore->getOtherGroupItems($productData->id);
		if ($suggestions) {
			echo "<section>";			
		
			echo "<div class='container'>";
			echo "<h3>" . $zstore->lang("hl_other_product_group_suggestions") . "</h3>";
			echo "<div class='row row-suggestions-group'>";

			foreach ($suggestions as $row) {
				$itemLink = $zstore->generateItemUrl($row->asin,$row->title);

				echo "<div class='col-sm-4 col-md-3 col-6 col-lg-3 suggestion-item'>
					<div class='card text-center'>
						<a href='" . $itemLink . "' class='no-text-decoration'>";
				if ($row->image_url) {
					echo "<img src='" . $zstore->getImgSizeUrl($row->image_url,"sm200") . "' class='img-fluid mx-auto mt-2' alt='' />";
				} else {
					echo "<i class='fa fa-cube fa-border text-secondary bg-light fa-no-item-pic-medium'></i>";
				}
				echo "</a>
						<div class='card-body'>
	          	<h6 class='card-title'>" . $row->title . "</h6>
	          	<a href='" . $itemLink . "' class='btn btn-secondary btn-zstore btn-block btn-sm mt-10'>" . $zstore->lang("more_details") . "</a>
	          </div>";
	      
	      echo "</div></div>";
			}
			
			echo "</div>"; //row			
			echo "<div class='row'><div class='col'><div class='slick-suggestions-group-arrow-holder'></div></div></div>";


			echo "</div>"; //container
			echo "</section>";
		}
	}
?>



<?php
	if ($productData->show_amz_suggestions) {
		$suggestions = $zstore->amzGetSuggestions($asin,$productData->link_amz_suggestions_to_amz);
		if ($suggestions) {
			echo "<section>";			
		
			echo "<div class='container'>";
			echo "<h3><i class='fa fa-amazon'></i> " . $zstore->lang("hl_current_amz_suggestions") . "</h3>";
			echo "<div class='row row-suggestions-amazon card-row0'>";

			foreach ($suggestions as $row) {
				$itemLink = $itemLinkClass= null;
				switch ($productData->link_amz_suggestions_to_amz) {
					case 1: 
						$itemLink = $row->item_url;
						$itemLinkClass = "open-external";
						break;
					case 0: 
					default:
						$itemLink = $zstore->generateItemUrl($row->asin,$row->title);
						break;
				}

				echo "<div class='col-sm-4 col-md-3 col-6 col-lg-3 suggestion-item'>
					<div class='card text-center'>
						<a href='" . $itemLink . "' class='" . $itemLinkClass . " no-text-decoration'>";
				if ($row->image_url) {
					echo "<img src='" . $row->image_url_medium . "' class='img-fluid mx-auto mt-2' alt='' />";
				} else {
					echo "<i class='fa fa-cube fa-border text-secondary bg-light fa-no-item-pic-medium'></i>";
				}
				echo "</a>
						<div class='card-body'>
	          	<h6 class='card-title'>" . $row->title . "</h6>";
	      if ($productData->link_amz_suggestions_to_amz) {
	        echo "<a href='" . $row->item_url . "' class='" . $itemLinkClass . " btn btn-warning btn-block btn-sm mt-10'><i class='fa fa-amazon'></i> " . $zstore->lang("amazon_item_page") . "</a>";
	      } else {
	        echo "<a href='" . $itemLink . "' class='btn btn-secondary btn-zstore btn-block btn-sm mt-10'>" . $zstore->lang("more_details") . "</a>";
	      }
	      echo "</div>
					</div></div>";
			}

			echo "</div>"; //row			
			echo "<div class='row'><div class='col'><div class='slick-suggestions-arrow-holder'></div></div></div>";


			echo "</div>"; //container
			echo "</section>";
		}
	}
?>


<div class='hidden-content js-hide'>
	<input type='hidden' name='currentPath' value='<?php echo $productData->url; ?>' />
</div>

<?php include("footer.php"); ?>