<?php

$srch = isset($_REQUEST["srch"]) ? trim($_REQUEST["srch"]) : null;

$filter = array();

$filter["srch"] = $srch;
$filter["imported"] = true;

$products = $zstore->getProducts($filter);

//set page data
$zstore->setSite(
	array("title" => $zstore->lang("search_results")
			 	)
);

$currentPage = "search";

$srch = htmlEntities($srch, ENT_QUOTES);

include("header.php");

?>

  	<div class="card card-top-line">
		  <div class="card-header">
		  	<div class='container'>
			  	<div class='row'>
			  		<div class='col-12'>
						  <ol class="breadcrumb zstore-breadcrumb">
						    <li class="breadcrumb-item"><a href="<?php echo $zstore->instDir; ?>/">Home</a></li>
						    <li class="breadcrumb-item active"><?php echo $zstore->lang("search_results"); ?></li>
						  </ol>
			  		</div>
			  	</div>
			  </div>
		  </div>
		 </div>


<?php

if (!$srch) {
	echo "<section>
		<div class='container mt-5'>
				<div class='alert alert-info'>" . $zstore->lang("error_no_search_term") . "</div>
		</div>
	</section>";
} elseif (!$products) {
	echo "<section>
		<div class='container mt-5'>
				<div class='alert alert-info'>" . sprintf($zstore->lang("info_no_search_results"),$srch) . "</div>
		</div>
	</section>";	
} else {

?>



<section class='section'>
	<div class='container'>

<?php
	$pager = null;
	$thisUrlPath = $_SERVER["PHP_SELF"];
	if ($zstore->pages > 1) {
    $navPages = $zstore->drawPagination($zstore->pages,$zstore->p); 
    if ($navPages) {
      // $pager .= "<div class='row'>";
      // $pager .= "<div class='col-xs-12 text-right'>";
      $pager .= "<ul class='pagination pagination-sm justify-content-end mb-20'>";

       $pager .= "<li class='page-item " . ($zstore->p && $zstore->p > 1 ? "" : "disabled") . "'><a href='$thisUrlPath?p=" . ($zstore->p-1) . "&amp;srch=$srch' class='page-link'><i class='fa fa-chevron-left'></i></a></li>";

      foreach ($navPages as $row) {
          if (isset($row["P"]) && $row["P"]) {
            $pager .= "<li class='page-item " . (isset($row["ACTIVE"]) && $row["ACTIVE"] ? "active" : "") . "'><a href='$thisUrlPath?p=" . $row["P"] . "&amp;srch=$srch' class='page-link'>" . $row["P"] . "</a></li>";
          }
          if (isset($row["SEP"]) && $row["SEP"]) {
            $pager .= "<li class='page-item disabled'><span class='page-link'>...</span></li>";
          }
      }

      $pager .= "<li class='page-item " . ($zstore->p < $zstore->pages ? "" : "disabled") . "'><a href='$thisUrlPath?p=" . ($zstore->p+1) . "&amp;srch=$srch' class='page-link'><i class='fa fa-chevron-right'></i></a></li>";
      
      $pager .= "</ul>";
    }
   }

  echo $pager;
?>


		<div class='row row-cards row-product-cards masonry-this'>
			<?php
				foreach ($products as $row) {
					echo "<div class='col-12 col-sm-6 col-md-4 col-lg-3 card-holder'>
						<div class='card'>
							<a href='" . $row->url . "'>";
					if ($row->image_url) {
						echo "<img src='" . $zstore->getImgSizeUrl($row->image_url,"md") . "' class='card-img-top mx-auto p-3' alt='' />";
					} else {
						echo "<i class='fa fa-cube fa-border text-secondary bg-light fa-no-item-pic'></i>";
					}
					echo "</a>
							<div class='card-body'>
								<h6 class='card-title'>" . $row->titleDB . "</h6>
								<div class='text-right small'><strong class='text-primary'>" . $row->price_str_offer . "</strong></div>";
					if ($row->price_str_lowest !=  $row->price_str_offer) {
						echo "<div class='text-right small text-muted'><em>" . $row->price_str_lowest . "</em></div>";
					}
					echo "</div>
						</div>				
					</div>";				
				}
			?>
		</div>

<?php

	//Footer Pagination
	echo $pager;
?>
	</div>
</section>

<?php

	} //$products

?>


<?php


	//Amazon Search Results????
	if ($zstore->config->show_amz_search_results) {
		$amzSearchResults = $zstore->searchAmazonByKeyword($srch,"All",$zstore->config->link_amz_search_results_to_amz);
		if ($amzSearchResults->results) {
			echo "<section>";			
		
			echo "<div class='container'>";
			echo "<h3><i class='fa fa-amazon'></i> " . $zstore->lang("hl_amz_search_results") . "</h3>";
			echo "<div class='row row-suggestions-amazon'>";

			foreach ($amzSearchResults->results as $row) {
				$itemLink = $itemLinkClass= null;
				switch ($zstore->config->link_amz_search_results_to_amz) {
					case 1: 
						$itemLink = $row->item_url;
						$itemLinkClass = "open-external";
						break;
					case 0: 
					default:
						$itemLink = $zstore->generateItemUrl($row->asin,$row->title);
						break;
				}

				echo "<div class='col-sm-4 col-md-3 col-6 col-lg-4 suggestion-item'>
					<div class='card text-center'>
						<a href='" . $itemLink . "' class='" . $itemLinkClass . " no-text-decoration'>";
				if ($row->image_url) {
					echo "<img src='" . $row->image_url_medium . "' class='img-fluid mx-auto mt-2' alt='' />";
				} else {
					echo "<i class='fa fa-cube fa-border text-secondary bg-light fa-no-item-pic-medium'></i>";
				}
				echo "</a>
						<div class='card-body'>
	          	<h6 class='card-title'>" . $row->title . "</h6>";
	      if ($zstore->config->link_amz_search_results_to_amz) {
	        echo "<a href='" . $row->item_url . "' class='" . $itemLinkClass . " btn btn-warning btn-block btn-sm mt-10'><i class='fa fa-amazon'></i> " . $zstore->lang("amazon_item_page") . "</a>";
	      } else {
	        echo "<a href='" . $itemLink . "' class='btn btn-secondary btn-zstore btn-block btn-sm mt-10'>" . $zstore->lang("more_details") . "</a>";
	      }
	      echo "</div>
					</div></div>";
			}
			if ($zstore->config->link_to_more_results_on_amz && $amzSearchResults->MoreSearchResultsUrl) {
				echo "<div class='col-sm-4 col-md-3 col-6 col-lg-4 suggestion-item'>
					<div class='card text-center'>
						<a href='" . $amzSearchResults->MoreSearchResultsUrl . "' class='open-external no-text-decoration'><i class='fa fa-amazon fa-border text-dark bg-warning fa-no-item-pic-medium'></i></a>
						<div class='card-body'>
	          	<h6 class='card-title'>" . $zstore->lang("amz_more_results") . "</h6>
	          	<a href='" . $amzSearchResults->MoreSearchResultsUrl . "' class='open-external btn btn-warning btn-block btn-sm mt-10'><i class='fa fa-amazon'></i> " . $zstore->lang("results_on_amazon") . "</a>
	          </div>
					</div>
				</div>";

		}
			

			echo "</div>"; //row			
			echo "<div class='row'><div class='col'><div class='slick-suggestions-arrow-holder'></div></div></div>";


			echo "</div>"; //container
			echo "</section>";
		}
	}



?>





<?php include("footer.php"); ?>