<?php
header("Content-Type: text/html; charset=utf-8" );
include("classes/zstore.class.php");
$zstore = new zstore(true);

include("admin/header.php");
?>

    <div class="card card-top-line">
      <div class="card-header">
        <div class='container'>
          <div class='row'>
            <div class='col-12'>
              <ol class="breadcrumb zstore-breadcrumb">
                <li class="breadcrumb-item active">Installation</li>
              </ol>
            </div>
          </div>
        </div>
      </div>
     </div>

    <div class="container mt-20">
      <div class='row'>
        <div class='col'>


<h2 class='mb-3'><i class='fa fa-fw fa-z'></i>oaBoutique V<?php echo number_format($zstore->initVersion,2); ?> Installer</h2>


<?php

if ($zstore->error) {
    $error[] = $zstore->error;
}

//dircheck xml
$error = array();
if (!is_dir($zstore->xmlCacheDir)) {
  $error[] = "Le dossier xml cache <b>" . $zstore->xmlCacheDir . "</b> <code>\$zstore->xmlCacheDir</code> ne peut pas &ecirc;tre pas trouv&eacute;. Le r&eacute;pertoire peut &ecirc;tre chang&eacute; dans classes/zstore.class.php";
} elseif (!is_writable($zstore->xmlCacheDir)) {
  $error[] = "Le dossier cache <b>" . $zstore->xmlCacheDir . "</b> <code>\$zstore->xmlCacheDir</code> n'est pas accessible en &eacute;criture.<br/>Veuillez faire un <b>chmod 757</b> pour r&eacute;parer ceci.";
} elseif (!file_exists(".htaccess")) {
  $error[] = "Le fichier <b>.htaccess</b> est manquant, veuillez t&eacute;l&eacute;charger tous les fichiers du dossier htdocs.<br />
    C'est directement dans le dossier htdocs, peut-&ecirc;tre que le fichier est cach&eacute; sur votre syst&egrave;me, sur MAC essayez <i>Chercher <i class='fa fa-angle-right'></i> Voir <i class='fa fa-angle-right'></i> Afficher les fichiers du syst&egrave;me</i>.";
} else {
  $success[] = "Le r&eacute;pertoire cache <b>" . $zstore->xmlCacheDir . "</b> <code>\$zstore->xmlCacheDir</code> a &eacute;t&eacute; trouv&eacute; et est fonctionnel.";
  $success[] = "Le fichier <b>.htaccess</b> a bien &eacute;t&eacute; trouv&eacute;.";
}




//databasechecks
//db credentialscheck via the config.php
//structure checks
if (!$error) {
  $neededTables = array("amazon_marketplaces",
    "amazon_searchindexes",
    "categories",
    "category_products",
    "config",
    "editorial_reviews",
    "error_log",
    "image_sets",
    "lang",
    "products",
    "variations"
    );
  //add prefixes
  $neededTables = preg_filter('/^/', $zstore->tablePrefix, $neededTables);

  $SQL_queries[] = "CREATE TABLE `" . $zstore->tablePrefix . "amazon_marketplaces` (
     `id` int(11) NOT NULL AUTO_INCREMENT,
     `descr` varchar(100) COLLATE utf8_bin NOT NULL,
     PRIMARY KEY (`id`)
    )";
  $SQL_queries[] = "INSERT INTO `" . $zstore->tablePrefix . "amazon_marketplaces` (`id`, `descr`) VALUES
    (1, 'webservices.amazon.com'),
    (2, 'webservices.amazon.com.br'),
    (3, 'webservices.amazon.ca'),
    (4, 'webservices.amazon.cn'),
    (5, 'webservices.amazon.de'),
    (6, 'webservices.amazon.es'),
    (7, 'webservices.amazon.fr'),
    (8, 'webservices.amazon.in'),
    (9, 'webservices.amazon.it'),
    (10, 'webservices.amazon.co.jp'),
    (11, 'webservices.amazon.com.mx'),
    (12, 'webservices.amazon.co.uk'),
    (13, 'webservices.amazon.com.tr'),
    (14, 'webservices.amazon.com.au')";
  $SQL_queries[] = "CREATE TABLE `" . $zstore->tablePrefix . "amazon_searchindexes` (
     `id` int(11) NOT NULL AUTO_INCREMENT,
     `descr` varchar(32) COLLATE utf8_bin NOT NULL,
     PRIMARY KEY (`id`)
    )";
  $SQL_queries[] = "INSERT INTO `" . $zstore->tablePrefix . "amazon_searchindexes` (`id`, `descr`) VALUES
    (1, 'All'),
    (2, 'Apparel'),
    (3, 'Appliances'),
    (4, 'Automotive'),
    (5, 'Baby'),
    (6, 'Beauty'),
    (7, 'Blended'),
    (8, 'Books'),
    (9, 'Classical'),
    (10, 'DVD'),
    (11, 'Electronics'),
    (12, 'GiftCards'),
    (13, 'Grocery'),
    (14, 'HealthPersonalCare'),
    (15, 'HomeGarden'),
    (16, 'Jewelry'),
    (17, 'KindleStore'),
    (18, 'Kitchen'),
    (19, 'Lighting'),
    (20, 'Luggage'),
    (21, 'MP3Downloads'),
    (22, 'MobileApps'),
    (23, 'Music'),
    (24, 'MusicalInstruments'),
    (25, 'OfficeProducts'),
    (26, 'PCHardware'),
    (27, 'PetSupplies'),
    (28, 'Shoes'),
    (29, 'Software'),
    (30, 'SportingGoods'),
    (31, 'Tools'),
    (32, 'Toys'),
    (33, 'UnboxVideo'),
    (34, 'VHS'),
    (35, 'VideoGames'),
    (36, 'Watches')";
  $SQL_queries[] = "CREATE TABLE `" . $zstore->tablePrefix . "categories` (
     `id` int(11) NOT NULL AUTO_INCREMENT,
     `parent` int(11) NOT NULL DEFAULT '0',
     `descr` varchar(30) COLLATE utf8_bin NOT NULL,
     `short_intro` varchar(1000) COLLATE utf8_bin DEFAULT NULL,
     `page_title` varchar(150) COLLATE utf8_bin DEFAULT NULL,
     `page_descr` text COLLATE utf8_bin,
     `headline` varchar(150) COLLATE utf8_bin DEFAULT NULL,
     `long_intro` text COLLATE utf8_bin,
     `pos` tinyint(3) unsigned NOT NULL DEFAULT '99',
     `top_cat` tinyint(1) NOT NULL DEFAULT '0',
     `status` tinyint(1) NOT NULL DEFAULT '1',
     `created` datetime NOT NULL,
     `edited` datetime DEFAULT NULL ON UPDATE CURRENT_TIMESTAMP,
     PRIMARY KEY (`id`)
    )";
  $SQL_queries[] = "CREATE TABLE `" . $zstore->tablePrefix . "category_products` (
     `id` int(11) NOT NULL AUTO_INCREMENT,
     `product_id` int(11) NOT NULL,
     `category_id` int(11) NOT NULL,
     `created` datetime NOT NULL,
     PRIMARY KEY (`id`)
    )";
  $SQL_queries[] = "CREATE TABLE `" . $zstore->tablePrefix . "config` (
     `id` int(11) NOT NULL AUTO_INCREMENT,
     `amz_marketplace` varchar(100) COLLATE utf8_bin DEFAULT NULL,
     `amz_tag` varchar(100) COLLATE utf8_bin DEFAULT NULL,
     `amz_access_key` varchar(100) COLLATE utf8_bin DEFAULT NULL,
     `amz_secret_key` varchar(100) COLLATE utf8_bin DEFAULT NULL,
     `affiliate_username` varchar(100) COLLATE utf8_bin DEFAULT NULL,
     `lang` varchar(10) COLLATE utf8_bin DEFAULT 'en',
     `site_title` varchar(100) COLLATE utf8_bin DEFAULT NULL,
     `site_author` varchar(100) COLLATE utf8_bin DEFAULT NULL,
     `meta_description` varchar(1000) COLLATE utf8_bin DEFAULT NULL,
     `meta_keywords` varchar(333) COLLATE utf8_bin DEFAULT NULL,
     `contact_mail` varchar(150) COLLATE utf8_bin DEFAULT NULL,
     `categories_in_navbar` tinyint(3) unsigned NOT NULL DEFAULT '0',
     `show_amz_search_results` tinyint(1) NOT NULL DEFAULT '1',
     `link_amz_search_results_to_amz` tinyint(1) NOT NULL DEFAULT '0',
     `link_to_more_results_on_amz` tinyint(1) NOT NULL DEFAULT '0',
     `default_products_show_amz_suggestions` tinyint(1) NOT NULL DEFAULT '1',
     `default_products_link_amz_suggestions_to_amz` tinyint(1) NOT NULL DEFAULT '1',
     `log_errors` tinyint(1) DEFAULT '0',
     `created` datetime NOT NULL,
     `edited` datetime DEFAULT NULL ON UPDATE CURRENT_TIMESTAMP,
     `version` FLOAT NOT NULL DEFAULT '" . floatval($zstore->initVersion) . "',
     PRIMARY KEY (`id`)
    )";
  $SQL_queries[] = "INSERT INTO `" . $zstore->tablePrefix . "config` (`id`, `created`) VALUES
    (1,now());";
  $SQL_queries[] = "CREATE TABLE `" . $zstore->tablePrefix . "editorial_reviews` (
     `id` int(11) NOT NULL AUTO_INCREMENT,
     `asin` varchar(25) COLLATE utf8_bin NOT NULL,
     `source` varchar(100) COLLATE utf8_bin DEFAULT NULL,
     `review` text COLLATE utf8_bin,
     `pos` int(3) NOT NULL DEFAULT '99',
     `created` datetime NOT NULL,
     `edited` datetime DEFAULT NULL,
     PRIMARY KEY (`id`)
    )";
  $SQL_queries[] = "ALTER TABLE `" . $zstore->tablePrefix . "editorial_reviews` ADD INDEX(`asin`)";
  $SQL_queries[] = "CREATE TABLE `" . $zstore->tablePrefix . "error_log` (
     `id` int(11) NOT NULL AUTO_INCREMENT,
     `error_type` varchar(10) COLLATE utf8_bin DEFAULT 'php',
     `message` varchar(255) COLLATE utf8_bin NOT NULL,
     `file` varchar(255) COLLATE utf8_bin NOT NULL,
     `line` int(11) NOT NULL,
     `url` varchar(500) COLLATE utf8_bin NOT NULL,
     `referer` varchar(500) COLLATE utf8_bin NOT NULL,
     `ip` varchar(50) COLLATE utf8_bin NOT NULL,
     `created` datetime NOT NULL,
     PRIMARY KEY (`id`)
    )";
  $SQL_queries[] = "CREATE TABLE `" . $zstore->tablePrefix . "image_sets` (
     `id` int(11) NOT NULL AUTO_INCREMENT,
     `asin` varchar(25) COLLATE utf8_bin NOT NULL,
     `image_url` varchar(150) COLLATE utf8_bin NOT NULL,
     `pos` int(3) unsigned NOT NULL DEFAULT '99',
     `created` datetime NOT NULL,
     PRIMARY KEY (`id`)
    )";
  $SQL_queries[] = "ALTER TABLE `" . $zstore->tablePrefix . "image_sets` ADD INDEX(`asin`)";
  $SQL_queries[] = "CREATE TABLE `" . $zstore->tablePrefix . "lang` (
     `id` int(11) NOT NULL AUTO_INCREMENT,
     `lang_key` varchar(5) COLLATE utf8_bin NOT NULL DEFAULT 'en',
     `short_key` varchar(200) COLLATE utf8_bin NOT NULL,
     `descr` text COLLATE utf8_bin,
     `created` datetime NOT NULL,
     `edited` datetime DEFAULT NULL ON UPDATE CURRENT_TIMESTAMP,
     PRIMARY KEY (`id`)
    )";
  $SQL_queries[] = "INSERT INTO `" . $zstore->tablePrefix . "lang` (`id`, `lang_key`, `short_key`, `descr`, `created`, `edited`) VALUES
    (1, 'en', 'send', 'Envoyer un message', '2017-11-07 17:20:21', NULL),
    (2, 'en', 'imprint', 'Informations Légales', '2017-12-12 14:40:45', '2018-04-24 11:00:53'),
    (3, 'en', 'product_categories', 'Catégories de Produits', '2017-12-12 15:17:28', NULL),
    (4, 'en', 'all_categories', 'Toutes les Catégories', '2017-12-13 16:14:56', NULL),
    (6, 'en', 'view_products', 'Voir les Produits', '2017-12-15 14:40:05', NULL),
    (7, 'en', 'actors', 'Acteurs', '2017-12-29 15:46:37', '2018-04-24 15:22:41'),
    (9, 'en', 'x_minutes', '{a:1} Minutes', '2017-12-29 16:21:54', '2017-12-29 16:22:33'),
    (10, 'en', 'description', 'Description', '2017-12-29 16:39:28', NULL),
    (11, 'en', 'customer_reviews', 'Avis des Clients', '2017-12-29 16:39:28', NULL),
    (12, 'en', 'add_to_cart', 'Ajouter Au Panier', '2017-12-29 17:11:50', NULL),
    (13, 'en', 'share_on_facebook', 'Partager sur Facebook', '2017-12-29 17:12:41', '2017-12-29 17:13:21'),
    (14, 'en', 'share_on_twitter', 'Partager sur Twitter', '2017-12-29 17:12:41', '2017-12-29 17:13:21'),
    (15, 'en', 'amazon_item_page', 'Page du Produit', '2017-12-29 17:15:41', NULL),
    (16, 'en', 'lowest_price', 'Le plus bas', '2017-12-30 09:12:06', NULL),
    (17, 'en', 'share_on_google', 'Partager sur google+', '2017-12-30 11:28:15', '2017-12-30 11:28:56'),
    (18, 'en', 'share', 'Partager', '2017-12-30 11:30:56', NULL),
    (19, 'en', 'error_unsufficient_data', 'Données insuffisantes.', '2017-12-30 13:48:40', NULL),
    (20, 'en', 'success_item_x_added2cart', 'Cet article {a:1} a été ajouté à votre panier.', '2017-12-30 16:04:33', NULL),
    (22, 'en', 'info_no_items_in_cart', 'Actuellement, votre panier est vide.', '2018-01-02 15:59:23', NULL),
    (23, 'en', 'info_checkout_on_amazon', 'Quand vous cliquez sur le bouton de paiement, votre article sera placé dans votre panier Amazon.', '2018-01-02 16:09:18', NULL),
    (24, 'en', 'descr_product_name', 'Nom du Produit', '2018-01-02 16:18:41', NULL),
    (25, 'en', 'descr_unit_price', 'Prix', '2018-01-02 16:18:41', NULL),
    (26, 'en', 'descr_quantity', 'Quantité', '2018-01-02 16:18:41', NULL),
    (27, 'en', 'descr_subtotal', 'Total', '2018-01-02 16:18:41', NULL),
    (28, 'en', 'descr_empty_cart', 'Panier vide', '2018-01-02 16:18:41', NULL),
    (29, 'en', 'checkout', 'Commander avec Amazon', '2018-01-02 18:38:30', '2018-01-02 18:52:44'),
    (30, 'en', 'seller', 'Vendeur', '2018-01-02 18:50:11', NULL),
    (31, 'en', 'error_remove_item_no_cart', 'Votre panier est vide. Peut-être que vous avez déjà vidé/retirer le produit de votre panier.<br />Essayez de recharger cette page.', '2018-01-04 16:35:07', NULL),
    (32, 'en', 'success_item_removed_from_cart', 'Le produit a été supprimé de votre panier.', '2018-01-04 16:44:43', NULL),
    (33, 'en', 'sold_by', 'Vendu par', '2018-01-05 16:38:09', NULL),
    (34, 'en', 'success_info_cart_empty_now', 'Maintenant, aucun article se trouve dans votre panier.', '2018-01-05 16:56:19', NULL),
    (35, 'en', 'success_cart_emptied', 'Votre panier a été vidé avec succès.', '2018-01-06 14:53:43', NULL),
    (36, 'en', 'success_item_number_changed', 'Le nombre du produit a été mis à jour avec succès.', '2018-01-06 15:36:21', '2018-01-06 15:59:59'),
    (37, 'en', 'hl_current_amz_suggestions', 'Les Suggestions Actuelles par Amazon', '2018-01-24 14:43:04', NULL),
    (38, 'en', 'more_details', 'Plus de détails', '2018-01-24 16:04:52', '2018-01-24 16:05:08'),
    (39, 'en', 'hl_other_product_group_suggestions', 'Autres articles dans notre catégorie de produits', '2018-01-30 10:50:49', '2018-01-30 10:51:24'),
    (40, 'en', 'error_no_search_term', 'Vous devez inscrire des termes, produits, etc que vous aimeriez trouver.', '2018-01-30 12:03:28', NULL),
    (41, 'en', 'info_no_search_results', 'Votre recherche <strong>&raquo;{a:1}&laquo;</strong> ne correspond à aucun produit dans notre boutique.', '2018-01-30 12:03:32', '2018-01-31 10:42:22'),
    (42, 'en', 'search_results', 'Résultats de la recherche', '2018-01-30 14:35:58', NULL),
    (43, 'en', 'hl_amz_search_results', 'Résultats de recherche Amazon', '2018-01-30 15:50:22', NULL),
    (44, 'en', 'amz_more_results', 'Plus de résultats', '2018-01-30 16:11:15', NULL),
    (45, 'en', 'results_on_amazon', 'sur Amazon', '2018-01-30 16:12:48', NULL),
    (46, 'en', 'product_video', 'Vidéo du Produit', '2018-03-21 17:29:44', NULL),
    (48, 'en', 'shopping_cart', 'Panier', '2018-04-25 10:11:59', '2018-04-25 10:12:09'),
    (49, 'en', 'success_item_x_added2favorites', 'Le produit {a:1} ajouté avec succès à vos Favoris.', '2018-08-26 18:17:21', '2018-08-26 18:18:11'),
    (50, 'en', 'title_remove_from_favorites', 'supprimer de mes Favoris', '2018-08-26 18:31:12', NULL),
    (51, 'en', 'title_add2favorites', 'ajouter aux Favoris', '2018-08-26 18:31:28', NULL),
    (52, 'en', 'success_item_x_removed_from_favorites', 'Le produit {a:1} a été supprimé de vos favoris avec succès.', '2018-08-26 18:42:14', NULL),
    (53, 'en', 'hl_favorites', 'Mes Favoris', '2018-08-27 10:17:46', NULL),
    (54, 'en', 'bc_favorites', 'Favoris', '2018-08-27 10:17:46', NULL),
    (55, 'en', 'info_no_favorites', 'Aucun article est présent dans votre liste de Favoris.', '2018-08-27 11:33:46', '2018-08-27 11:34:05'),
    (56, 'en', 'actors2', 'Acteurs de la prochaine génération x2000', '2018-08-27 16:51:10', '2018-08-31 13:47:15'),
    (57, 'en', 'running_time', 'Temps', '2018-08-27 17:25:31', NULL),
    (58, 'en', 'view_all_products', 'Voir tous les produits', '2018-09-28 15:50:43', NULL),
    (59, 'en', 'hl-products-map', 'Carte des Produits', '2018-10-31 16:07:00', NULL),
    (60, 'en', 'hl-prodmap-unsorted-itemsblock', 'Non triés', '2018-10-31 16:50:00', NULL),
    (61, 'en', 'rating_x_of_5_with_reviews', '{a:1} étoiles sur 5 avec {a:2} Revues', '2019-01-08 11:14:00', NULL),
    (62, 'en', 'descr_product_variation', 'Variations de produit', '2019-04-09 15:30:00', NULL),
    (63, 'en', 'cancel', 'Annuler', '2019-04-09 15:30:00', NULL)
    ";
  $SQL_queries[] = "CREATE TABLE `" . $zstore->tablePrefix . "products` (
     `id` int(11) NOT NULL AUTO_INCREMENT,
     `asin` varchar(25) COLLATE utf8_bin NOT NULL,
     `parent_asin` varchar(25) COLLATE utf8_bin DEFAULT NULL,
     `ean` varchar(50) COLLATE utf8_bin DEFAULT NULL,
     `title` varchar(333) COLLATE utf8_bin DEFAULT NULL,
     `title_custom` varchar(333) COLLATE utf8_bin DEFAULT NULL,
     `meta_keywords` varchar(333) COLLATE utf8_bin DEFAULT NULL,
     `meta_description` varchar(555) COLLATE utf8_bin DEFAULT NULL,
     `search_keywords` varchar(333) COLLATE utf8_bin DEFAULT NULL,
     `item_url` varchar(333) COLLATE utf8_bin DEFAULT NULL,
     `wishlist_url` varchar(333) COLLATE utf8_bin DEFAULT NULL,
     `reviews_external_url` varchar(333) COLLATE utf8_bin DEFAULT NULL,
     `reviews_iframe_url` varchar(333) COLLATE utf8_bin DEFAULT NULL,
     `reviews_iframe_url_last_update` datetime DEFAULT CURRENT_TIMESTAMP,
     `has_reviews` tinyint(1) DEFAULT '0',
     `show_reviews` tinyint(1) NOT NULL DEFAULT '1',
     `rating` float NOT NULL DEFAULT '0',
     `last_rating_update` datetime DEFAULT NULL,
     `rating_dom` text COLLATE utf8_bin,
     `reviews` int(11) DEFAULT '0',
     `features` text COLLATE utf8_bin,
     `brand` varchar(150) COLLATE utf8_bin DEFAULT NULL,
     `product_group` varchar(150) COLLATE utf8_bin DEFAULT NULL,
     `actors` varchar(333) COLLATE utf8_bin DEFAULT NULL,
     `release_date` date DEFAULT NULL,
     `running_time` int(11) DEFAULT NULL,
     `platform` varchar(150) COLLATE utf8_bin DEFAULT NULL,
     `is_movie` tinyint(1) NOT NULL DEFAULT '0',
     `image_url` varchar(150) COLLATE utf8_bin DEFAULT NULL,
     `video_url` varchar(150) COLLATE utf8_bin DEFAULT NULL,
     `show_amz_suggestions` tinyint(1) NOT NULL DEFAULT '1',
     `link_amz_suggestions_to_amz` tinyint(1) NOT NULL DEFAULT '0',
     `show_other_items_of_group` tinyint(1) NOT NULL DEFAULT '1',
     `show_own_suggestions` tinyint(1) NOT NULL DEFAULT '0',
     `show_other_group_items` tinyint(1) NOT NULL DEFAULT '1',
     `price_str_lowest` varchar(100) COLLATE utf8_bin DEFAULT NULL,
     `price_str_offer` varchar(100) COLLATE utf8_bin DEFAULT NULL,
     `offers_total` INT(11) NOT NULL DEFAULT '-1',
     `last_price_update` datetime DEFAULT NULL,
     `prime` tinyint(1) DEFAULT '0',
     `variations_total` INT(11) NOT NULL DEFAULT '0', 
     `variation_dimensions` TEXT COLLATE utf8_bin default null,
     `variations_price_str_lowest` VARCHAR(100) COLLATE utf8_bin DEFAULT NULL,
     `variations_price_str_highest` VARCHAR(100) COLLATE utf8_bin DEFAULT NULL,
     `created` datetime NOT NULL,
     `source` varchar(25) COLLATE utf8_bin NOT NULL DEFAULT 'admin-import',
     `edited` datetime DEFAULT NULL,
     `imported` datetime DEFAULT NULL,
     `updated` datetime DEFAULT NULL,
     `import_failed` datetime DEFAULT NULL,
     `dev_flag` tinyint(1) NOT NULL DEFAULT '0',
     PRIMARY KEY (`id`)
    )";
  $SQL_queries[] = "ALTER TABLE `" . $zstore->tablePrefix . "products` ADD INDEX(`asin`)";
  $SQL_queries[] = "CREATE TABLE `" . $zstore->tablePrefix . "variations` (
    `id` int(11) NOT NULL AUTO_INCREMENT,
    `asin` varchar(25) COLLATE utf8_bin NOT NULL,
    `parent_asin` varchar(25) COLLATE utf8_bin NOT NULL,
    `title` VARCHAR(333) COLLATE utf8_bin NOT NULL,
    `image_url` varchar(150) COLLATE utf8_bin DEFAULT NULL,
    `attr1_name` varchar(100) COLLATE utf8_bin DEFAULT NULL,
    `attr1_value` varchar(100) COLLATE utf8_bin DEFAULT NULL,
    `attr2_name` varchar(100) COLLATE utf8_bin DEFAULT NULL,
    `attr2_value` varchar(100) COLLATE utf8_bin DEFAULT NULL,
    `attr3_name` varchar(100) COLLATE utf8_bin DEFAULT NULL,
    `attr3_value` varchar(100) COLLATE utf8_bin DEFAULT NULL,
    `attr4_name` varchar(100) COLLATE utf8_bin DEFAULT NULL,
    `attr4_value` varchar(100) COLLATE utf8_bin DEFAULT NULL,
    `attr5_name` varchar(100) COLLATE utf8_bin DEFAULT NULL,
    `attr5_value` varchar(100) COLLATE utf8_bin DEFAULT NULL,
    `attr6_name` varchar(100) COLLATE utf8_bin DEFAULT NULL,
    `attr6_value` varchar(100) COLLATE utf8_bin DEFAULT NULL,
    `attr7_name` varchar(100) COLLATE utf8_bin DEFAULT NULL,
    `attr7_value` varchar(100) COLLATE utf8_bin DEFAULT NULL,
    `attr8_name` varchar(100) COLLATE utf8_bin DEFAULT NULL,
    `attr8_value` varchar(100) COLLATE utf8_bin DEFAULT NULL,
    `attr9_name` varchar(100) COLLATE utf8_bin DEFAULT NULL,
    `attr9_value` varchar(100) COLLATE utf8_bin DEFAULT NULL,
    `attr10_name` varchar(100) COLLATE utf8_bin DEFAULT NULL,
    `attr10_value` varchar(100) COLLATE utf8_bin DEFAULT NULL,
    `created` datetime NOT NULL,
    PRIMARY KEY (`id`)
  )";

  if (isset($_REQUEST["todo"]) && $_REQUEST["todo"] == "createStructure") {
    foreach ($SQL_queries as $sql) {
      $zstore->dbquery($sql);
      // if (preg_match('/create/i',$sql)) {echo $sql . "<br />";}
    }
  }
  $res = $zstore->dbquery("show tables from `" . $zstore->dbName . "`");
  $foundTables = 0;
  while ($row = mysqli_fetch_object($res)) {
    if (in_array($row->{"Tables_in_".$zstore->dbName}, $neededTables)) $foundTables++;
  }
  if ($foundTables < count($neededTables)) {
    $this_error = "<div class='setuperror'><b>tables nécessaires non trouvées.</b><br>
      Veuillez créer ces tables avec ces requêtes <strong>or</strong> cliquez <a href='?todo=createStructure' class='btn btn-primary btn-sm'>juste ici</a> pour créer les tables automatiquement.<br /><br />";

    foreach ($SQL_queries as $sql) {
      $this_error .= "<pre class='syntax-highlight'>" . $zstore->highlightText($sql) . "</pre>";
    }

    $this_error .= "</div>";
    $error[] = $this_error;
  } else {
    $success[] = "Structure de base de données nécessaire trouvée.";
  }
}

if ($error) {
  echo "<div class='alert alert-danger'><strong>Des erreurs sont survenues</strong><ul><li>" . implode("</li><li>",$error) . "</li></ul></div>";
} elseif ($success) {
  echo "<div class='alert alert-success'><strong>Installation terminée</strong><ul><li>" . implode(" <i class='icon-ok'></i></li><li>",$success) . " <i class='icon-ok'></i></li></ul>Maintenant, vous devez renommer ou supprimer setup.php.</div>";
}
if ($zstore->adminPass == "pass" || $zstore->adminUser == "admin") $secnotes[] = "Vous devriez aussi changer <code>\$zstore->adminUser</code> et/ou <code>\$zstore->adminPass</code> pour des questions de sécurité.";
if (file_exists("z-admin.php")) $secnotes[] = "Vous devriez renommer le fichier admin (z-admin.php).";
if ($secnotes) {
  echo "<div class='alert alert-warning'><strong>Conseils de sécurité</strong><ul><li>" . implode("</li><li>",$secnotes) . "</li></ul></div>";
}



echo "</div></div></div>"; //col, row, container
include("admin/footer.php");

?>
