<?php
header("Content-Type: text/html; charset=utf-8" );
include("classes/zstore.class.php");
$zstore = new zstore();

if (preg_match('/\.php\//',$_SERVER["REQUEST_URI"])) {
	header("location: " . preg_replace('/\.php\//','.php',$_SERVER["REQUEST_URI"]));
}

$action = isset($_REQUEST["action"]) ? $_REQUEST["action"] : null;
$thisSubPage = $sub2 = null;

$pageTitle = "Tableau de bord ZOABOUTIQUE";
$currentPage = "admin";


$adminScript = $_SERVER["PHP_SELF"];


if (!$zstore->auth) {
	if ($action == "authenticate") {
		$zstore->authenticate($_REQUEST);
	}
} elseif (isset($_REQUEST["logout"])) {
	$zstore->logout();
}

include("admin/header.php");

$breadcrumpDescr = array();

if ($zstore->auth) {

	//var sets
	switch (true) {
		case isset($_REQUEST["config"]):
			$thisSubPage = "config";
			break;
		case isset($_REQUEST["categories"]):
			$thisSubPage = "categories";
			break;
		case isset($_REQUEST["products"]):
			$thisSubPage = "products";
			break;
		case isset($_REQUEST["errorLog"]):
			$thisSubPage = "errorLog";
			break;
		case isset($_REQUEST["languages"]):
			$thisSubPage = "languages";
			break;
		case isset($_REQUEST["manual"]):
			$thisSubPage = "manual";
			break;
		default:
			$thisSubPage = "dashboard";
			break;
	};

	$breadcrumpDescr = array(
		"config" => "<i class='fa fa-fw fa-z'></i> Configuration",
		"categories" => "Catégories de Produits",
		"products" => "Produits/Articles",
		"errorLog" => "Journal des Erreurs",
		"languages" => "Langues/Traduction",
		"manual" => "<i class='fa fa-fw fa-z'></i>Manuel d'utilisation",
		"dashboard" => null,
		);


}

?>

  	<div class="card card-top-line">
		  <div class="card-header">
		  	<div class='container'>
			  	<div class='row'>
			  		<div class='col-12'>
						  <ol class="breadcrumb zstore-breadcrumb">
						  	<?php
						  		if ($breadcrumpDescr[$thisSubPage]) {
								    echo '<li class="breadcrumb-item"><a href="' . $adminScript . '/">Tableau de bord</a></li>';
									  echo '<li class="breadcrumb-item active">' . $breadcrumpDescr[$thisSubPage] . '</li>';
						  		} elseif ($zstore->auth) {
								    echo '<li class="breadcrumb-item active">Administration</li>';
						  		} else {
								    echo '<li class="breadcrumb-item active">Connexion...</li>';
						  		}
						  	?>
						  </ol>
			  		</div>
			  	</div>
			  </div>
		  </div>
		 </div>




    <div class="container mt-20">


<?php


if (!$zstore->auth) {
	include("admin/login.php");
} else {



	$subPageAct[$thisSubPage] = "active";



	echo "<div class='row'>";

	/***********
	 *** sidenav
	 ***********/
	echo "<div class='col-sm-3'>";
	
	echo "<div class='list-group list-group-zstore'>";

	//DASHBOARD
	echo "<a href='$adminScript' class='list-group-item list-group-item-action " . (isset($subPageAct['dashboard']) ? $subPageAct['dashboard'] : "") . "'><i class='fa fa-fw fa-dashboard'></i> Tableau de bord</a>";


	//CONFIG
	echo "<a href='$adminScript?config' class='list-group-item list-group-item-action " . (isset($subPageAct['config']) ? $subPageAct['config'] : "") . "'><i class='fa fa-fw fa-z'></i> Configuration</a>";


	//LANGUAGES
	echo "<a href='$adminScript?languages' class='list-group-item list-group-item-action " . (isset($subPageAct['languages']) ? $subPageAct['languages'] : "") . "'><i class='fa fa-fw fa-language'></i> Langues</a>";

	if (isset($subPageAct['languages'])) {

		$languages = $zstore->getLanguages();

		$sub2 = $manlang = null;
		if (isset($_REQUEST["sub2"])) {
			$sub2 = $_REQUEST["sub2"];
		}

		$sub2PageAct[$sub2] = "active";

		if (isset($_REQUEST['manlang']) || $manlang) {
			$manlang = $manlang ?: $_REQUEST['manlang'];
			$sub2 = "manlang";
		}

		if (!$manlang && !$sub2) {
			$manlang = $languages[0];
		}

		$langNavItemBase = "<a href='$adminScript?languages&amp;manlang=[LANGKEY]' data-lang-key='[LANGKEY]' class='list-group-item list-group-item-action list-group-item-zstore-sub small [CLASS_ACTIVE]'><i class='fa fa-fw fa-globe'></i> <span class='langKeyDescr text-uppercase'>[LANGKEY]</span></a>";

		echo "<div class='language-keys-nav'>";
		foreach ($languages as $langKey) {
			$find = array("[LANGKEY]","[CLASS_ACTIVE]");
			$replace = array($langKey,$manlang == $langKey ? "active" : "");
			echo str_replace($find,$replace,$langNavItemBase);
			// echo "<div data-lang-key='$langKey'><a href='$adminScript?languages&amp;manlang=$langKey' class='list-group-item list-group-item-action list-group-item-zstore-sub small " . ($manlang == $langKey ? "active" : "") . "'><i class='fa fa-fw fa-globe'></i> " . strtoupper($langKey) . "</div></a>";
			// echo $langNavItem = "<a href='$adminScript?languages&amp;manlang=$langKey' data-lang-key='$langKey' class='list-group-item list-group-item-action list-group-item-zstore-sub small " . ($manlang == $langKey ? "active" : "") . "'><i class='fa fa-fw fa-globe'></i> <span class='langKeyDescr'>" . strtoupper($langKey) . "</span></a>";
		}
		echo "</div>";

		echo "<a href='$adminScript?languages&amp;sub2=findOverwrite' class='list-group-item list-group-item-action list-group-item-zstore-sub small " . (isset($sub2PageAct['findOverwrite']) ? $sub2PageAct['findOverwrite'] : "") . "'><i class='fa fa-fw fa-search'></i> Récrire le language</a>";


		echo "<a href='$adminScript?languages&amp;sub2=addLanguage' class='list-group-item list-group-item-action list-group-item-zstore-sub small " . (isset($sub2PageAct['addLanguage']) ? $sub2PageAct['addLanguage'] : "") . " js-btn-add-language'><i class='fa fa-fw fa-plus-square'></i> Ajouter une Langue</a>";
	


		echo "<div class='js-hide hidden-content'>
				<div class='langNavItem'>$langNavItemBase</div>
			</div>";
	}


	//CATEGORIES
	echo "<a href='$adminScript?categories' class='list-group-item list-group-item-action " . (isset($subPageAct['categories']) ? $subPageAct['categories'] : "") . "'><i class='fa fa-fw fa-sitemap'></i> Catégories de Produits</a>";


	//PRODUCTS
	echo "<a href='$adminScript?products' class='list-group-item list-group-item-action " . (isset($subPageAct['products']) ? $subPageAct['products'] : "") . "'><i class='fa fa-fw fa-cubes'></i> Produits/Articles</a>";

	if (isset($subPageAct['products'])) {

		$sub2 = isset($_REQUEST["sub2"]) ? $_REQUEST["sub2"] : "showItems";
		$sub2PageAct[$sub2] = "active";

		echo "<a href='$adminScript?products' class='list-group-item list-group-item-action list-group-item-zstore-sub small " . (isset($sub2PageAct['showItems']) ? $sub2PageAct['showItems'] : "") . "'><i class='fa fa-fw fa-cubes'></i> Produits/Articles</a>
			<a href='$adminScript?products&amp;sub2=multiOps' class='list-group-item list-group-item-action list-group-item-zstore-sub small " . (isset($sub2PageAct['multiOps']) ? $sub2PageAct['multiOps'] : "") . "'><i class='fa fa-fw fa-exchange'></i> Opérations Multi-Produit</a>
			<a href='$adminScript?products&amp;sub2=addASINs' class='list-group-item list-group-item-action list-group-item-zstore-sub small " . (isset($sub2PageAct['addASINs']) ? $sub2PageAct['addASINs'] : "") . "'><i class='fa fa-fw fa-amazon'></i> Importation via ASIN</a>
			<a href='$adminScript?products&amp;sub2=addASIN' class='list-group-item list-group-item-action list-group-item-zstore-sub small " . (isset($sub2PageAct['addASIN']) ? $sub2PageAct['addASIN'] : "") . "'><i class='fa fa-fw fa-amazon'></i> Importation rapide ASIN</a>
			<a href='$adminScript?products&amp;sub2=addTitle' class='list-group-item list-group-item-action list-group-item-zstore-sub small " . (isset($sub2PageAct['addTitle']) ? $sub2PageAct['addTitle'] : "") . "'><i class='fa fa-fw fa-search'></i> Recherches de Titres</a>
			<a href='$adminScript?products&amp;sub2=parseHTML' class='list-group-item list-group-item-action list-group-item-zstore-sub small " . (isset($sub2PageAct['parseHTML']) ? $sub2PageAct['parseHTML'] : "") . "'><i class='fa fa-fw fa-code'></i> Percer ASIN via le code HTML</a>
			<a href='$adminScript?products&amp;sub2=grabNow' class='list-group-item list-group-item-action list-group-item-zstore-sub small " . (isset($sub2PageAct['grabNow']) ? $sub2PageAct['grabNow'] : "") . "'><i class='fa fa-fw fa-bolt'></i> Collecter les infos via Amazon </a>
			";
	}


	//ERRORLOG
	echo "<a href='$adminScript?errorLog' class='list-group-item list-group-item-action " . (isset($subPageAct['errorLog']) ? $subPageAct['errorLog'] : "") . "'><i class='fa fa-fw fa-exclamation-triangle'></i> Journal des Erreurs</a>";


	//MANUAL
	echo "<a href='$adminScript?manual' class='list-group-item list-group-item-action " . (isset($subPageAct['manual']) ? $subPageAct['manual'] : "") . "'><i class='fa fa-fw fa-z'></i> Manuel d'utilisation</a>";

	if (isset($subPageAct['manual'])) {

		$sub2 = isset($_REQUEST["sub2"]) ? $_REQUEST["sub2"] : null;
		$sub2PageAct[$sub2] = "active";

		echo "<a href='$adminScript?manual&amp;sub2=requirements' class='list-group-item list-group-item-action list-group-item-zstore-sub small " . (isset($sub2PageAct['requirements']) ? $sub2PageAct['requirements'] : "") . "'><i class='fa fa-fw fa-angle-right'></i> Exigences du serveur</a>";
		echo "<a href='$adminScript?manual&amp;sub2=installation' class='list-group-item list-group-item-action list-group-item-zstore-sub small " . (isset($sub2PageAct['installation']) ? $sub2PageAct['installation'] : "") . "'><i class='fa fa-fw fa-angle-right'></i> Installation</a>";
		echo "<a href='$adminScript?manual&amp;sub2=variations' class='list-group-item list-group-item-action list-group-item-zstore-sub small " . (isset($sub2PageAct['variations']) ? $sub2PageAct['variations'] : "") . "'><i class='fa fa-fw fa-angle-right'></i> Variations des Produits</a>";
		echo "<a href='$adminScript?manual&amp;sub2=amazon' class='list-group-item list-group-item-action list-group-item-zstore-sub small " . (isset($sub2PageAct['amazon']) ? $sub2PageAct['amazon'] : "") . "'><i class='fa fa-fw fa-angle-right'></i> Partenaire Amazon</a>";
		echo "<a href='$adminScript?manual&amp;sub2=languages' class='list-group-item list-group-item-action list-group-item-zstore-sub small " . (isset($sub2PageAct['languages']) ? $sub2PageAct['languages'] : "") . "'><i class='fa fa-fw fa-angle-right'></i> Languages</a>";
		echo "<a href='$adminScript?manual&amp;sub2=layouts' class='list-group-item list-group-item-action list-group-item-zstore-sub small " . (isset($sub2PageAct['layouts']) ? $sub2PageAct['layouts'] : "") . "'><i class='fa fa-fw fa-angle-right'></i> Les Modèles</a>";
		echo "<a href='$adminScript?manual&amp;sub2=cron' class='list-group-item list-group-item-action list-group-item-zstore-sub small " . (isset($sub2PageAct['cron']) ? $sub2PageAct['cron'] : "") . "'><i class='fa fa-fw fa-angle-right'></i> Tâches Cron</a>";
		echo "<a href='$adminScript?manual&amp;sub2=jscss' class='list-group-item list-group-item-action list-group-item-zstore-sub small " . (isset($sub2PageAct['jscss']) ? $sub2PageAct['jscss'] : "") . "'><i class='fa fa-fw fa-angle-right'></i> Produits Numériques</a>";
		echo "<a href='$adminScript?manual&amp;sub2=credits' class='list-group-item list-group-item-action list-group-item-zstore-sub small " . (isset($sub2PageAct['credits']) ? $sub2PageAct['credits'] : "") . "'><i class='fa fa-fw fa-angle-right'></i> Monétisation</a>";
		echo "<a href='$adminScript?manual&amp;sub2=changelog' class='list-group-item list-group-item-action list-group-item-zstore-sub small " . (isset($sub2PageAct['changelog']) ? $sub2PageAct['changelog'] : "") . "'><i class='fa fa-fw fa-angle-right'></i> ZOA ULTRA</a>";
	}

	echo "<a href='$adminScript?logout' class='list-group-item list-group-item-action'><i class='fa fa-power-off fa-fw'></i> Déconnexion</a>
	</div>";


	echo "</div>"; //col-sm-3

	echo "<div class='col-sm-9'>";

	switch ($thisSubPage) {
		case 'config':
			include("admin/config.php");
			break;
		case 'categories':
			include("admin/categories.php");
			break;
		case 'products':
			include("admin/products.php");
			break;
		case 'errorLog':
			include("admin/errorLog.php");
			break;
		case 'languages':
			include("admin/languages.php");
			break;
		case 'manual':
			include("admin/manual.php");
			break;
		default:
			include("admin/dashboard.php");
			break;
	}

	echo "</div>";



	echo "</div>"; //row

}
	echo "</div>"; //container
?>







<?php include("admin/footer.php"); ?>